/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
'use strict';

const _commonjsHelpers = require('./_commonjsHelpers-6d73bb9b.js');
const wrappers_pb = require('./wrappers_pb-f76eff58.js');

var paging_pb = _commonjsHelpers.createCommonjsModule(function (module, exports) {
/**
 * @fileoverview
 * @enhanceable
 * @suppress {messageConventions} JS Compiler reports an error if a variable or
 *     field starts with 'MSG_' and isn't a translatable message.
 * @public
 */
// GENERATED CODE -- DO NOT EDIT!


var goog = wrappers_pb.googleProtobuf;
var global = Function('return this')();

goog.exportSymbol('proto.vertexvis.protobuf.core.Cursor', null, global);
goog.exportSymbol('proto.vertexvis.protobuf.core.OffsetCursor', null, global);
goog.exportSymbol('proto.vertexvis.protobuf.core.OffsetPager', null, global);
goog.exportSymbol('proto.vertexvis.protobuf.core.Pager', null, global);

/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.vertexvis.protobuf.core.Pager = function(opt_data) {
  wrappers_pb.googleProtobuf.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.vertexvis.protobuf.core.Pager, wrappers_pb.googleProtobuf.Message);
if (goog.DEBUG && !COMPILED) {
  proto.vertexvis.protobuf.core.Pager.displayName = 'proto.vertexvis.protobuf.core.Pager';
}


if (wrappers_pb.googleProtobuf.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto suitable for use in Soy templates.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     com.google.apps.jspb.JsClassTemplate.JS_RESERVED_WORDS.
 * @param {boolean=} opt_includeInstance Whether to include the JSPB instance
 *     for transitional soy proto support: http://goto/soy-param-migration
 * @return {!Object}
 */
proto.vertexvis.protobuf.core.Pager.prototype.toObject = function(opt_includeInstance) {
  return proto.vertexvis.protobuf.core.Pager.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Whether to include the JSPB
 *     instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.vertexvis.protobuf.core.Pager} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.core.Pager.toObject = function(includeInstance, msg) {
  var obj = {
    limit: wrappers_pb.googleProtobuf.Message.getFieldWithDefault(msg, 1, 0),
    cursor: wrappers_pb.googleProtobuf.Message.getFieldWithDefault(msg, 2, "")
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.vertexvis.protobuf.core.Pager}
 */
proto.vertexvis.protobuf.core.Pager.deserializeBinary = function(bytes) {
  var reader = new wrappers_pb.googleProtobuf.BinaryReader(bytes);
  var msg = new proto.vertexvis.protobuf.core.Pager;
  return proto.vertexvis.protobuf.core.Pager.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.vertexvis.protobuf.core.Pager} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.vertexvis.protobuf.core.Pager}
 */
proto.vertexvis.protobuf.core.Pager.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = /** @type {number} */ (reader.readUint32());
      msg.setLimit(value);
      break;
    case 2:
      var value = /** @type {string} */ (reader.readString());
      msg.setCursor(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.vertexvis.protobuf.core.Pager.prototype.serializeBinary = function() {
  var writer = new wrappers_pb.googleProtobuf.BinaryWriter();
  proto.vertexvis.protobuf.core.Pager.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.vertexvis.protobuf.core.Pager} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.core.Pager.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getLimit();
  if (f !== 0) {
    writer.writeUint32(
      1,
      f
    );
  }
  f = message.getCursor();
  if (f.length > 0) {
    writer.writeString(
      2,
      f
    );
  }
};


/**
 * optional uint32 limit = 1;
 * @return {number}
 */
proto.vertexvis.protobuf.core.Pager.prototype.getLimit = function() {
  return /** @type {number} */ (wrappers_pb.googleProtobuf.Message.getFieldWithDefault(this, 1, 0));
};


/** @param {number} value */
proto.vertexvis.protobuf.core.Pager.prototype.setLimit = function(value) {
  wrappers_pb.googleProtobuf.Message.setProto3IntField(this, 1, value);
};


/**
 * optional string cursor = 2;
 * @return {string}
 */
proto.vertexvis.protobuf.core.Pager.prototype.getCursor = function() {
  return /** @type {string} */ (wrappers_pb.googleProtobuf.Message.getFieldWithDefault(this, 2, ""));
};


/** @param {string} value */
proto.vertexvis.protobuf.core.Pager.prototype.setCursor = function(value) {
  wrappers_pb.googleProtobuf.Message.setProto3StringField(this, 2, value);
};



/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.vertexvis.protobuf.core.OffsetPager = function(opt_data) {
  wrappers_pb.googleProtobuf.Message.initialize(this, opt_data, 0, -1, null, proto.vertexvis.protobuf.core.OffsetPager.oneofGroups_);
};
goog.inherits(proto.vertexvis.protobuf.core.OffsetPager, wrappers_pb.googleProtobuf.Message);
if (goog.DEBUG && !COMPILED) {
  proto.vertexvis.protobuf.core.OffsetPager.displayName = 'proto.vertexvis.protobuf.core.OffsetPager';
}
/**
 * Oneof group definitions for this message. Each group defines the field
 * numbers belonging to that group. When of these fields' value is set, all
 * other fields in the group are cleared. During deserialization, if multiple
 * fields are encountered for a group, only the last value seen will be kept.
 * @private {!Array<!Array<number>>}
 * @const
 */
proto.vertexvis.protobuf.core.OffsetPager.oneofGroups_ = [[2,3]];

/**
 * @enum {number}
 */
proto.vertexvis.protobuf.core.OffsetPager.PagerCase = {
  PAGER_NOT_SET: 0,
  CURSOR: 2,
  OFFSET: 3
};

/**
 * @return {proto.vertexvis.protobuf.core.OffsetPager.PagerCase}
 */
proto.vertexvis.protobuf.core.OffsetPager.prototype.getPagerCase = function() {
  return /** @type {proto.vertexvis.protobuf.core.OffsetPager.PagerCase} */(wrappers_pb.googleProtobuf.Message.computeOneofCase(this, proto.vertexvis.protobuf.core.OffsetPager.oneofGroups_[0]));
};



if (wrappers_pb.googleProtobuf.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto suitable for use in Soy templates.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     com.google.apps.jspb.JsClassTemplate.JS_RESERVED_WORDS.
 * @param {boolean=} opt_includeInstance Whether to include the JSPB instance
 *     for transitional soy proto support: http://goto/soy-param-migration
 * @return {!Object}
 */
proto.vertexvis.protobuf.core.OffsetPager.prototype.toObject = function(opt_includeInstance) {
  return proto.vertexvis.protobuf.core.OffsetPager.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Whether to include the JSPB
 *     instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.vertexvis.protobuf.core.OffsetPager} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.core.OffsetPager.toObject = function(includeInstance, msg) {
  var obj = {
    limit: wrappers_pb.googleProtobuf.Message.getFieldWithDefault(msg, 1, 0),
    cursor: wrappers_pb.googleProtobuf.Message.getFieldWithDefault(msg, 2, ""),
    offset: wrappers_pb.googleProtobuf.Message.getFieldWithDefault(msg, 3, 0)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.vertexvis.protobuf.core.OffsetPager}
 */
proto.vertexvis.protobuf.core.OffsetPager.deserializeBinary = function(bytes) {
  var reader = new wrappers_pb.googleProtobuf.BinaryReader(bytes);
  var msg = new proto.vertexvis.protobuf.core.OffsetPager;
  return proto.vertexvis.protobuf.core.OffsetPager.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.vertexvis.protobuf.core.OffsetPager} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.vertexvis.protobuf.core.OffsetPager}
 */
proto.vertexvis.protobuf.core.OffsetPager.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = /** @type {number} */ (reader.readUint32());
      msg.setLimit(value);
      break;
    case 2:
      var value = /** @type {string} */ (reader.readString());
      msg.setCursor(value);
      break;
    case 3:
      var value = /** @type {number} */ (reader.readUint32());
      msg.setOffset(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.vertexvis.protobuf.core.OffsetPager.prototype.serializeBinary = function() {
  var writer = new wrappers_pb.googleProtobuf.BinaryWriter();
  proto.vertexvis.protobuf.core.OffsetPager.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.vertexvis.protobuf.core.OffsetPager} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.core.OffsetPager.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getLimit();
  if (f !== 0) {
    writer.writeUint32(
      1,
      f
    );
  }
  f = /** @type {string} */ (wrappers_pb.googleProtobuf.Message.getField(message, 2));
  if (f != null) {
    writer.writeString(
      2,
      f
    );
  }
  f = /** @type {number} */ (wrappers_pb.googleProtobuf.Message.getField(message, 3));
  if (f != null) {
    writer.writeUint32(
      3,
      f
    );
  }
};


/**
 * optional uint32 limit = 1;
 * @return {number}
 */
proto.vertexvis.protobuf.core.OffsetPager.prototype.getLimit = function() {
  return /** @type {number} */ (wrappers_pb.googleProtobuf.Message.getFieldWithDefault(this, 1, 0));
};


/** @param {number} value */
proto.vertexvis.protobuf.core.OffsetPager.prototype.setLimit = function(value) {
  wrappers_pb.googleProtobuf.Message.setProto3IntField(this, 1, value);
};


/**
 * optional string cursor = 2;
 * @return {string}
 */
proto.vertexvis.protobuf.core.OffsetPager.prototype.getCursor = function() {
  return /** @type {string} */ (wrappers_pb.googleProtobuf.Message.getFieldWithDefault(this, 2, ""));
};


/** @param {string} value */
proto.vertexvis.protobuf.core.OffsetPager.prototype.setCursor = function(value) {
  wrappers_pb.googleProtobuf.Message.setOneofField(this, 2, proto.vertexvis.protobuf.core.OffsetPager.oneofGroups_[0], value);
};


proto.vertexvis.protobuf.core.OffsetPager.prototype.clearCursor = function() {
  wrappers_pb.googleProtobuf.Message.setOneofField(this, 2, proto.vertexvis.protobuf.core.OffsetPager.oneofGroups_[0], undefined);
};


/**
 * Returns whether this field is set.
 * @return {!boolean}
 */
proto.vertexvis.protobuf.core.OffsetPager.prototype.hasCursor = function() {
  return wrappers_pb.googleProtobuf.Message.getField(this, 2) != null;
};


/**
 * optional uint32 offset = 3;
 * @return {number}
 */
proto.vertexvis.protobuf.core.OffsetPager.prototype.getOffset = function() {
  return /** @type {number} */ (wrappers_pb.googleProtobuf.Message.getFieldWithDefault(this, 3, 0));
};


/** @param {number} value */
proto.vertexvis.protobuf.core.OffsetPager.prototype.setOffset = function(value) {
  wrappers_pb.googleProtobuf.Message.setOneofField(this, 3, proto.vertexvis.protobuf.core.OffsetPager.oneofGroups_[0], value);
};


proto.vertexvis.protobuf.core.OffsetPager.prototype.clearOffset = function() {
  wrappers_pb.googleProtobuf.Message.setOneofField(this, 3, proto.vertexvis.protobuf.core.OffsetPager.oneofGroups_[0], undefined);
};


/**
 * Returns whether this field is set.
 * @return {!boolean}
 */
proto.vertexvis.protobuf.core.OffsetPager.prototype.hasOffset = function() {
  return wrappers_pb.googleProtobuf.Message.getField(this, 3) != null;
};



/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.vertexvis.protobuf.core.Cursor = function(opt_data) {
  wrappers_pb.googleProtobuf.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.vertexvis.protobuf.core.Cursor, wrappers_pb.googleProtobuf.Message);
if (goog.DEBUG && !COMPILED) {
  proto.vertexvis.protobuf.core.Cursor.displayName = 'proto.vertexvis.protobuf.core.Cursor';
}


if (wrappers_pb.googleProtobuf.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto suitable for use in Soy templates.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     com.google.apps.jspb.JsClassTemplate.JS_RESERVED_WORDS.
 * @param {boolean=} opt_includeInstance Whether to include the JSPB instance
 *     for transitional soy proto support: http://goto/soy-param-migration
 * @return {!Object}
 */
proto.vertexvis.protobuf.core.Cursor.prototype.toObject = function(opt_includeInstance) {
  return proto.vertexvis.protobuf.core.Cursor.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Whether to include the JSPB
 *     instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.vertexvis.protobuf.core.Cursor} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.core.Cursor.toObject = function(includeInstance, msg) {
  var obj = {
    next: wrappers_pb.googleProtobuf.Message.getFieldWithDefault(msg, 1, "")
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.vertexvis.protobuf.core.Cursor}
 */
proto.vertexvis.protobuf.core.Cursor.deserializeBinary = function(bytes) {
  var reader = new wrappers_pb.googleProtobuf.BinaryReader(bytes);
  var msg = new proto.vertexvis.protobuf.core.Cursor;
  return proto.vertexvis.protobuf.core.Cursor.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.vertexvis.protobuf.core.Cursor} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.vertexvis.protobuf.core.Cursor}
 */
proto.vertexvis.protobuf.core.Cursor.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = /** @type {string} */ (reader.readString());
      msg.setNext(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.vertexvis.protobuf.core.Cursor.prototype.serializeBinary = function() {
  var writer = new wrappers_pb.googleProtobuf.BinaryWriter();
  proto.vertexvis.protobuf.core.Cursor.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.vertexvis.protobuf.core.Cursor} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.core.Cursor.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getNext();
  if (f.length > 0) {
    writer.writeString(
      1,
      f
    );
  }
};


/**
 * optional string next = 1;
 * @return {string}
 */
proto.vertexvis.protobuf.core.Cursor.prototype.getNext = function() {
  return /** @type {string} */ (wrappers_pb.googleProtobuf.Message.getFieldWithDefault(this, 1, ""));
};


/** @param {string} value */
proto.vertexvis.protobuf.core.Cursor.prototype.setNext = function(value) {
  wrappers_pb.googleProtobuf.Message.setProto3StringField(this, 1, value);
};



/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.vertexvis.protobuf.core.OffsetCursor = function(opt_data) {
  wrappers_pb.googleProtobuf.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.vertexvis.protobuf.core.OffsetCursor, wrappers_pb.googleProtobuf.Message);
if (goog.DEBUG && !COMPILED) {
  proto.vertexvis.protobuf.core.OffsetCursor.displayName = 'proto.vertexvis.protobuf.core.OffsetCursor';
}


if (wrappers_pb.googleProtobuf.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto suitable for use in Soy templates.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     com.google.apps.jspb.JsClassTemplate.JS_RESERVED_WORDS.
 * @param {boolean=} opt_includeInstance Whether to include the JSPB instance
 *     for transitional soy proto support: http://goto/soy-param-migration
 * @return {!Object}
 */
proto.vertexvis.protobuf.core.OffsetCursor.prototype.toObject = function(opt_includeInstance) {
  return proto.vertexvis.protobuf.core.OffsetCursor.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Whether to include the JSPB
 *     instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.vertexvis.protobuf.core.OffsetCursor} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.core.OffsetCursor.toObject = function(includeInstance, msg) {
  var obj = {
    total: wrappers_pb.googleProtobuf.Message.getFieldWithDefault(msg, 1, 0),
    next: wrappers_pb.googleProtobuf.Message.getFieldWithDefault(msg, 2, "")
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.vertexvis.protobuf.core.OffsetCursor}
 */
proto.vertexvis.protobuf.core.OffsetCursor.deserializeBinary = function(bytes) {
  var reader = new wrappers_pb.googleProtobuf.BinaryReader(bytes);
  var msg = new proto.vertexvis.protobuf.core.OffsetCursor;
  return proto.vertexvis.protobuf.core.OffsetCursor.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.vertexvis.protobuf.core.OffsetCursor} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.vertexvis.protobuf.core.OffsetCursor}
 */
proto.vertexvis.protobuf.core.OffsetCursor.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = /** @type {number} */ (reader.readUint32());
      msg.setTotal(value);
      break;
    case 2:
      var value = /** @type {string} */ (reader.readString());
      msg.setNext(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.vertexvis.protobuf.core.OffsetCursor.prototype.serializeBinary = function() {
  var writer = new wrappers_pb.googleProtobuf.BinaryWriter();
  proto.vertexvis.protobuf.core.OffsetCursor.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.vertexvis.protobuf.core.OffsetCursor} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.core.OffsetCursor.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getTotal();
  if (f !== 0) {
    writer.writeUint32(
      1,
      f
    );
  }
  f = message.getNext();
  if (f.length > 0) {
    writer.writeString(
      2,
      f
    );
  }
};


/**
 * optional uint32 total = 1;
 * @return {number}
 */
proto.vertexvis.protobuf.core.OffsetCursor.prototype.getTotal = function() {
  return /** @type {number} */ (wrappers_pb.googleProtobuf.Message.getFieldWithDefault(this, 1, 0));
};


/** @param {number} value */
proto.vertexvis.protobuf.core.OffsetCursor.prototype.setTotal = function(value) {
  wrappers_pb.googleProtobuf.Message.setProto3IntField(this, 1, value);
};


/**
 * optional string next = 2;
 * @return {string}
 */
proto.vertexvis.protobuf.core.OffsetCursor.prototype.getNext = function() {
  return /** @type {string} */ (wrappers_pb.googleProtobuf.Message.getFieldWithDefault(this, 2, ""));
};


/** @param {string} value */
proto.vertexvis.protobuf.core.OffsetCursor.prototype.setNext = function(value) {
  wrappers_pb.googleProtobuf.Message.setProto3StringField(this, 2, value);
};


goog.object.extend(exports, proto.vertexvis.protobuf.core);
});

var uuid_pb = _commonjsHelpers.createCommonjsModule(function (module, exports) {
/**
 * @fileoverview
 * @enhanceable
 * @suppress {messageConventions} JS Compiler reports an error if a variable or
 *     field starts with 'MSG_' and isn't a translatable message.
 * @public
 */
// GENERATED CODE -- DO NOT EDIT!


var goog = wrappers_pb.googleProtobuf;
var global = Function('return this')();

goog.exportSymbol('proto.vertexvis.protobuf.core.Uuid', null, global);
goog.exportSymbol('proto.vertexvis.protobuf.core.Uuid2l', null, global);
goog.exportSymbol('proto.vertexvis.protobuf.core.UuidArray', null, global);

/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.vertexvis.protobuf.core.Uuid = function(opt_data) {
  wrappers_pb.googleProtobuf.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.vertexvis.protobuf.core.Uuid, wrappers_pb.googleProtobuf.Message);
if (goog.DEBUG && !COMPILED) {
  proto.vertexvis.protobuf.core.Uuid.displayName = 'proto.vertexvis.protobuf.core.Uuid';
}


if (wrappers_pb.googleProtobuf.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto suitable for use in Soy templates.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     com.google.apps.jspb.JsClassTemplate.JS_RESERVED_WORDS.
 * @param {boolean=} opt_includeInstance Whether to include the JSPB instance
 *     for transitional soy proto support: http://goto/soy-param-migration
 * @return {!Object}
 */
proto.vertexvis.protobuf.core.Uuid.prototype.toObject = function(opt_includeInstance) {
  return proto.vertexvis.protobuf.core.Uuid.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Whether to include the JSPB
 *     instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.vertexvis.protobuf.core.Uuid} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.core.Uuid.toObject = function(includeInstance, msg) {
  var obj = {
    hex: wrappers_pb.googleProtobuf.Message.getFieldWithDefault(msg, 1, "")
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.vertexvis.protobuf.core.Uuid}
 */
proto.vertexvis.protobuf.core.Uuid.deserializeBinary = function(bytes) {
  var reader = new wrappers_pb.googleProtobuf.BinaryReader(bytes);
  var msg = new proto.vertexvis.protobuf.core.Uuid;
  return proto.vertexvis.protobuf.core.Uuid.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.vertexvis.protobuf.core.Uuid} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.vertexvis.protobuf.core.Uuid}
 */
proto.vertexvis.protobuf.core.Uuid.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = /** @type {string} */ (reader.readString());
      msg.setHex(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.vertexvis.protobuf.core.Uuid.prototype.serializeBinary = function() {
  var writer = new wrappers_pb.googleProtobuf.BinaryWriter();
  proto.vertexvis.protobuf.core.Uuid.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.vertexvis.protobuf.core.Uuid} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.core.Uuid.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getHex();
  if (f.length > 0) {
    writer.writeString(
      1,
      f
    );
  }
};


/**
 * optional string hex = 1;
 * @return {string}
 */
proto.vertexvis.protobuf.core.Uuid.prototype.getHex = function() {
  return /** @type {string} */ (wrappers_pb.googleProtobuf.Message.getFieldWithDefault(this, 1, ""));
};


/** @param {string} value */
proto.vertexvis.protobuf.core.Uuid.prototype.setHex = function(value) {
  wrappers_pb.googleProtobuf.Message.setProto3StringField(this, 1, value);
};



/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.vertexvis.protobuf.core.Uuid2l = function(opt_data) {
  wrappers_pb.googleProtobuf.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.vertexvis.protobuf.core.Uuid2l, wrappers_pb.googleProtobuf.Message);
if (goog.DEBUG && !COMPILED) {
  proto.vertexvis.protobuf.core.Uuid2l.displayName = 'proto.vertexvis.protobuf.core.Uuid2l';
}


if (wrappers_pb.googleProtobuf.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto suitable for use in Soy templates.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     com.google.apps.jspb.JsClassTemplate.JS_RESERVED_WORDS.
 * @param {boolean=} opt_includeInstance Whether to include the JSPB instance
 *     for transitional soy proto support: http://goto/soy-param-migration
 * @return {!Object}
 */
proto.vertexvis.protobuf.core.Uuid2l.prototype.toObject = function(opt_includeInstance) {
  return proto.vertexvis.protobuf.core.Uuid2l.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Whether to include the JSPB
 *     instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.vertexvis.protobuf.core.Uuid2l} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.core.Uuid2l.toObject = function(includeInstance, msg) {
  var obj = {
    msb: wrappers_pb.googleProtobuf.Message.getFieldWithDefault(msg, 1, "0"),
    lsb: wrappers_pb.googleProtobuf.Message.getFieldWithDefault(msg, 2, "0")
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.vertexvis.protobuf.core.Uuid2l}
 */
proto.vertexvis.protobuf.core.Uuid2l.deserializeBinary = function(bytes) {
  var reader = new wrappers_pb.googleProtobuf.BinaryReader(bytes);
  var msg = new proto.vertexvis.protobuf.core.Uuid2l;
  return proto.vertexvis.protobuf.core.Uuid2l.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.vertexvis.protobuf.core.Uuid2l} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.vertexvis.protobuf.core.Uuid2l}
 */
proto.vertexvis.protobuf.core.Uuid2l.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = /** @type {string} */ (reader.readSfixed64String());
      msg.setMsb(value);
      break;
    case 2:
      var value = /** @type {string} */ (reader.readSfixed64String());
      msg.setLsb(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.vertexvis.protobuf.core.Uuid2l.prototype.serializeBinary = function() {
  var writer = new wrappers_pb.googleProtobuf.BinaryWriter();
  proto.vertexvis.protobuf.core.Uuid2l.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.vertexvis.protobuf.core.Uuid2l} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.core.Uuid2l.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getMsb();
  if (parseInt(f, 10) !== 0) {
    writer.writeSfixed64String(
      1,
      f
    );
  }
  f = message.getLsb();
  if (parseInt(f, 10) !== 0) {
    writer.writeSfixed64String(
      2,
      f
    );
  }
};


/**
 * optional sfixed64 msb = 1;
 * @return {string}
 */
proto.vertexvis.protobuf.core.Uuid2l.prototype.getMsb = function() {
  return /** @type {string} */ (wrappers_pb.googleProtobuf.Message.getFieldWithDefault(this, 1, "0"));
};


/** @param {string} value */
proto.vertexvis.protobuf.core.Uuid2l.prototype.setMsb = function(value) {
  wrappers_pb.googleProtobuf.Message.setProto3StringIntField(this, 1, value);
};


/**
 * optional sfixed64 lsb = 2;
 * @return {string}
 */
proto.vertexvis.protobuf.core.Uuid2l.prototype.getLsb = function() {
  return /** @type {string} */ (wrappers_pb.googleProtobuf.Message.getFieldWithDefault(this, 2, "0"));
};


/** @param {string} value */
proto.vertexvis.protobuf.core.Uuid2l.prototype.setLsb = function(value) {
  wrappers_pb.googleProtobuf.Message.setProto3StringIntField(this, 2, value);
};



/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.vertexvis.protobuf.core.UuidArray = function(opt_data) {
  wrappers_pb.googleProtobuf.Message.initialize(this, opt_data, 0, -1, proto.vertexvis.protobuf.core.UuidArray.repeatedFields_, null);
};
goog.inherits(proto.vertexvis.protobuf.core.UuidArray, wrappers_pb.googleProtobuf.Message);
if (goog.DEBUG && !COMPILED) {
  proto.vertexvis.protobuf.core.UuidArray.displayName = 'proto.vertexvis.protobuf.core.UuidArray';
}
/**
 * List of repeated fields within this message type.
 * @private {!Array<number>}
 * @const
 */
proto.vertexvis.protobuf.core.UuidArray.repeatedFields_ = [1,2];



if (wrappers_pb.googleProtobuf.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto suitable for use in Soy templates.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     com.google.apps.jspb.JsClassTemplate.JS_RESERVED_WORDS.
 * @param {boolean=} opt_includeInstance Whether to include the JSPB instance
 *     for transitional soy proto support: http://goto/soy-param-migration
 * @return {!Object}
 */
proto.vertexvis.protobuf.core.UuidArray.prototype.toObject = function(opt_includeInstance) {
  return proto.vertexvis.protobuf.core.UuidArray.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Whether to include the JSPB
 *     instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.vertexvis.protobuf.core.UuidArray} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.core.UuidArray.toObject = function(includeInstance, msg) {
  var obj = {
    msbsList: wrappers_pb.googleProtobuf.Message.getRepeatedField(msg, 1),
    lsbsList: wrappers_pb.googleProtobuf.Message.getRepeatedField(msg, 2)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.vertexvis.protobuf.core.UuidArray}
 */
proto.vertexvis.protobuf.core.UuidArray.deserializeBinary = function(bytes) {
  var reader = new wrappers_pb.googleProtobuf.BinaryReader(bytes);
  var msg = new proto.vertexvis.protobuf.core.UuidArray;
  return proto.vertexvis.protobuf.core.UuidArray.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.vertexvis.protobuf.core.UuidArray} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.vertexvis.protobuf.core.UuidArray}
 */
proto.vertexvis.protobuf.core.UuidArray.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = /** @type {!Array<string>} */ (reader.readPackedSfixed64String());
      msg.setMsbsList(value);
      break;
    case 2:
      var value = /** @type {!Array<string>} */ (reader.readPackedSfixed64String());
      msg.setLsbsList(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.vertexvis.protobuf.core.UuidArray.prototype.serializeBinary = function() {
  var writer = new wrappers_pb.googleProtobuf.BinaryWriter();
  proto.vertexvis.protobuf.core.UuidArray.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.vertexvis.protobuf.core.UuidArray} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.core.UuidArray.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getMsbsList();
  if (f.length > 0) {
    writer.writePackedSfixed64String(
      1,
      f
    );
  }
  f = message.getLsbsList();
  if (f.length > 0) {
    writer.writePackedSfixed64String(
      2,
      f
    );
  }
};


/**
 * repeated sfixed64 msbs = 1;
 * @return {!Array<string>}
 */
proto.vertexvis.protobuf.core.UuidArray.prototype.getMsbsList = function() {
  return /** @type {!Array<string>} */ (wrappers_pb.googleProtobuf.Message.getRepeatedField(this, 1));
};


/** @param {!Array<string>} value */
proto.vertexvis.protobuf.core.UuidArray.prototype.setMsbsList = function(value) {
  wrappers_pb.googleProtobuf.Message.setField(this, 1, value || []);
};


/**
 * @param {!string} value
 * @param {number=} opt_index
 */
proto.vertexvis.protobuf.core.UuidArray.prototype.addMsbs = function(value, opt_index) {
  wrappers_pb.googleProtobuf.Message.addToRepeatedField(this, 1, value, opt_index);
};


proto.vertexvis.protobuf.core.UuidArray.prototype.clearMsbsList = function() {
  this.setMsbsList([]);
};


/**
 * repeated sfixed64 lsbs = 2;
 * @return {!Array<string>}
 */
proto.vertexvis.protobuf.core.UuidArray.prototype.getLsbsList = function() {
  return /** @type {!Array<string>} */ (wrappers_pb.googleProtobuf.Message.getRepeatedField(this, 2));
};


/** @param {!Array<string>} value */
proto.vertexvis.protobuf.core.UuidArray.prototype.setLsbsList = function(value) {
  wrappers_pb.googleProtobuf.Message.setField(this, 2, value || []);
};


/**
 * @param {!string} value
 * @param {number=} opt_index
 */
proto.vertexvis.protobuf.core.UuidArray.prototype.addLsbs = function(value, opt_index) {
  wrappers_pb.googleProtobuf.Message.addToRepeatedField(this, 2, value, opt_index);
};


proto.vertexvis.protobuf.core.UuidArray.prototype.clearLsbsList = function() {
  this.setLsbsList([]);
};


goog.object.extend(exports, proto.vertexvis.protobuf.core);
});

class CustomError extends Error {
  constructor(message, e) {
    super();
    this.message = message;
    this.stack = e === null || e === void 0 ? void 0 : e.stack;
    this.name = this.constructor.name;
    // Allows for `instanceof` checks.
    Object.setPrototypeOf(this, CustomError.prototype);
  }
}
class InvalidResourceUrnError extends CustomError {
  constructor(message, e) {
    super(message, e);
    // Allows for `instanceof` checks.
    Object.setPrototypeOf(this, InvalidResourceUrnError.prototype);
  }
}
class ViewerInitializationError extends CustomError {
  constructor(message, e) {
    super(message, e);
    // Allows for `instanceof` checks.
    Object.setPrototypeOf(this, ViewerInitializationError.prototype);
  }
}
class ComponentInitializationError extends CustomError {
  constructor(message, e) {
    super(message, e);
    // Allows for `instanceof` checks.
    Object.setPrototypeOf(this, ComponentInitializationError.prototype);
  }
}
class SceneRenderError extends CustomError {
  constructor(message, e) {
    super(message, e);
    // Allows for `instanceof` checks.
    Object.setPrototypeOf(this, SceneRenderError.prototype);
  }
}
class WebsocketConnectionError extends CustomError {
  constructor(message, e) {
    super(message, e);
    // Allows for `instanceof` checks.
    Object.setPrototypeOf(this, WebsocketConnectionError.prototype);
  }
}
class InteractionHandlerError extends CustomError {
  constructor(message, e) {
    super(message, e);
    // Allows for `instanceof` checks.
    Object.setPrototypeOf(this, InteractionHandlerError.prototype);
  }
}
class ImageLoadError extends CustomError {
  constructor(message, e) {
    super(message, e);
    // Allows for `instanceof` checks.
    Object.setPrototypeOf(this, ImageLoadError.prototype);
  }
}
class InvalidArgumentError extends CustomError {
  constructor(message, e) {
    super(message, e);
    // Allows for `instanceof` checks.
    Object.setPrototypeOf(this, InvalidArgumentError.prototype);
  }
}
class InvalidCameraError extends CustomError {
  constructor(message, e) {
    super(message, e);
    // Allows for `instanceof` checks.
    Object.setPrototypeOf(this, InvalidCameraError.prototype);
  }
}

exports.ComponentInitializationError = ComponentInitializationError;
exports.CustomError = CustomError;
exports.ImageLoadError = ImageLoadError;
exports.InteractionHandlerError = InteractionHandlerError;
exports.InvalidArgumentError = InvalidArgumentError;
exports.InvalidCameraError = InvalidCameraError;
exports.InvalidResourceUrnError = InvalidResourceUrnError;
exports.SceneRenderError = SceneRenderError;
exports.ViewerInitializationError = ViewerInitializationError;
exports.WebsocketConnectionError = WebsocketConnectionError;
exports.paging_pb = paging_pb;
exports.uuid_pb = uuid_pb;

//# sourceMappingURL=errors-959312c1.js.map