/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
'use strict';

const browser_esm = require('./browser.esm-91aa64b8.js');
const streamAttributes = require('./streamAttributes-8c3c3d8a.js');

const mapModelView = browser_esm.mapper.defineMapper(browser_esm.mapper.read(browser_esm.mapper.mapRequiredProp('id', streamAttributes.fromPbUuid2l), browser_esm.mapper.getProp('displayName'), browser_esm.mapper.mapRequiredProp('partRevisionId', streamAttributes.fromPbUuid2l)), ([id, displayName, partRevisionId]) => ({
  id,
  displayName,
  partRevisionId,
}));
const mapListItemModelViewsResponse = browser_esm.mapper.defineMapper(browser_esm.mapper.read(browser_esm.mapper.mapProp('modelViewsList', browser_esm.mapper.mapArray(mapModelView)), browser_esm.mapper.mapProp('nextPageCursor', streamAttributes.mapCursor)), ([modelViews, next]) => ({ modelViews, paging: { next } }));
const mapListItemModelViewsResponseOrThrow = browser_esm.mapper.ifInvalidThrow(mapListItemModelViewsResponse);
const mapItemModelView = browser_esm.mapper.defineMapper(browser_esm.mapper.read(browser_esm.mapper.mapProp('modelViewId', streamAttributes.toPbJsUuid2l), browser_esm.mapper.mapProp('sceneItemId', streamAttributes.toPbJsUuid2l)), ([modelViewId, sceneItemId]) => ({ modelViewId, sceneItemId }));
const mapItemModelViewOrThrow = browser_esm.mapper.ifInvalidThrow(mapItemModelView);

const mapPmiAnnotation = browser_esm.mapper.defineMapper(browser_esm.mapper.read(browser_esm.mapper.mapRequiredProp('id', streamAttributes.fromPbUuid2l), browser_esm.mapper.getProp('displayName')), ([id, displayName]) => ({ id, displayName }));
const mapListPmiAnnotationsResponse = browser_esm.mapper.defineMapper(browser_esm.mapper.read(browser_esm.mapper.mapProp('annotationsList', browser_esm.mapper.mapArray(mapPmiAnnotation)), browser_esm.mapper.mapProp('nextPageCursor', streamAttributes.mapCursor)), ([annotations, next]) => ({ annotations, paging: { next } }));
const mapListPmiAnnotationsResponseOrThrow = browser_esm.mapper.ifInvalidThrow(mapListPmiAnnotationsResponse);

exports.mapItemModelViewOrThrow = mapItemModelViewOrThrow;
exports.mapListItemModelViewsResponseOrThrow = mapListItemModelViewsResponseOrThrow;
exports.mapListPmiAnnotationsResponseOrThrow = mapListPmiAnnotationsResponseOrThrow;

//# sourceMappingURL=mapper-f1521d42.js.map