/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
'use strict';

const bundle_esm = require('./bundle.esm-9f2927ac.js');
const browser_esm = require('./browser.esm-91aa64b8.js');

class ArrowMarkup {
  constructor(init) {
    var _a, _b, _c, _d, _e;
    this.start = (_a = init.start) !== null && _a !== void 0 ? _a : bundle_esm.point.create();
    this.end = (_b = init.end) !== null && _b !== void 0 ? _b : bundle_esm.point.create();
    this.id = (_c = init.id) !== null && _c !== void 0 ? _c : `arrow-markup--${browser_esm.uuid.create()}`;
    this.startLineAnchorStyle = (_d = init.startLineAnchorStyle) !== null && _d !== void 0 ? _d : 'none';
    this.endLineAnchorStyle = (_e = init.endLineAnchorStyle) !== null && _e !== void 0 ? _e : 'arrow-triangle';
  }
}
class CircleMarkup {
  constructor(init) {
    var _a, _b;
    this.bounds = (_a = init.bounds) !== null && _a !== void 0 ? _a : bundle_esm.rectangle.create(0, 0, 0, 0);
    this.id = (_b = init.id) !== null && _b !== void 0 ? _b : `circle-markup--${browser_esm.uuid.create()}`;
  }
}
class FreeformMarkup {
  constructor(init) {
    var _a, _b, _c;
    this.bounds = (_a = init.bounds) !== null && _a !== void 0 ? _a : bundle_esm.rectangle.create(0, 0, 0, 0);
    this.points = (_b = init.points) !== null && _b !== void 0 ? _b : [];
    this.id = (_c = init.id) !== null && _c !== void 0 ? _c : `freeform-markup--${browser_esm.uuid.create()}`;
  }
}

exports.ArrowMarkup = ArrowMarkup;
exports.CircleMarkup = CircleMarkup;
exports.FreeformMarkup = FreeformMarkup;

//# sourceMappingURL=markup-17396bf6.js.map