/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
'use strict';

const bundle_esm = require('./bundle.esm-9f2927ac.js');

/**
 * Constructs a new measurement result from the given points.
 *
 * @param point1 A starting point.
 * @param point2 An ending point.
 * @returns A new measurement result.
 */
function makeMinimumDistanceResult(point1, point2) {
  return {
    type: 'minimum-distance',
    point1,
    point2,
    distance: bundle_esm.vector3.distance(point1, point2),
  };
}

exports.makeMinimumDistanceResult = makeMinimumDistanceResult;

//# sourceMappingURL=results-dc11ea4b.js.map