/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
'use strict';

const index = require('./index-4ebe6acf.js');

// eslint-disable-next-line no-restricted-imports
function readDOM(task) {
  index.readTask(task);
}
function writeDOM(task) {
  index.writeTask(task);
}
function debounceEvent(event, wait) {
  let timer = undefined;
  function debounce(value) {
    window.clearTimeout(timer);
    timer = window.setTimeout(() => event.emit(value), wait);
  }
  return {
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    emit: debounce,
    dispose() {
      window.clearTimeout(timer);
    },
  };
}

exports.debounceEvent = debounceEvent;
exports.readDOM = readDOM;
exports.writeDOM = writeDOM;

//# sourceMappingURL=stencil-1be2254b.js.map