/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-4ebe6acf.js');
const index$1 = require('./index-cafdf699.js');
require('./_commonjsHelpers-6d73bb9b.js');

const viewerAnnotationCalloutCss = ":host{display:block;--viewer-annotation-callout-primary-color:var(--blue-700);--viewer-annotation-callout-accent-color:var(--white)}.content{display:flex;align-items:center;box-sizing:border-box;justify-content:center;background-color:var(--viewer-annotation-callout-primary-color);border:1px solid var(--viewer-annotation-callout-accent-color)}.content.sm{border-radius:14px;width:28px;height:28px}.content.md{border-radius:19px;width:38px;height:38px}.content.lg{border-radius:24px;width:48px;height:48px}.icon{color:var(--viewer-annotation-callout-accent-color)}";

const ViewerAnnotationCallout = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /**
     * The icon size to display.
     */
    this.iconSize = 'sm';
  }
  render() {
    return (index.h(index.Host, null, index.h("div", { class: index$1.classnames('content', this.iconSize), style: {
        borderColor: this.data.accentColor,
        backgroundColor: this.data.primaryColor,
      } }, index.h("vertex-viewer-icon", { class: "icon", name: this.data.icon, size: this.iconSize, style: { color: this.data.accentColor } }))));
  }
};
ViewerAnnotationCallout.style = viewerAnnotationCalloutCss;

exports.vertex_viewer_annotation_callout = ViewerAnnotationCallout;

//# sourceMappingURL=vertex-viewer-annotation-callout.cjs.entry.js.map