/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-4ebe6acf.js');
const index$1 = require('./index-cafdf699.js');
require('./_commonjsHelpers-6d73bb9b.js');

const viewerButtonCss = ":host{cursor:pointer}.viewer-button{align-items:center;background:none;border:none;color:inherit;cursor:inherit;display:flex;padding:0}";

const ViewerButton = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
  }
  render() {
    return (index.h(index.Host, null, index.h("button", { class: "viewer-button" }, index.h("slot", null))));
  }
};
ViewerButton.style = viewerButtonCss;

const viewerToolbarCss = ".layer{padding:1rem;display:flex}.layer.position-top{align-items:flex-start}.layer.position-middle{align-items:center}.layer.position-bottom{align-items:flex-end}.layer.position-left{justify-content:flex-start}.layer.position-center{justify-content:center}.layer.position-right{justify-content:flex-end}.inner{display:flex}.inner.vertical{flex-direction:column}.inner.horizonal{flex-direction:row}::slotted(*){pointer-events:initial}";

const ViewerToolbar = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /**
     * Specifies where the toolbar is positioned.
     */
    this.placement = 'bottom-center';
    this.direction = 'horizontal';
  }
  render() {
    const [vertical, horizontal] = this.placement.split('-');
    return (index.h("vertex-viewer-layer", { class: index$1.classnames('layer', {
        'position-top': vertical === 'top',
        'position-middle': vertical === 'middle',
        'position-bottom': vertical === 'bottom',
        'position-left': horizontal === 'left',
        'position-center': horizontal === 'center',
        'position-right': horizontal === 'right',
      }) }, index.h("div", { class: index$1.classnames('inner', {
        vertical: this.direction === 'vertical',
        horizontal: this.direction === 'horizontal',
      }) }, index.h("slot", null))));
  }
};
ViewerToolbar.style = viewerToolbarCss;

const viewerToolbarGroupCss = ".inner{display:flex;align-items:center;margin:auto}.inner.vertical{flex-direction:column}.inner.horizontal{flex-direction:row}";

const ViewerToolbarGroup = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.direction = 'horizontal';
  }
  render() {
    return (index.h("div", { class: index$1.classnames('inner', {
        horizontal: this.direction === 'horizontal',
        vertical: this.direction === 'vertical',
      }) }, index.h("slot", null)));
  }
};
ViewerToolbarGroup.style = viewerToolbarGroupCss;

exports.vertex_viewer_button = ViewerButton;
exports.vertex_viewer_toolbar = ViewerToolbar;
exports.vertex_viewer_toolbar_group = ViewerToolbarGroup;

//# sourceMappingURL=vertex-viewer-button_3.cjs.entry.js.map