/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-4ebe6acf.js');

const viewerLayerCss = ":host{pointer-events:none;overflow:hidden}:host(:not([stretch-off])){position:absolute;left:0;right:0;top:0;bottom:0}";

const ViewerLayer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /**
     * Indicates if the layer should stretch to fill the size of its container's
     * nearest positioned parent.
     */
    this.stretchOff = false;
  }
  /**
   * @ignore
   */
  render() {
    return (index.h(index.Host, null, index.h("slot", null)));
  }
  get hostEl() { return index.getElement(this); }
};
ViewerLayer.style = viewerLayerCss;

exports.vertex_viewer_layer = ViewerLayer;

//# sourceMappingURL=vertex-viewer-layer.cjs.entry.js.map