/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-4ebe6acf.js');
const streamAttributes = require('./streamAttributes-8c3c3d8a.js');
require('./entities-ed091fe1.js');
const bundle_esm = require('./bundle.esm-9f2927ac.js');
const index$1 = require('./index-cafdf699.js');
require('./bundle.esm-a19223be.js');
require('./browser.esm-91aa64b8.js');
require('./_commonjsHelpers-6d73bb9b.js');

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign$1 = function() {
    __assign$1 = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign$1.apply(this, arguments);
};

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

/**
 * Source: ftp://ftp.unicode.org/Public/UCD/latest/ucd/SpecialCasing.txt
 */
/**
 * Lower case as a function.
 */
function lowerCase(str) {
    return str.toLowerCase();
}

// Support camel case ("camelCase" -> "camel Case" and "CAMELCase" -> "CAMEL Case").
var DEFAULT_SPLIT_REGEXP = [/([a-z0-9])([A-Z])/g, /([A-Z])([A-Z][a-z])/g];
// Remove all non-word characters.
var DEFAULT_STRIP_REGEXP = /[^A-Z0-9]+/gi;
/**
 * Normalize the string into something other libraries can manipulate easier.
 */
function noCase(input, options) {
    if (options === void 0) { options = {}; }
    var _a = options.splitRegexp, splitRegexp = _a === void 0 ? DEFAULT_SPLIT_REGEXP : _a, _b = options.stripRegexp, stripRegexp = _b === void 0 ? DEFAULT_STRIP_REGEXP : _b, _c = options.transform, transform = _c === void 0 ? lowerCase : _c, _d = options.delimiter, delimiter = _d === void 0 ? " " : _d;
    var result = replace(replace(input, splitRegexp, "$1\0$2"), stripRegexp, "\0");
    var start = 0;
    var end = result.length;
    // Trim the delimiter from around the output string.
    while (result.charAt(start) === "\0")
        start++;
    while (result.charAt(end - 1) === "\0")
        end--;
    // Transform each token independently.
    return result.slice(start, end).split("\0").map(transform).join(delimiter);
}
/**
 * Replace `re` in the input string with the replacement value.
 */
function replace(input, re, value) {
    if (re instanceof RegExp)
        return input.replace(re, value);
    return re.reduce(function (input, re) { return input.replace(re, value); }, input);
}

function dotCase(input, options) {
    if (options === void 0) { options = {}; }
    return noCase(input, __assign({ delimiter: "." }, options));
}

function paramCase(input, options) {
    if (options === void 0) { options = {}; }
    return dotCase(input, __assign$1({ delimiter: "-" }, options));
}

const MeasurementDetailsEntry = (_a, children) => {
  var { label } = _a, props = bundle_esm.__rest(_a, ["label"]);
  return (index.h("div", Object.assign({}, props, { class: "measurement-details-entry" }),
    index.h("div", { class: index$1.classnames('measurement-details-entry-label', paramCase(label)) },
      label,
      ":"),
    children));
};

// eslint-disable-next-line @typescript-eslint/no-unused-vars
const MinimumDistanceResultEntry = ({ result, formatter, overlays, onShowOverlay, onHideOverlay }) => {
  const v = bundle_esm.vector3.subtract(result.point1, result.point2);
  return (index.h(index.Fragment, null,
    index.h(MeasurementDetailsEntry, { label: "Dist", onMouseEnter: () => onShowOverlay(overlays === null || overlays === void 0 ? void 0 : overlays.addLineFromResult(result)), onMouseLeave: onHideOverlay }, formatter(result.distance)),
    index.h(MeasurementDetailsEntry, { label: "X", onMouseEnter: () => onShowOverlay(overlays === null || overlays === void 0 ? void 0 : overlays.addDistanceVectorFromResult(result)), onMouseLeave: onHideOverlay }, formatter(v.x)),
    index.h(MeasurementDetailsEntry, { label: "Y", onMouseEnter: () => onShowOverlay(overlays === null || overlays === void 0 ? void 0 : overlays.addDistanceVectorFromResult(result)), onMouseLeave: onHideOverlay }, formatter(v.y)),
    index.h(MeasurementDetailsEntry, { label: "Z", onMouseEnter: () => onShowOverlay(overlays === null || overlays === void 0 ? void 0 : overlays.addDistanceVectorFromResult(result)), onMouseLeave: onHideOverlay }, formatter(v.z))));
};
const PlanarAngleResultEntry = ({ result, formatter }) => {
  return (index.h(MeasurementDetailsEntry, { label: "Angle" }, formatter(result.angle)));
};
const PlanarDistanceResultEntry = ({ result, formatter }) => {
  return (index.h(MeasurementDetailsEntry, { label: "Parallel Dist" }, formatter(result.distance)));
};
const SurfaceAreaResultEntry = ({ result, formatter }) => {
  return (index.h(MeasurementDetailsEntry, { label: "Area" }, formatter(result.area)));
};

const viewerMeasurementDetailsCss = ":host{display:flex;flex-direction:column;--viewer-measurement-details-x-color:red;--viewer-measurement-details-y-color:var(--green-500);--viewer-measurement-details-z-color:blue}.measurement-details-entry{display:flex;align-items:center}.measurement-details-entry-label{user-select:none;padding-right:0.25rem}.measurement-details-entry-label.x{color:var(--viewer-measurement-details-x-color)}.measurement-details-entry-label.y{color:var(--viewer-measurement-details-y-color)}.measurement-details-entry-label.z{color:var(--viewer-measurement-details-z-color)}";

const ViewerMeasurementDetails = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /**
     * The unit of distance-based measurement.
     */
    this.distanceUnits = 'millimeters';
    /**
     * The unit of angle-based measurement.
     */
    this.angleUnits = 'degrees';
    /**
     * The number of fraction digits to display.
     */
    this.fractionalDigits = 2;
    this.distanceMeasurementUnits = new streamAttributes.DistanceUnits(this.distanceUnits);
    this.angleMeasurementUnits = new streamAttributes.AngleUnits(this.angleUnits);
    this.areaMeasurementUnits = new streamAttributes.AreaUnits(this.distanceUnits);
    this.handleShowOverlay = (overlay) => {
      this.overlay = overlay;
    };
    this.handleHideOverlay = () => {
      var _a;
      (_a = this.overlay) === null || _a === void 0 ? void 0 : _a.dispose();
    };
    this.handleOutcomeChange = () => {
      this.updateStateFromModel();
    };
  }
  /**
   * @internal
   */
  connectedCallback() {
    var _a;
    this.onOutcomeChangedHandler = (_a = this.measurementModel) === null || _a === void 0 ? void 0 : _a.onOutcomeChanged(this.handleOutcomeChange);
    this.updateStateFromModel();
  }
  /**
   * @internal
   */
  disconnectedCallback() {
    var _a;
    (_a = this.onOutcomeChangedHandler) === null || _a === void 0 ? void 0 : _a.dispose();
  }
  /**
   * @internal
   */
  handleDistanceUnitsChanged() {
    this.distanceMeasurementUnits = new streamAttributes.DistanceUnits(this.distanceUnits);
    this.areaMeasurementUnits = new streamAttributes.AreaUnits(this.distanceUnits);
  }
  /**
   * @internal
   */
  handleAngleUnitsChanged() {
    this.angleMeasurementUnits = new streamAttributes.AngleUnits(this.angleUnits);
  }
  /**
   * @internal
   */
  handleMeasurementModelChanged() {
    var _a, _b;
    (_a = this.onOutcomeChangedHandler) === null || _a === void 0 ? void 0 : _a.dispose();
    this.onOutcomeChangedHandler = (_b = this.measurementModel) === null || _b === void 0 ? void 0 : _b.onOutcomeChanged(this.handleOutcomeChange);
    this.updateStateFromModel();
  }
  /**
   * @internal
   */
  handleResultTypesChanged() {
    this.updateStateFromModel();
  }
  /**
   * @internal
   */
  render() {
    var _a, _b;
    const isFilteredResultType = (result) => {
      var _a, _b;
      return (_b = (_a = this.resultTypes) === null || _a === void 0 ? void 0 : _a.includes(result.type)) !== null && _b !== void 0 ? _b : true;
    };
    const results = ((_b = (_a = this.measurementOutcome) === null || _a === void 0 ? void 0 : _a.results) !== null && _b !== void 0 ? _b : []).filter(isFilteredResultType);
    return (index.h(index.Host, null, this.renderResult('planar-angle', results, (result) => (index.h(PlanarAngleResultEntry, { result: result, overlays: this.measurementOverlays, formatter: this.makeAngleFormatter(), onShowOverlay: this.handleShowOverlay, onHideOverlay: this.handleHideOverlay }))), this.renderResult('planar-distance', results, (result) => (index.h(PlanarDistanceResultEntry, { result: result, overlays: this.measurementOverlays, formatter: this.makeDistanceFormatter(), onShowOverlay: this.handleShowOverlay, onHideOverlay: this.handleHideOverlay }))), this.renderResult('surface-area', results, (result) => (index.h(SurfaceAreaResultEntry, { result: result, overlays: this.measurementOverlays, formatter: this.makeAreaFormatter(), onShowOverlay: this.handleShowOverlay, onHideOverlay: this.handleHideOverlay }))), this.renderResult('minimum-distance', results, (result) => (index.h(MinimumDistanceResultEntry, { result: result, overlays: this.measurementOverlays, formatter: this.makeDistanceFormatter(), onShowOverlay: this.handleShowOverlay, onHideOverlay: this.handleHideOverlay })))));
  }
  updateStateFromModel() {
    var _a;
    this.measurementOutcome = (_a = this.measurementModel) === null || _a === void 0 ? void 0 : _a.getOutcome();
  }
  renderResult(type, results, render) {
    const result = this.getResultForType(type, results);
    return result != null ? render(result) : undefined;
  }
  getResultForType(type, results) {
    return results.find((result) => result.type === type);
  }
  makeDistanceFormatter() {
    return this.makeFormatter((value) => this.distanceMeasurementUnits.convertWorldValueToReal(value), this.distanceMeasurementUnits.unit, this.distanceFormatter);
  }
  makeAngleFormatter() {
    return this.makeFormatter((value) => this.angleMeasurementUnits.convertTo(value), this.angleMeasurementUnits.unit, this.angleFormatter);
  }
  makeAreaFormatter() {
    return this.makeFormatter((value) => this.areaMeasurementUnits.convertWorldValueToReal(value), this.areaMeasurementUnits.unit, this.areaFormatter);
  }
  makeFormatter(convert, units, customFormatter) {
    return (value) => {
      const v = convert(value);
      if (customFormatter != null) {
        return customFormatter(v);
      }
      else {
        return this.formatValue(v, units);
      }
    };
  }
  formatValue(value, unit) {
    var _a, _b;
    const val = value.toFixed(this.fractionalDigits);
    const isApprox = (_b = (_a = this.measurementOutcome) === null || _a === void 0 ? void 0 : _a.isApproximate) !== null && _b !== void 0 ? _b : false;
    return `${isApprox ? '~' + val : val} ${unit.abbreviatedName}`;
  }
  static get watchers() { return {
    "distanceUnits": ["handleDistanceUnitsChanged"],
    "angleUnits": ["handleAngleUnitsChanged"],
    "measurementModel": ["handleMeasurementModelChanged"],
    "resultTypes": ["handleResultTypesChanged"]
  }; }
};
ViewerMeasurementDetails.style = viewerMeasurementDetailsCss;

exports.vertex_viewer_measurement_details = ViewerMeasurementDetails;

//# sourceMappingURL=vertex-viewer-measurement-details.cjs.entry.js.map