/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-4ebe6acf.js');
const index$1 = require('./index-cafdf699.js');
require('./_commonjsHelpers-6d73bb9b.js');

const viewerSpinnerCss = ".spinner{position:relative;height:16px;width:16px}.spinner div{position:absolute;display:block;animation:spinner 1.2s cubic-bezier(0.5, 0, 0.5, 1) infinite;border-radius:50%;border-style:solid;box-sizing:border-box;border-color:var(--neutral-800) transparent transparent transparent;border-width:1px;margin:0}.spinner div:nth-child(1){animation-delay:-0.45s}.spinner div:nth-child(2){animation-delay:-0.3s}.spinner div:nth-child(3){animation-delay:-0.15s}.spinner.xs{height:16px;width:16px}.spinner.xs div{border-width:1px;height:16px;width:16px;margin:0}.spinner.sm{height:24px;width:24px}.spinner.sm div{border-width:3px;height:18px;width:18px;margin:2px}.spinner.md{height:32px;width:32px}.spinner.md div{border-width:3px;height:32px;width:32px;margin:2px}.spinner.lg{height:64px;width:64px}.spinner.lg div{border-width:6px;height:52px;width:52px;margin:6px}@keyframes spinner{0%{transform:rotate(0deg)}100%{transform:rotate(360deg)}}";

const ViewerSpinner = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /**
     * The size of the spinner. Can be `'xs' | 'sm' | 'md' | 'lg' | undefined`. Predefined
     * sizes are set to:
     *
     *  * `xm`: 16px
     *  * `sm`: 24px
     *  * `md`: 32px
     *  * `lg`: 64px
     */
    this.size = 'md';
  }
  render() {
    return (index.h("div", { class: index$1.classnames('spinner', {
        ['xs']: this.size === 'xs',
        ['sm']: this.size === 'sm',
        ['md']: this.size === 'md',
        ['lg']: this.size === 'lg',
      }) }, index.h("div", null), index.h("div", null), index.h("div", null), index.h("div", null)));
  }
};
ViewerSpinner.style = viewerSpinnerCss;

exports.vertex_viewer_spinner = ViewerSpinner;

//# sourceMappingURL=vertex-viewer-spinner.cjs.entry.js.map