/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
import { Component, h, Host, Prop } from '@stencil/core';
export class SceneTreeTableColumn {
  render() {
    return (h(Host, null,
      h("div", { class: "hidden" },
        h("slot", { name: "header" })),
      h("div", { class: "column" },
        h("slot", null))));
  }
  static get is() { return "vertex-scene-tree-table-column"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() { return {
    "$": ["scene-tree-table-column.css"]
  }; }
  static get styleUrls() { return {
    "$": ["scene-tree-table-column.css"]
  }; }
  static get properties() { return {
    "initialWidth": {
      "type": "number",
      "mutable": false,
      "complexType": {
        "original": "number",
        "resolved": "number | undefined",
        "references": {}
      },
      "required": false,
      "optional": true,
      "docs": {
        "tags": [],
        "text": "The initial width of this column."
      },
      "attribute": "initial-width",
      "reflect": false
    },
    "minWidth": {
      "type": "number",
      "mutable": false,
      "complexType": {
        "original": "number",
        "resolved": "number | undefined",
        "references": {}
      },
      "required": false,
      "optional": true,
      "docs": {
        "tags": [],
        "text": "The minimum width of this column."
      },
      "attribute": "min-width",
      "reflect": false
    },
    "maxWidth": {
      "type": "number",
      "mutable": false,
      "complexType": {
        "original": "number",
        "resolved": "number | undefined",
        "references": {}
      },
      "required": false,
      "optional": true,
      "docs": {
        "tags": [],
        "text": "The maximum width of this column."
      },
      "attribute": "max-width",
      "reflect": false
    }
  }; }
}
//# sourceMappingURL=scene-tree-table-column.js.map