/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
import { Component, h, Host } from '@stencil/core';
/**
 * @slot The primary content that will be placed in the center of the toolbar
 * and stretch to container's available width.
 * @slot before - Content that is placed before the primary content.
 * @slot after - Content that is placed after the primary content.
 */
export class SceneTreeToolbar {
  render() {
    return (h(Host, null,
      h("div", { class: "content" },
        h("slot", { name: "before" })),
      h("div", { class: "content content-primary" },
        h("slot", null)),
      h("div", { class: "content" },
        h("slot", { name: "after" }))));
  }
  static get is() { return "vertex-scene-tree-toolbar"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() { return {
    "$": ["scene-tree-toolbar.css"]
  }; }
  static get styleUrls() { return {
    "$": ["scene-tree-toolbar.css"]
  }; }
}
//# sourceMappingURL=scene-tree-toolbar.js.map