/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
import { Component, Element, h, Host, Prop } from '@stencil/core';
export class ViewerLayer {
  constructor() {
    /**
     * Indicates if the layer should stretch to fill the size of its container's
     * nearest positioned parent.
     */
    this.stretchOff = false;
  }
  /**
   * @ignore
   */
  render() {
    return (h(Host, null,
      h("slot", null)));
  }
  static get is() { return "vertex-viewer-layer"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() { return {
    "$": ["viewer-layer.css"]
  }; }
  static get styleUrls() { return {
    "$": ["viewer-layer.css"]
  }; }
  static get properties() { return {
    "stretchOff": {
      "type": "boolean",
      "mutable": false,
      "complexType": {
        "original": "boolean",
        "resolved": "boolean",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "Indicates if the layer should stretch to fill the size of its container's\nnearest positioned parent."
      },
      "attribute": "stretch-off",
      "reflect": true,
      "defaultValue": "false"
    }
  }; }
  static get elementRef() { return "hostEl"; }
}
//# sourceMappingURL=viewer-layer.js.map