/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
// eslint-disable-next-line @typescript-eslint/no-unused-vars
import { h } from '@stencil/core';
import { Angle, Point } from '@vertexvis/geometry';
import classNames from 'classnames';
import { RelativeAnchor } from '../viewer-markup/viewer-markup-components';
export const BoundingBox1d = ({ start, end, onStartAnchorPointerDown, onCenterAnchorPointerDown, onEndAnchorPointerDown, }) => {
  const angle = Angle.normalize(Angle.toDegrees(Angle.fromPoints(start, end)) - 270);
  const center = Point.create((start.x + end.x) / 2, (start.y + end.y) / 2);
  return (h("div", { class: "bounds-container" },
    h(RelativeAnchor, { id: "bounding-box-1d-start-anchor", name: "start-anchor", rotation: angle, point: start, onPointerDown: onStartAnchorPointerDown },
      h("div", { class: classNames('bounds-default-anchor', 'bounds-cap-anchor') })),
    h(RelativeAnchor, { id: "bounding-box-1d-end-anchor", name: "end-anchor", rotation: angle, point: end, onPointerDown: onEndAnchorPointerDown },
      h("div", { class: classNames('bounds-default-anchor', 'bounds-cap-anchor') })),
    h(RelativeAnchor, { id: "bounding-box-1d-center-anchor", name: "center-anchor", point: center, onPointerDown: onCenterAnchorPointerDown },
      h("div", { class: classNames('bounds-default-anchor', 'bounds-center-anchor') }))));
};
//# sourceMappingURL=viewer-markup-arrow-components.js.map