/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
// eslint-disable-next-line @typescript-eslint/no-unused-vars
import { h } from '@stencil/core';
export const RelativeAnchor = ({ id, rotation, name, point, onPointerDown }, children) => {
  return (h("div", { id: id, class: "bounds-anchor-position", style: {
      top: `${point.y}px`,
      left: `${point.x}px`,
    }, onTouchStart: (event) => event.preventDefault(), onPointerDown: onPointerDown },
    h("div", { class: "bounds-anchor", style: {
        transform: `rotateZ(${rotation !== null && rotation !== void 0 ? rotation : 0}deg)`,
      } },
      h("slot", { name: name }, children))));
};
export const SvgShadow = ({ id }) => {
  return (h("filter", { id: id, filterUnits: "userSpaceOnUse" },
    h("feGaussianBlur", { in: "SourceAlpha", stdDeviation: "2" }),
    h("feOffset", { dx: "0", dy: "1", result: "offsetblur" }),
    h("feFlood", { "flood-color": "#000000", "flood-opacity": "0.25" }),
    h("feComposite", { in2: "offsetblur", operator: "in" }),
    h("feMerge", null,
      h("feMergeNode", null),
      h("feMergeNode", { in: "SourceGraphic" }))));
};
//# sourceMappingURL=viewer-markup-components.js.map