/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
// eslint-disable-next-line @typescript-eslint/no-unused-vars
import { Fragment, h } from '@stencil/core';
import { Vector3 } from '@vertexvis/geometry';
import { MeasurementDetailsEntry } from './viewer-measurement-details-entry';
export const MinimumDistanceResultEntry = ({ result, formatter, overlays, onShowOverlay, onHideOverlay }) => {
  const v = Vector3.subtract(result.point1, result.point2);
  return (h(Fragment, null,
    h(MeasurementDetailsEntry, { label: "Dist", onMouseEnter: () => onShowOverlay(overlays === null || overlays === void 0 ? void 0 : overlays.addLineFromResult(result)), onMouseLeave: onHideOverlay }, formatter(result.distance)),
    h(MeasurementDetailsEntry, { label: "X", onMouseEnter: () => onShowOverlay(overlays === null || overlays === void 0 ? void 0 : overlays.addDistanceVectorFromResult(result)), onMouseLeave: onHideOverlay }, formatter(v.x)),
    h(MeasurementDetailsEntry, { label: "Y", onMouseEnter: () => onShowOverlay(overlays === null || overlays === void 0 ? void 0 : overlays.addDistanceVectorFromResult(result)), onMouseLeave: onHideOverlay }, formatter(v.y)),
    h(MeasurementDetailsEntry, { label: "Z", onMouseEnter: () => onShowOverlay(overlays === null || overlays === void 0 ? void 0 : overlays.addDistanceVectorFromResult(result)), onMouseLeave: onHideOverlay }, formatter(v.z))));
};
export const PlanarAngleResultEntry = ({ result, formatter }) => {
  return (h(MeasurementDetailsEntry, { label: "Angle" }, formatter(result.angle)));
};
export const PlanarDistanceResultEntry = ({ result, formatter }) => {
  return (h(MeasurementDetailsEntry, { label: "Parallel Dist" }, formatter(result.distance)));
};
export const SurfaceAreaResultEntry = ({ result, formatter }) => {
  return (h(MeasurementDetailsEntry, { label: "Area" }, formatter(result.area)));
};
//# sourceMappingURL=viewer-measurement-details-results.js.map