/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
// eslint-disable-next-line @typescript-eslint/no-unused-vars
import { Fragment, h } from '@stencil/core';
import classNames from 'classnames';
import { getPinColors, isIconPin, isTextPin } from '../../lib/pins/model';
export const PinRenderer = ({ pin, selected, occluded, detached, }) => {
  const { primaryColor } = getPinColors(pin);
  return (h(Fragment, null,
    isTextPin(pin) && (h("div", { id: "pin-anchor", class: classNames('pin-anchor', {
        selected: selected,
        'pin-occluded': occluded,
        'pin-detached': detached,
      }), style: {
        background: primaryColor,
      } })),
    isIconPin(pin) && (h("vertex-viewer-icon", { name: "pin-fill", size: "lg", class: classNames('pin', {
        'pin-selected': selected,
        'pin-occluded': occluded,
        'pin-detached': detached,
      }), style: {
        color: primaryColor,
      } }))));
};
//# sourceMappingURL=pin-renderer.js.map