/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
import { Component, 
// eslint-disable-next-line @typescript-eslint/no-unused-vars
h, Host, Prop, } from '@stencil/core';
import { getPinColors } from '../../lib/pins/model';
export class VertexPinLabelLine {
  render() {
    var _a, _b, _c, _d;
    const { primaryColor } = getPinColors(this.pin);
    return (h(Host, null,
      h("svg", { class: "svg" },
        h("line", { class: "label-line", style: {
            stroke: primaryColor,
          }, x1: (_a = this.labelPoint) === null || _a === void 0 ? void 0 : _a.x, y1: (_b = this.labelPoint) === null || _b === void 0 ? void 0 : _b.y, x2: (_c = this.pinPoint) === null || _c === void 0 ? void 0 : _c.x, y2: (_d = this.pinPoint) === null || _d === void 0 ? void 0 : _d.y }))));
  }
  static get is() { return "vertex-viewer-pin-label-line"; }
  static get originalStyleUrls() { return {
    "$": ["viewer-pin-label-line.css"]
  }; }
  static get styleUrls() { return {
    "$": ["viewer-pin-label-line.css"]
  }; }
  static get properties() { return {
    "pinPoint": {
      "type": "unknown",
      "mutable": false,
      "complexType": {
        "original": "Point.Point | undefined",
        "resolved": "Point | undefined",
        "references": {
          "Point": {
            "location": "import",
            "path": "@vertexvis/geometry"
          }
        }
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": ""
      }
    },
    "labelPoint": {
      "type": "unknown",
      "mutable": false,
      "complexType": {
        "original": "Point.Point | undefined",
        "resolved": "Point | undefined",
        "references": {
          "Point": {
            "location": "import",
            "path": "@vertexvis/geometry"
          }
        }
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": ""
      }
    },
    "pin": {
      "type": "unknown",
      "mutable": false,
      "complexType": {
        "original": "Pin | undefined",
        "resolved": "IconPin | TextPin | undefined",
        "references": {
          "Pin": {
            "location": "import",
            "path": "../../lib/pins/model"
          }
        }
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": ""
      }
    }
  }; }
}
//# sourceMappingURL=viewer-pin-label-line.js.map