/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
import { Component, h, Prop } from '@stencil/core';
import classNames from 'classnames';
export class ViewerToolbarGroup {
  constructor() {
    this.direction = 'horizontal';
  }
  render() {
    return (h("div", { class: classNames('inner', {
        horizontal: this.direction === 'horizontal',
        vertical: this.direction === 'vertical',
      }) },
      h("slot", null)));
  }
  static get is() { return "vertex-viewer-toolbar-group"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() { return {
    "$": ["viewer-toolbar-group.css"]
  }; }
  static get styleUrls() { return {
    "$": ["viewer-toolbar-group.css"]
  }; }
  static get properties() { return {
    "direction": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "ViewerToolbarGroupDirection",
        "resolved": "\"horizontal\" | \"vertical\"",
        "references": {
          "ViewerToolbarGroupDirection": {
            "location": "import",
            "path": "./types"
          }
        }
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": ""
      },
      "attribute": "direction",
      "reflect": false,
      "defaultValue": "'horizontal'"
    }
  }; }
}
//# sourceMappingURL=viewer-toolbar-group.js.map