/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
export class CustomError extends Error {
  constructor(message, e) {
    super();
    this.message = message;
    this.stack = e === null || e === void 0 ? void 0 : e.stack;
    this.name = this.constructor.name;
    // Allows for `instanceof` checks.
    Object.setPrototypeOf(this, CustomError.prototype);
  }
}
export class ExpiredCredentialsError extends CustomError {
  constructor(message, e) {
    super(message, e);
    // Allows for `instanceof` checks.
    Object.setPrototypeOf(this, ExpiredCredentialsError.prototype);
  }
}
export class InvalidCredentialsError extends CustomError {
  constructor(message, e) {
    super(message, e);
    // Allows for `instanceof` checks.
    Object.setPrototypeOf(this, InvalidCredentialsError.prototype);
  }
}
export class InvalidResourceUrnError extends CustomError {
  constructor(message, e) {
    super(message, e);
    // Allows for `instanceof` checks.
    Object.setPrototypeOf(this, InvalidResourceUrnError.prototype);
  }
}
export class ViewerInitializationError extends CustomError {
  constructor(message, e) {
    super(message, e);
    // Allows for `instanceof` checks.
    Object.setPrototypeOf(this, ViewerInitializationError.prototype);
  }
}
export class ComponentInitializationError extends CustomError {
  constructor(message, e) {
    super(message, e);
    // Allows for `instanceof` checks.
    Object.setPrototypeOf(this, ComponentInitializationError.prototype);
  }
}
export class SceneRenderError extends CustomError {
  constructor(message, e) {
    super(message, e);
    // Allows for `instanceof` checks.
    Object.setPrototypeOf(this, SceneRenderError.prototype);
  }
}
export class UnsupportedOperationError extends CustomError {
  constructor(message, e) {
    super(message, e);
    // Allows for `instanceof` checks.
    Object.setPrototypeOf(this, UnsupportedOperationError.prototype);
  }
}
export class WebsocketConnectionError extends CustomError {
  constructor(message, e) {
    super(message, e);
    // Allows for `instanceof` checks.
    Object.setPrototypeOf(this, WebsocketConnectionError.prototype);
  }
}
export class InteractionHandlerError extends CustomError {
  constructor(message, e) {
    super(message, e);
    // Allows for `instanceof` checks.
    Object.setPrototypeOf(this, InteractionHandlerError.prototype);
  }
}
export class MissingJWTError extends CustomError {
  constructor(message, e) {
    super(message, e);
    // Allows for `instanceof` checks.
    Object.setPrototypeOf(this, MissingJWTError.prototype);
  }
}
export class ImageLoadError extends CustomError {
  constructor(message, e) {
    super(message, e);
    // Allows for `instanceof` checks.
    Object.setPrototypeOf(this, ImageLoadError.prototype);
  }
}
export class IllegalStateError extends CustomError {
  constructor(message, e) {
    super(message, e);
    // Allows for `instanceof` checks.
    Object.setPrototypeOf(this, IllegalStateError.prototype);
  }
}
export class NoImplementationFoundError extends CustomError {
  constructor(message, e) {
    super(message, e);
    // Allows for `instanceof` checks.
    Object.setPrototypeOf(this, NoImplementationFoundError.prototype);
  }
}
export class InvalidArgumentError extends CustomError {
  constructor(message, e) {
    super(message, e);
    // Allows for `instanceof` checks.
    Object.setPrototypeOf(this, InvalidArgumentError.prototype);
  }
}
export class InvalidCameraError extends CustomError {
  constructor(message, e) {
    super(message, e);
    // Allows for `instanceof` checks.
    Object.setPrototypeOf(this, InvalidCameraError.prototype);
  }
}
//# sourceMappingURL=errors.js.map