/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
import { vertexvis } from '@vertexvis/frame-streaming-protos';
import { Mapper as M } from '@vertexvis/utils';
export const toPbCameraType = M.defineMapper((cameraType) => {
  switch (cameraType) {
    case 'perspective':
      return vertexvis.protobuf.stream.CameraType.CAMERA_TYPE_PERSPECTIVE;
    case 'orthographic':
      return vertexvis.protobuf.stream.CameraType.CAMERA_TYPE_ORTHOGRAPHIC;
    default:
      return vertexvis.protobuf.stream.CameraType.CAMERA_TYPE_INVALID;
  }
}, (cameraType) => cameraType);
export function toPbCameraTypeOrThrow() {
  return M.ifInvalidThrow(toPbCameraType);
}
//# sourceMappingURL=camera.js.map