/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
import { UUID } from '@vertexvis/utils';
import { Mapper as M } from '@vertexvis/utils';
import Long from 'long';
export const fromPbJsUuid = M.defineMapper(M.read(M.requiredProp('hex')), ([uuid]) => uuid);
export const fromPbJsUuid2l = M.defineMapper(M.read(M.requiredProp('msb'), M.requiredProp('lsb')), ([msb, lsb]) => {
  const m = BigInt(typeof msb === 'number' ? msb : msb.toString());
  const l = BigInt(typeof lsb === 'number' ? lsb : lsb.toString());
  return UUID.fromMsbLsb(m, l);
});
export const toPbJsUuid2l = M.defineMapper(M.compose((str) => UUID.toMsbLsb(str), M.read(M.mapProp('msb', Long.fromString), M.mapProp('lsb', Long.fromString))), ([msb, lsb]) => ({ msb, lsb }));
//# sourceMappingURL=corePbJs.js.map