/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
import { BoundingBox, Dimensions, Plane, Rectangle, Vector3, } from '@vertexvis/geometry';
import { Mapper as M } from '@vertexvis/utils';
export const fromPbDim = M.defineMapper(M.read(M.requiredProp('width'), M.requiredProp('height')), ([width, height]) => Dimensions.create(width, height));
export const fromPbRect = M.defineMapper(M.read(M.requiredProp('x'), M.requiredProp('y'), M.requiredProp('width'), M.requiredProp('height')), ([x, y, width, height]) => Rectangle.create(x, y, width, height));
export const fromPbVector3f = M.defineMapper(M.read(M.requiredProp('x'), M.requiredProp('y'), M.requiredProp('z')), ([x, y, z]) => Vector3.create(x, y, z));
export const fromPbBoundingBox3f = M.defineMapper(M.read(M.requiredProp('xmin'), M.requiredProp('ymin'), M.requiredProp('zmin'), M.requiredProp('xmax'), M.requiredProp('ymax'), M.requiredProp('zmax')), ([xmin, ymin, zmin, xmax, ymax, zmax]) => BoundingBox.create(Vector3.create(xmin, ymin, zmin), Vector3.create(xmax, ymax, zmax)));
export const fromPbPlane = M.defineMapper(M.read(M.requiredProp('d'), M.mapRequiredProp('normal', fromPbVector3f)), ([constant, normal]) => Plane.create({ normal, constant }));
//# sourceMappingURL=geometry.js.map