/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
import { Vector3 } from '@vertexvis/geometry';
/**
 * Constructs a new measurement result from the given points.
 *
 * @param point1 A starting point.
 * @param point2 An ending point.
 * @returns A new measurement result.
 */
export function makeMinimumDistanceResult(point1, point2) {
  return {
    type: 'minimum-distance',
    point1,
    point2,
    distance: Vector3.distance(point1, point2),
  };
}
//# sourceMappingURL=results.js.map