/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
import { Mapper as M } from '@vertexvis/utils';
import { fromPbUuid2l, mapCursor } from '../mappers';
const mapPmiAnnotation = M.defineMapper(M.read(M.mapRequiredProp('id', fromPbUuid2l), M.getProp('displayName')), ([id, displayName]) => ({ id, displayName }));
const mapListPmiAnnotationsResponse = M.defineMapper(M.read(M.mapProp('annotationsList', M.mapArray(mapPmiAnnotation)), M.mapProp('nextPageCursor', mapCursor)), ([annotations, next]) => ({ annotations, paging: { next } }));
export const mapListPmiAnnotationsResponseOrThrow = M.ifInvalidThrow(mapListPmiAnnotationsResponse);
//# sourceMappingURL=mapper.js.map