/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
// eslint-disable-next-line no-restricted-imports
import { readTask, writeTask } from '@stencil/core';
export function readDOM(task) {
  readTask(task);
}
export function writeDOM(task) {
  writeTask(task);
}
export function debounceEvent(event, wait) {
  let timer = undefined;
  function debounce(value) {
    window.clearTimeout(timer);
    timer = window.setTimeout(() => event.emit(value), wait);
  }
  return {
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    emit: debounce,
    dispose() {
      window.clearTimeout(timer);
    },
  };
}
//# sourceMappingURL=stencil.js.map