/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
export var StorageKeys;
(function (StorageKeys) {
  StorageKeys["DEVICE_ID"] = "vertexvis:device-id";
})(StorageKeys || (StorageKeys = {}));
export function upsertStorageEntry(key, values, storage = window.localStorage) {
  const existing = storage.getItem(key);
  if (existing != null) {
    const updated = Object.assign(Object.assign({}, JSON.parse(existing)), values);
    storage.setItem(key, JSON.stringify(updated));
  }
  else {
    storage.setItem(key, JSON.stringify(values));
  }
}
export function getStorageEntry(key, f, storage = window.localStorage) {
  const item = storage.getItem(key);
  if (item != null) {
    return f(JSON.parse(item));
  }
}
//# sourceMappingURL=storage.js.map