/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
// eslint-disable-next-line @typescript-eslint/no-explicit-any
export function createFrameStreamingClientMock() {
  return {
    connect: mockConnect(),
    startStream: mockStartStream(),
    createSceneAlteration: mockCreateSceneAlteration(),
  };
}
function mockConnect() {
  // eslint-disable-next-line @typescript-eslint/no-empty-function
  return jest.fn().mockResolvedValue({ dispose: () => { } });
}
function mockStartStream() {
  const result = {
    streamId: { hex: 'stream-id' },
    sceneViewId: { hex: 'scene-view-id' },
  };
  return jest.fn().mockResolvedValue(result);
}
function mockCreateSceneAlteration() {
  return jest.fn().mockResolvedValue({});
}
//# sourceMappingURL=frameStreamingClient.js.map