/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
import { PmiAnnotation } from '@vertexvis/scene-view-protos/core/protos/model_views_pb';
import { ListPmiAnnotationsResponse } from '@vertexvis/scene-view-protos/sceneview/protos/scene_view_api_pb';
import { UUID } from '@vertexvis/utils';
import { random } from './random';
import { makeUuid2l } from './sceneView';
export function makeListPmiAnnotationsResponse(annotations = [makeAnnotation(), makeAnnotation()]) {
  const res = new ListPmiAnnotationsResponse();
  res.setAnnotationsList(annotations);
  return res;
}
export function makeAnnotation(id = UUID.create(), displayName = random.string()) {
  const annotation = new PmiAnnotation();
  annotation.setId(makeUuid2l(id));
  annotation.setDisplayName(displayName);
  return annotation;
}
//# sourceMappingURL=pmi.js.map