/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
class ElementRectObserver {
  constructor() {
    this.observer = new ResizeObserver(() => this.measure());
  }
  observe(element) {
    this.element = element;
    this.observer.observe(element);
    this.measure();
  }
  disconnect() {
    this.element = undefined;
    this.observer.disconnect();
  }
  measure() {
    var _a;
    this.rect = (_a = this.element) === null || _a === void 0 ? void 0 : _a.getBoundingClientRect();
  }
}

export { ElementRectObserver as E };

//# sourceMappingURL=elementRectObserver.js.map