/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';

const sceneTreeToolbarCss = ":host{--scene-tree-toolbar-content-gap:8px;display:flex;padding:0.5rem}.content{display:flex;align-items:center}.content-primary{width:100%}::slotted(:not(:first-child)){margin-left:var(--scene-tree-toolbar-content-gap)}";

const SceneTreeToolbar = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
  }
  render() {
    return (h(Host, null, h("div", { class: "content" }, h("slot", { name: "before" })), h("div", { class: "content content-primary" }, h("slot", null)), h("div", { class: "content" }, h("slot", { name: "after" }))));
  }
  static get style() { return sceneTreeToolbarCss; }
}, [1, "vertex-scene-tree-toolbar"]);
function defineCustomElement() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["vertex-scene-tree-toolbar"];
  components.forEach(tagName => { switch (tagName) {
    case "vertex-scene-tree-toolbar":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, SceneTreeToolbar);
      }
      break;
  } });
}
defineCustomElement();

export { SceneTreeToolbar as S, defineCustomElement as d };

//# sourceMappingURL=scene-tree-toolbar.js.map