/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';

const sceneTreeTableColumnCss = ":host{width:100%;height:100%;position:relative}.hidden{visibility:hidden;pointer-events:none}.column{display:flex;flex-direction:column;height:100%;width:100%;overflow:hidden}";

const SceneTreeTableColumn = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
  }
  render() {
    return (h(Host, null, h("div", { class: "hidden" }, h("slot", { name: "header" })), h("div", { class: "column" }, h("slot", null))));
  }
  static get style() { return sceneTreeTableColumnCss; }
}, [1, "vertex-scene-tree-table-column", {
    "initialWidth": [2, "initial-width"],
    "minWidth": [2, "min-width"],
    "maxWidth": [2, "max-width"]
  }]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["vertex-scene-tree-table-column"];
  components.forEach(tagName => { switch (tagName) {
    case "vertex-scene-tree-table-column":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, SceneTreeTableColumn);
      }
      break;
  } });
}
defineCustomElement$1();

const VertexSceneTreeTableColumn = SceneTreeTableColumn;
const defineCustomElement = defineCustomElement$1;

export { VertexSceneTreeTableColumn, defineCustomElement };

//# sourceMappingURL=vertex-scene-tree-table-column.js.map