/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';

const sceneTreeTableHeaderCss = ":host{width:100%;box-sizing:border-box}.header{display:flex;align-items:center;box-sizing:border-box;font-size:0.875rem;white-space:nowrap;overflow:hidden;padding:0.5rem 0}";

const SceneTreeTableHeader = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
  }
  render() {
    return (h(Host, null, h("div", { class: "header" }, h("slot", null))));
  }
  static get style() { return sceneTreeTableHeaderCss; }
}, [1, "vertex-scene-tree-table-header"]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["vertex-scene-tree-table-header"];
  components.forEach(tagName => { switch (tagName) {
    case "vertex-scene-tree-table-header":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, SceneTreeTableHeader);
      }
      break;
  } });
}
defineCustomElement$1();

const VertexSceneTreeTableHeader = SceneTreeTableHeader;
const defineCustomElement = defineCustomElement$1;

export { VertexSceneTreeTableHeader, defineCustomElement };

//# sourceMappingURL=vertex-scene-tree-table-header.js.map