/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';

const sceneTreeToolbarGroupCss = ":host{--scene-tree-toolbar-group-item-gap:calc(\n    var(--scene-tree-toolbar-content-gap) / 2\n  );display:flex}::slotted(:not(:first-child)){margin-left:var(--scene-tree-toolbar-group-item-gap)}";

const SceneTreeToolbarGroup = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
  }
  render() {
    return (h(Host, null, h("slot", null)));
  }
  static get style() { return sceneTreeToolbarGroupCss; }
}, [1, "vertex-scene-tree-toolbar-group"]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["vertex-scene-tree-toolbar-group"];
  components.forEach(tagName => { switch (tagName) {
    case "vertex-scene-tree-toolbar-group":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, SceneTreeToolbarGroup);
      }
      break;
  } });
}
defineCustomElement$1();

const VertexSceneTreeToolbarGroup = SceneTreeToolbarGroup;
const defineCustomElement = defineCustomElement$1;

export { VertexSceneTreeToolbarGroup, defineCustomElement };

//# sourceMappingURL=vertex-scene-tree-toolbar-group.js.map