/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';

const viewerButtonCss = ":host{cursor:pointer}.viewer-button{align-items:center;background:none;border:none;color:inherit;cursor:inherit;display:flex;padding:0}";

const ViewerButton = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
  }
  render() {
    return (h(Host, null, h("button", { class: "viewer-button" }, h("slot", null))));
  }
  static get style() { return viewerButtonCss; }
}, [1, "vertex-viewer-button"]);
function defineCustomElement() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["vertex-viewer-button"];
  components.forEach(tagName => { switch (tagName) {
    case "vertex-viewer-button":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, ViewerButton);
      }
      break;
  } });
}
defineCustomElement();

export { ViewerButton as V, defineCustomElement as d };

//# sourceMappingURL=viewer-button.js.map