/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { g as getPinColors } from './model3.js';

const viewerPinLabelLineCss = ":host{--viewer-annotations-pin-label-line-color:var(--viewer-annotations-pin-primary-color);--viewer-annotations-pin-label-line-width:1\n\n  overflow: hidden;pointer-events:none}.label-line{pointer-events:auto;stroke:var(--viewer-annotations-pin-label-line-color);stroke-width:var( --viewer-annotations-pin-label-line-width);cursor:default}.svg{position:absolute;top:0;bottom:0;left:0;right:0;overflow:hidden;pointer-events:none;height:100%;width:100%}";

const VertexPinLabelLine = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
  }
  render() {
    var _a, _b, _c, _d;
    const { primaryColor } = getPinColors(this.pin);
    return (h(Host, null, h("svg", { class: "svg" }, h("line", { class: "label-line", style: {
        stroke: primaryColor,
      }, x1: (_a = this.labelPoint) === null || _a === void 0 ? void 0 : _a.x, y1: (_b = this.labelPoint) === null || _b === void 0 ? void 0 : _b.y, x2: (_c = this.pinPoint) === null || _c === void 0 ? void 0 : _c.x, y2: (_d = this.pinPoint) === null || _d === void 0 ? void 0 : _d.y }))));
  }
  static get style() { return viewerPinLabelLineCss; }
}, [0, "vertex-viewer-pin-label-line", {
    "pinPoint": [16],
    "labelPoint": [16],
    "pin": [16]
  }]);
function defineCustomElement() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["vertex-viewer-pin-label-line"];
  components.forEach(tagName => { switch (tagName) {
    case "vertex-viewer-pin-label-line":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, VertexPinLabelLine);
      }
      break;
  } });
}
defineCustomElement();

export { VertexPinLabelLine as V, defineCustomElement as d };

//# sourceMappingURL=viewer-pin-label-line.js.map