/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
import { proxyCustomElement, HTMLElement, h } from '@stencil/core/internal/client';
import { c as classnames } from './index2.js';

const viewerToolbarGroupCss = ".inner{display:flex;align-items:center;margin:auto}.inner.vertical{flex-direction:column}.inner.horizontal{flex-direction:row}";

const ViewerToolbarGroup = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.direction = 'horizontal';
  }
  render() {
    return (h("div", { class: classnames('inner', {
        horizontal: this.direction === 'horizontal',
        vertical: this.direction === 'vertical',
      }) }, h("slot", null)));
  }
  static get style() { return viewerToolbarGroupCss; }
}, [1, "vertex-viewer-toolbar-group", {
    "direction": [1]
  }]);
function defineCustomElement() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["vertex-viewer-toolbar-group"];
  components.forEach(tagName => { switch (tagName) {
    case "vertex-viewer-toolbar-group":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, ViewerToolbarGroup);
      }
      break;
  } });
}
defineCustomElement();

export { ViewerToolbarGroup as V, defineCustomElement as d };

//# sourceMappingURL=viewer-toolbar-group.js.map