/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
import { p as point, e as rectangle } from './bundle.esm-0508e4f1.js';
import { a as uuid } from './browser.esm-956a68fc.js';

class ArrowMarkup {
  constructor(init) {
    var _a, _b, _c, _d, _e;
    this.start = (_a = init.start) !== null && _a !== void 0 ? _a : point.create();
    this.end = (_b = init.end) !== null && _b !== void 0 ? _b : point.create();
    this.id = (_c = init.id) !== null && _c !== void 0 ? _c : `arrow-markup--${uuid.create()}`;
    this.startLineAnchorStyle = (_d = init.startLineAnchorStyle) !== null && _d !== void 0 ? _d : 'none';
    this.endLineAnchorStyle = (_e = init.endLineAnchorStyle) !== null && _e !== void 0 ? _e : 'arrow-triangle';
  }
}
class CircleMarkup {
  constructor(init) {
    var _a, _b;
    this.bounds = (_a = init.bounds) !== null && _a !== void 0 ? _a : rectangle.create(0, 0, 0, 0);
    this.id = (_b = init.id) !== null && _b !== void 0 ? _b : `circle-markup--${uuid.create()}`;
  }
}
class FreeformMarkup {
  constructor(init) {
    var _a, _b, _c;
    this.bounds = (_a = init.bounds) !== null && _a !== void 0 ? _a : rectangle.create(0, 0, 0, 0);
    this.points = (_b = init.points) !== null && _b !== void 0 ? _b : [];
    this.id = (_c = init.id) !== null && _c !== void 0 ? _c : `freeform-markup--${uuid.create()}`;
  }
}

export { ArrowMarkup as A, CircleMarkup as C, FreeformMarkup as F };

//# sourceMappingURL=markup-66ddf24a.js.map