/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
import { v as vector3 } from './bundle.esm-0508e4f1.js';

/**
 * Constructs a new measurement result from the given points.
 *
 * @param point1 A starting point.
 * @param point2 An ending point.
 * @returns A new measurement result.
 */
function makeMinimumDistanceResult(point1, point2) {
  return {
    type: 'minimum-distance',
    point1,
    point2,
    distance: vector3.distance(point1, point2),
  };
}

export { makeMinimumDistanceResult as m };

//# sourceMappingURL=results-2685e21c.js.map