/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
import { a as readTask, e as writeTask } from './index-fef00dee.js';

// eslint-disable-next-line no-restricted-imports
function readDOM(task) {
  readTask(task);
}
function writeDOM(task) {
  writeTask(task);
}
function debounceEvent(event, wait) {
  let timer = undefined;
  function debounce(value) {
    window.clearTimeout(timer);
    timer = window.setTimeout(() => event.emit(value), wait);
  }
  return {
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    emit: debounce,
    dispose() {
      window.clearTimeout(timer);
    },
  };
}

export { debounceEvent as d, readDOM as r, writeDOM as w };

//# sourceMappingURL=stencil-819ab171.js.map