/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
import { r as registerInstance, h, H as Host } from './index-fef00dee.js';

const sceneTreeTableColumnCss = ":host{width:100%;height:100%;position:relative}.hidden{visibility:hidden;pointer-events:none}.column{display:flex;flex-direction:column;height:100%;width:100%;overflow:hidden}";

const SceneTreeTableColumn = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
  }
  render() {
    return (h(Host, null, h("div", { class: "hidden" }, h("slot", { name: "header" })), h("div", { class: "column" }, h("slot", null))));
  }
};
SceneTreeTableColumn.style = sceneTreeTableColumnCss;

export { SceneTreeTableColumn as vertex_scene_tree_table_column };

//# sourceMappingURL=vertex-scene-tree-table-column.entry.js.map