/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
import { r as registerInstance, h, H as Host } from './index-fef00dee.js';

const sceneTreeTableHeaderCss = ":host{width:100%;box-sizing:border-box}.header{display:flex;align-items:center;box-sizing:border-box;font-size:0.875rem;white-space:nowrap;overflow:hidden;padding:0.5rem 0}";

const SceneTreeTableHeader = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
  }
  render() {
    return (h(Host, null, h("div", { class: "header" }, h("slot", null))));
  }
};
SceneTreeTableHeader.style = sceneTreeTableHeaderCss;

export { SceneTreeTableHeader as vertex_scene_tree_table_header };

//# sourceMappingURL=vertex-scene-tree-table-header.entry.js.map