/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
import { r as registerInstance, h, H as Host } from './index-fef00dee.js';
import { c as classnames } from './index-eb6950b9.js';
import './_commonjsHelpers-6e425ac3.js';

const viewerAnnotationCalloutCss = ":host{display:block;--viewer-annotation-callout-primary-color:var(--blue-700);--viewer-annotation-callout-accent-color:var(--white)}.content{display:flex;align-items:center;box-sizing:border-box;justify-content:center;background-color:var(--viewer-annotation-callout-primary-color);border:1px solid var(--viewer-annotation-callout-accent-color)}.content.sm{border-radius:14px;width:28px;height:28px}.content.md{border-radius:19px;width:38px;height:38px}.content.lg{border-radius:24px;width:48px;height:48px}.icon{color:var(--viewer-annotation-callout-accent-color)}";

const ViewerAnnotationCallout = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    /**
     * The icon size to display.
     */
    this.iconSize = 'sm';
  }
  render() {
    return (h(Host, null, h("div", { class: classnames('content', this.iconSize), style: {
        borderColor: this.data.accentColor,
        backgroundColor: this.data.primaryColor,
      } }, h("vertex-viewer-icon", { class: "icon", name: this.data.icon, size: this.iconSize, style: { color: this.data.accentColor } }))));
  }
};
ViewerAnnotationCallout.style = viewerAnnotationCalloutCss;

export { ViewerAnnotationCallout as vertex_viewer_annotation_callout };

//# sourceMappingURL=vertex-viewer-annotation-callout.entry.js.map