import { CustomError } from '../../../lib/errors';
export declare enum SceneTreeErrorCode {
  UNKNOWN = 0,
  SCENE_TREE_DISABLED = 1,
  MISSING_VIEWER = 2,
  DISCONNECTED = 3,
  SUBSCRIPTION_FAILURE = 4,
  UNAUTHORIZED = 5,
  ABORTED = 6
}
export declare class SceneTreeErrorDetails {
  readonly name: keyof typeof SceneTreeErrorCode;
  readonly code: SceneTreeErrorCode;
  readonly link?: string | undefined;
  readonly message: string;
  constructor(name: keyof typeof SceneTreeErrorCode, code: SceneTreeErrorCode, link?: string | undefined);
}
export declare class SceneTreeError extends CustomError {
  constructor(message: string, e?: Error);
}
export declare class SceneTreeUnauthorizedError extends SceneTreeError {
  constructor(message: string, e?: Error);
}
export declare class SceneTreeConnectionCancelledError extends SceneTreeError {
  constructor(message: string, e?: Error);
}
export declare class SceneTreeOperationFailedError extends SceneTreeError {
  constructor(message: string, e?: Error);
}
