export declare const DEFAULT_SCENE_TREE_OP_ANIMATION_MS = 500;
export interface ViewerItemOptions {
  suppliedCorrelationId?: string;
}
export interface ViewerSelectItemOptions extends ViewerItemOptions {
  append?: boolean;
  range?: boolean;
}
export interface ViewerIsolateItemOptions extends ViewerItemOptions {
  animationDurationMs?: number;
}
export declare function showItem(viewer: HTMLVertexViewerElement, id: string, { suppliedCorrelationId }?: ViewerItemOptions): Promise<void>;
export declare function hideItem(viewer: HTMLVertexViewerElement, id: string, { suppliedCorrelationId }?: ViewerItemOptions): Promise<void>;
export declare function selectItem(viewer: HTMLVertexViewerElement, id: string, { append, suppliedCorrelationId }: ViewerSelectItemOptions): Promise<void>;
export declare function selectRangeInSceneTree(viewer: HTMLVertexViewerElement, start: number, end: number, { append, suppliedCorrelationId }: ViewerSelectItemOptions): Promise<void>;
export declare function selectFilterResults(viewer: HTMLVertexViewerElement, filter: string, keys: string[], exactMatch: boolean, removeHiddenResults: boolean, { append, suppliedCorrelationId }: ViewerSelectItemOptions): Promise<void>;
export declare function deselectItem(viewer: HTMLVertexViewerElement, id: string, { suppliedCorrelationId }?: ViewerItemOptions): Promise<void>;
export declare function isolateItem(viewer: HTMLVertexViewerElement, id: string, { suppliedCorrelationId, animationDurationMs }?: ViewerIsolateItemOptions): Promise<void>;
