import { h } from '../../stencil-public-runtime';
import { ViewerToolbarPlacement } from '../viewer-toolbar/types';
import { ViewerToolbarGroupDirection } from '../viewer-toolbar-group/types';
export declare class ViewerDefaultToolbar {
  /**
   * An instance of the viewer that operations will be performed on. If
   * contained within a `<vertex-viewer>` element, this property will
   * automatically be wired.
   */
  viewer?: HTMLVertexViewerElement;
  /**
   * Specifies where the toolbar is positioned.
   */
  placement: ViewerToolbarPlacement;
  /**
   * Specifies the direction that UI elements are placed.
   */
  direction: ViewerToolbarGroupDirection;
  /**
   * Indicates whether animations will be used when performing camera
   * operations. Defaults to `true`.
   */
  animationsDisabled: boolean;
  /**
   * The duration of animations, in milliseconds. Defaults to `1000`.
   */
  animationMs: number;
  render(): h.JSX.IntrinsicElements;
  private viewAll;
}
