import { h } from '../../stencil-public-runtime';
/**
 * The names of the icons that the `<vertex-viewer-icon>` element can display.
 */
export declare type ViewerIconName = 'chevron-down' | 'chevron-right' | 'close-circle' | 'comment-filled' | 'comment-show' | 'eye-half' | 'eye-half-dotted' | 'eye-open' | 'fit-all' | 'locate' | 'pin-fill' | 'search';
/**
 * The predefined sizes for icons.
 */
export declare type ViewerIconSize = 'sm' | 'md' | 'lg' | undefined;
export declare class ViewerIcon {
  /**
   * The name of the icon to render.
   */
  name?: ViewerIconName;
  /**
   * The size of the icon. Can be `'sm' | 'md' | 'lg' | undefined`. Predefined
   * sizes are set to:
   *
   *  * `sm`: 16px
   *  * `md`: 24px
   *  * `lg`: 32px
   *
   * A custom size can be supplied by setting this field to `undefined` and
   * setting `font-size` through CSS. Defaults to `md`.
   */
  size?: ViewerIconSize;
  render(): h.JSX.IntrinsicElements;
  private renderSvgIcon;
}
