import type { EventEmitter } from '../../stencil-public-runtime';
import { MarkupInteractionHandler } from '../../lib/markup/interactions';
import { MarkupInteraction } from '../../lib/types/markup';
declare type ViewerMarkupArrowEditAnchor = 'start' | 'end' | 'center';
export declare class ArrowMarkupInteractionHandler extends MarkupInteractionHandler {
  private readonly markupEl;
  private readonly interactionBegin;
  private readonly interactionEnd;
  private pointerId?;
  private anchor;
  constructor(markupEl: HTMLVertexViewerMarkupArrowElement, interactionBegin: EventEmitter<void>, interactionEnd: EventEmitter<MarkupInteraction>);
  editAnchor(anchor: ViewerMarkupArrowEditAnchor, event: PointerEvent): void;
  startInteraction(event: PointerEvent): void;
  protected computeBoundingRect(): DOMRect;
  protected handleInteractionAttempt(event: PointerEvent): void;
  protected handleInteractionMove(event: PointerEvent): void;
  protected handleInteractionEnd(event: PointerEvent): void;
}
export {};
