import * as Point from '../../../../geometry/src/point';
export declare type LineAnchorStyle = 'arrow-triangle' | 'arrow-line' | 'dot' | 'hash' | 'none';
export interface LineAnchorStylePoints {
  tip: Point.Point;
  base: Point.Point;
  arrowTriangle: ArrowheadPoints;
  arrowLine: ArrowheadPoints;
  hash: ArrowheadPoints;
  radius: number;
}
export interface ArrowheadPoints {
  leftPoint: Point.Point;
  rightPoint: Point.Point;
}
export declare function createArrowheadPoints(start: Point.Point, end: Point.Point, arrowSideLength: number, arrowHeadTheta: number): ArrowheadPoints;
export declare function createLineAnchorStylePoints(start: Point.Point, end: Point.Point, triangleArrowAngle?: number, lineArrowAngle?: number): LineAnchorStylePoints;
export declare function arrowheadPointsToPolygonPoints(points: LineAnchorStylePoints): string;
export declare function arrowheadPointsToPathPoints(points: LineAnchorStylePoints): string;
export declare function isVertexViewerArrowMarkup(el: unknown): el is HTMLVertexViewerMarkupArrowElement;
export declare function parsePoint(value: string | Point.Point | undefined): Point.Point | undefined;
