import { FunctionalComponent } from '../../stencil-public-runtime';
import { Formatter } from '../../lib/formatter';
import { MeasurementOverlay, MeasurementOverlayManager, MeasurementResult, MinimumDistanceMeasurementResult, PlanarAngleMeasurementResult, PlanarDistanceMeasurementResult, SurfaceAreaMeasurementResult } from '../../lib/measurement';
interface MeasurementResultEntryProps<R extends MeasurementResult> {
  result: R;
  overlays?: MeasurementOverlayManager;
  formatter: Formatter<number>;
  onShowOverlay: (overlay: MeasurementOverlay | undefined) => void;
  onHideOverlay: () => void;
}
export declare const MinimumDistanceResultEntry: FunctionalComponent<MeasurementResultEntryProps<MinimumDistanceMeasurementResult>>;
export declare const PlanarAngleResultEntry: FunctionalComponent<MeasurementResultEntryProps<PlanarAngleMeasurementResult>>;
export declare const PlanarDistanceResultEntry: FunctionalComponent<MeasurementResultEntryProps<PlanarDistanceMeasurementResult>>;
export declare const SurfaceAreaResultEntry: FunctionalComponent<MeasurementResultEntryProps<SurfaceAreaMeasurementResult>>;
export {};
