import { Line3, Point } from '@vertexvis/geometry';
import { FrameCameraBase, Viewport } from '../../lib/types';
export declare type Anchor = 'start' | 'end';
export interface MeasurementElementPositions {
  startPt?: Point.Point;
  endPt?: Point.Point;
  labelPt?: Point.Point;
  indicatorPt?: Point.Point;
  hideStart?: boolean;
  hideEnd?: boolean;
}
export interface RenderParams {
  viewport: Viewport;
  camera: FrameCameraBase;
}
export declare function translateWorldLineToViewport(line: Line3.Line3, params: RenderParams): {
  start: Point.Point;
  end: Point.Point;
  hideStart: boolean;
  hideEnd: boolean;
};
export declare function getViewingElementPositions(line: Line3.Line3, interactingAnchor: Anchor | 'none', params: RenderParams): MeasurementElementPositions;
export declare function isVertexViewerDistanceMeasurement(el: unknown): el is HTMLVertexViewerMeasurementDistanceElement;
