import { h } from '../../stencil-public-runtime';
import { Point } from '@vertexvis/geometry';
export declare class ViewerMeasurementLine {
  /**
   * A point that specifies the starting point of the line.
   */
  start: Point.Point;
  /**
   * A point that specifies the ending point of the line.
   */
  end: Point.Point;
  /**
   * A length of the line cap. The line cap is a line at each end of a line.
   */
  capLength: number;
  /**
   * The type of [SVG pointer
   * events](https://developer.mozilla.org/en-US/docs/Web/SVG/Attribute/pointer-events)
   * that the line should respond to.
   */
  pointerEvents: string;
  /**
   * @ignore
   */
  protected render(): h.JSX.IntrinsicElements;
}
