import { h } from '../../stencil-public-runtime';
import { MeasurementOverlayManager } from '../../lib/measurement';
import { FrameCameraBase } from '../../lib/types';
export declare class ViewerMeasurementOverlays {
  /**
   * The model that contains the overlays to present.
   */
  measurementOverlays: MeasurementOverlayManager;
  private onOverlaysChangedListener?;
  /**
   * @ignore
   */
  protected handleMeasurementOverlaysChanged(): void;
  /**
   * @internal
   */
  camera?: FrameCameraBase;
  /**
   * The viewer that this component is bound to.
   */
  viewer?: HTMLVertexViewerElement;
  /**
   * @ignore
   */
  protected handleViewerChanged(newViewer?: HTMLVertexViewerElement, oldViewer?: HTMLVertexViewerElement): void;
  private overlays;
  /**
   * @ignore
   */
  protected componentWillLoad(): void;
  private addModelListeners;
  private removeModelListeners;
  private addViewerListeners;
  private removeViewerListeners;
  private updateCamera;
  private updateOverlays;
  /**
   * @ignore
   */
  protected render(): h.JSX.IntrinsicElements;
}
