import { h } from '../../stencil-public-runtime';
/**
 * The predefined sizes for the spinner.
 */
export declare type SpinnerSize = 'xs' | 'sm' | 'md' | 'lg' | undefined;
export declare class ViewerSpinner {
  /**
   * The size of the spinner. Can be `'xs' | 'sm' | 'md' | 'lg' | undefined`. Predefined
   * sizes are set to:
   *
   *  * `xm`: 16px
   *  * `sm`: 24px
   *  * `md`: 32px
   *  * `lg`: 64px
   */
  size?: SpinnerSize;
  render(): h.JSX.IntrinsicElements;
}
