import { Matrix4, Point, Rectangle, Vector3 } from '@vertexvis/geometry';
import { AngleUnitType, DistanceUnitType, Frame, Viewport } from '../../lib/types';
import { TransformWidgetInputPlacement } from './viewer-transform-widget-components';
export interface PointAndPlacement {
  point: Point.Point;
  placement: TransformWidgetInputPlacement;
}
export declare function convertPointToCanvas(point: Point.Point, bounds?: DOMRect): Point.Point | undefined;
export declare function convertCanvasPointToWorld(point?: Point.Point, frame?: Frame, viewport?: Viewport, transform?: Matrix4.Matrix4): Vector3.Vector3 | undefined;
export declare function computeInputDeltaTransform(current: Matrix4.Matrix4, identifier: string, value: number, lastValue: number, distanceUnit: DistanceUnitType, angleUnit: AngleUnitType): Matrix4.Matrix4;
export declare function computeInputDisplayValue(identifier: string, current: Matrix4.Matrix4, start: Matrix4.Matrix4, distanceUnit: DistanceUnitType, angleUnit: AngleUnitType): number;
export declare function computeHandleDeltaTransform(current: Matrix4.Matrix4, previous: Vector3.Vector3, next: Vector3.Vector3, viewVector: Vector3.Vector3, angle: number, identifier: string): Matrix4.Matrix4;
export declare function computeRotationAxis(current: Matrix4.Matrix4, viewVector: Vector3.Vector3, axis: Vector3.Vector3): Vector3.Vector3;
export declare function computeTranslation(current: Matrix4.Matrix4, axis: Vector3.Vector3, delta: Vector3.Vector3): Matrix4.Matrix4;
export declare function computeInputPosition(viewport: Viewport, bounds: Rectangle.Rectangle, shapePoints: Point.Point[]): PointAndPlacement;
