import { FunctionalComponent } from '../../stencil-public-runtime';
import { Point } from '@vertexvis/geometry';
import { AngleUnits, DistanceUnits, Viewport } from '../../lib/types';
export declare type TransformWidgetInputPlacement = 'top-left' | 'top-right' | 'bottom-left' | 'bottom-right';
export interface TransformWidgetInputWrapperProps {
  ref: (el?: HTMLDivElement) => void;
  bounds?: DOMRect;
  viewport: Viewport;
  point: Point.Point;
  placement: TransformWidgetInputPlacement;
  displayUnit: DistanceUnits | AngleUnits;
}
export declare const TransformWidgetInputWrapper: FunctionalComponent<TransformWidgetInputWrapperProps>;
export interface TransformWidgetInputProps {
  ref: (el?: HTMLInputElement) => void;
  identifier?: string;
  disabled?: boolean;
  onChange?: (value: number) => void | Promise<void>;
  onIncrement?: VoidFunction;
  onDecrement?: VoidFunction;
  onBlur?: VoidFunction;
  onUndo?: VoidFunction;
}
export declare const TransformWidgetInput: FunctionalComponent<TransformWidgetInputProps>;
