import { Point } from '@vertexvis/geometry';
import { InteractionApi } from './interactionApi';
import { InteractionHandler } from './interactionHandler';
export declare abstract class MultiTouchInteractionHandler implements InteractionHandler {
  protected element?: HTMLElement;
  protected interactionApi?: InteractionApi;
  private previousFirstPoints;
  private previousSecondPoints;
  initialize(element: HTMLElement, api: InteractionApi): void;
  dispose(): void;
  protected beginTwoPointTouch(point1: Point.Point, point2: Point.Point): void;
  protected handleTwoPointTouchMove(point1: Point.Point, point2: Point.Point): void;
  protected endTwoPointTouch(): void;
  private computeDelta;
  private computeZoom;
  private computeAngle;
}
