import { Disposable } from '@vertexvis/utils';
import { ConfigProvider } from '../config';
import { InteractionApi } from './interactionApi';
import { PanInteraction, PivotInteraction, RotateInteraction, RotatePointInteraction, TwistInteraction, ZoomInteraction } from './mouseInteractions';
import { MultiElementInteractionHandler } from './multiElementInteractionHandler';
export declare class PointerInteractionHandler extends MultiElementInteractionHandler {
  private touchPoints;
  constructor(getConfig: ConfigProvider, rotateInteraction?: RotateInteraction, rotatePointInteraction?: RotatePointInteraction, zoomInteraction?: ZoomInteraction, panInteraction?: PanInteraction, twistInteraction?: TwistInteraction, pivotInteraction?: PivotInteraction);
  initialize(element: HTMLElement, api: InteractionApi): void;
  addEventListenersToElement(element: HTMLElement): Disposable;
  private handlePointerDown;
  private handlePointerUp;
}
