import type { InteractionApi, InteractionHandler } from '../interactions';
export declare abstract class MarkupInteractionHandler implements InteractionHandler {
  protected element?: HTMLElement;
  protected elementBounds?: DOMRect;
  protected api?: InteractionApi;
  private resizeObserver;
  constructor();
  initialize(element: HTMLElement, api: InteractionApi): void;
  dispose(): void;
  protected acceptInteraction(): void;
  private handlePointerDown;
  private handlePointerMove;
  private handlePointerUp;
  protected abstract computeBoundingRect(): DOMRect;
  protected abstract handleInteractionAttempt(event: PointerEvent): void;
  protected abstract handleInteractionMove(event: PointerEvent): void;
  protected abstract handleInteractionEnd(event: PointerEvent): void;
}
