import { RequestMessageHandler, StreamApi } from '@vertexvis/stream-api';
import { SynchronizedClock } from '../types';
/**
 * Returns a request handler that will acknowledge any frame requests that it
 * receives.
 *
 * @param api The client to acknowledge frames from.
 * @param clock A function that returns a synchronized clock.
 */
export declare function acknowledgeFrameRequests(api: StreamApi, clockProvider: () => SynchronizedClock | undefined): RequestMessageHandler;
