import { StreamApi } from '@vertexvis/stream-api';
import type { FrameDecoder } from '../mappers';
import { StreamApiEventDispatcher } from '../stream/dispatcher';
import { Result } from '../stream/result';
import { Frame } from '../types';
export interface RenderResultIds {
  animationId?: string;
  correlationId?: string;
}
export declare class CameraRenderResult implements Result {
  data: undefined;
  onAnimationCompleted: StreamApiEventDispatcher<string>;
  onFrameReceived: StreamApiEventDispatcher<Frame>;
  constructor(stream: StreamApi, decodeFrame: FrameDecoder, { animationId, correlationId }: RenderResultIds, timeout?: number);
}
