import { Color } from '@vertexvis/utils';
/**
 * The `ColorMaterial` interface is here.
 */
export interface ColorMaterial {
  opacity: number;
  glossiness: number;
  diffuse: Color.Color;
  ambient: Color.Color;
  specular: Color.Color;
  emissive: Color.Color;
}
export declare const defaultColor: ColorMaterial;
/**
 * This helper creates an rgb value color
 * @param hex
 * @param opacity
 */
export declare const create: (r: number, g: number, b: number, opacity?: number | undefined) => ColorMaterial;
/**
 * This helper converts a hex string to a ColorMaterial object
 * @param hex
 * @param opacity
 */
export declare const fromHex: (hex: string, opacity?: number | undefined) => ColorMaterial;
