/**
 * An enumeration of the possible types of entities in a frame.
 */
export declare enum EntityType {
  /**
   * A value that represents the presence of a cross-section.
   */
  CROSS_SECTION = 255,
  /**
   * A value that represents the presence of an edge with BREP.
   */
  PRECISE_EDGE = 224,
  /**
   * A value that represents the presence of a surface with BREP.
   */
  PRECISE_SURFACE = 192,
  /**
   * A value that represents the presence of an edge without BREP.
   */
  IMPRECISE_EDGE = 160,
  /**
   * A value that represents the presence of a surface without BREP.
   */
  IMPRECISE_SURFACE = 128,
  /**
   * A value that represents the presence of geometry without BREP.
   */
  GENERIC_GEOMETRY = 96,
  /**
   * A value that represents the absence of geometry.
   */
  NO_GEOMETRY = 0
}
