import { BoundingBox } from '@vertexvis/geometry';
import { FrameCamera } from './frameCamera';
interface FlyToSuppliedId {
  type: 'supplied';
  data: string;
}
interface FlyToItemId {
  type: 'internal';
  data: string;
}
interface FlyToBoundingBox {
  type: 'bounding-box';
  data: BoundingBox.BoundingBox;
}
interface FlyToCamera {
  type: 'camera';
  data: Partial<FrameCamera>;
}
export declare type FlyToType = FlyToSuppliedId | FlyToItemId | FlyToBoundingBox | FlyToCamera;
export interface FlyToOptions {
  flyTo: FlyToType;
}
export declare function create(data?: Partial<FlyToOptions>): FlyToOptions;
export {};
