import { UUID } from '@vertexvis/utils';
export interface SceneViewStateId {
  id: UUID.UUID;
}
export interface SceneViewStateSuppliedId {
  suppliedId: string;
}
/**
 * An object describing an ID for the scene view state. Can either be an
 * object containing the ID generated on creation, or an object containing
 * a supplied id provided during creation.
 */
export declare type SceneViewStateIdentifier = SceneViewStateId | SceneViewStateSuppliedId;
export declare function isSceneViewStateId(identifier: SceneViewStateIdentifier): identifier is SceneViewStateId;
export declare function isSceneViewStateSuppliedId(identifier: SceneViewStateIdentifier): identifier is SceneViewStateSuppliedId;
