/**
 * Runs a function that contains assertions until they pass, or until the number
 * of attempts are exhausted. This helper is handy for async operations where
 * you are not able to know if they've completed or not.
 *
 * @example
 *
 * test('it works', async () => {
 *   await eventually(() => expect(1 + 1).toEqual(2));
 * })
 */
export declare function eventually(assertions: () => void | Promise<void>, { attempts, delay }?: {
  attempts?: number;
  delay?: number;
}): Promise<void>;
