/*!
 * Copyright (c) 2025 Vertex Software LLC. All rights reserved.
 */
import { g as googleProtobuf, w as wrappers_pb, a as grpcWebClient_umd } from './wrappers_pb.js';
import { u as uuid_pb, p as paging_pb, C as CustomError } from './errors.js';
import { c as createCommonjsModule } from './_commonjsHelpers.js';
import { E as EventDispatcher } from './browser.esm.js';
import { i as isLoadedRow, f as fromNodeProto } from './row.js';

var domain_pb = createCommonjsModule(function (module, exports) {
/**
 * @fileoverview
 * @enhanceable
 * @suppress {messageConventions} JS Compiler reports an error if a variable or
 *     field starts with 'MSG_' and isn't a translatable message.
 * @public
 */
// GENERATED CODE -- DO NOT EDIT!


var goog = googleProtobuf;
var global = Function('return this')();



goog.exportSymbol('proto.vertexvis.protobuf.scenetree.v1alpha1.ColumnKey', null, global);
goog.exportSymbol('proto.vertexvis.protobuf.scenetree.v1alpha1.FilterChange', null, global);
goog.exportSymbol('proto.vertexvis.protobuf.scenetree.v1alpha1.KeepAlive', null, global);
goog.exportSymbol('proto.vertexvis.protobuf.scenetree.v1alpha1.ListChange', null, global);
goog.exportSymbol('proto.vertexvis.protobuf.scenetree.v1alpha1.Node', null, global);
goog.exportSymbol('proto.vertexvis.protobuf.scenetree.v1alpha1.Range', null, global);
goog.exportSymbol('proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange', null, global);
goog.exportSymbol('proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType', null, global);

/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node = function(opt_data) {
  googleProtobuf.Message.initialize(this, opt_data, 0, -1, proto.vertexvis.protobuf.scenetree.v1alpha1.Node.repeatedFields_, null);
};
goog.inherits(proto.vertexvis.protobuf.scenetree.v1alpha1.Node, googleProtobuf.Message);
if (goog.DEBUG && !COMPILED) {
  proto.vertexvis.protobuf.scenetree.v1alpha1.Node.displayName = 'proto.vertexvis.protobuf.scenetree.v1alpha1.Node';
}
/**
 * List of repeated fields within this message type.
 * @private {!Array<number>}
 * @const
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node.repeatedFields_ = [10];



if (googleProtobuf.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto suitable for use in Soy templates.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     com.google.apps.jspb.JsClassTemplate.JS_RESERVED_WORDS.
 * @param {boolean=} opt_includeInstance Whether to include the JSPB instance
 *     for transitional soy proto support: http://goto/soy-param-migration
 * @return {!Object}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node.prototype.toObject = function(opt_includeInstance) {
  return proto.vertexvis.protobuf.scenetree.v1alpha1.Node.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Whether to include the JSPB
 *     instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.Node} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node.toObject = function(includeInstance, msg) {
  var f, obj = {
    id: (f = msg.getId()) && uuid_pb.Uuid.toObject(includeInstance, f),
    depth: googleProtobuf.Message.getFieldWithDefault(msg, 2, 0),
    name: googleProtobuf.Message.getFieldWithDefault(msg, 3, ""),
    visible: googleProtobuf.Message.getFieldWithDefault(msg, 4, false),
    selected: googleProtobuf.Message.getFieldWithDefault(msg, 5, false),
    expanded: googleProtobuf.Message.getFieldWithDefault(msg, 6, false),
    isLeaf: googleProtobuf.Message.getFieldWithDefault(msg, 7, false),
    suppliedId: (f = msg.getSuppliedId()) && wrappers_pb.StringValue.toObject(includeInstance, f),
    partiallyVisible: googleProtobuf.Message.getFieldWithDefault(msg, 9, false),
    columnsList: googleProtobuf.Message.getRepeatedField(msg, 10),
    filterHit: googleProtobuf.Message.getFieldWithDefault(msg, 11, false),
    phantom: googleProtobuf.Message.getFieldWithDefault(msg, 12, false),
    endItem: googleProtobuf.Message.getFieldWithDefault(msg, 13, false)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.Node}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node.deserializeBinary = function(bytes) {
  var reader = new googleProtobuf.BinaryReader(bytes);
  var msg = new proto.vertexvis.protobuf.scenetree.v1alpha1.Node;
  return proto.vertexvis.protobuf.scenetree.v1alpha1.Node.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.Node} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.Node}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = new uuid_pb.Uuid;
      reader.readMessage(value,uuid_pb.Uuid.deserializeBinaryFromReader);
      msg.setId(value);
      break;
    case 2:
      var value = /** @type {number} */ (reader.readUint32());
      msg.setDepth(value);
      break;
    case 3:
      var value = /** @type {string} */ (reader.readString());
      msg.setName(value);
      break;
    case 4:
      var value = /** @type {boolean} */ (reader.readBool());
      msg.setVisible(value);
      break;
    case 5:
      var value = /** @type {boolean} */ (reader.readBool());
      msg.setSelected(value);
      break;
    case 6:
      var value = /** @type {boolean} */ (reader.readBool());
      msg.setExpanded(value);
      break;
    case 7:
      var value = /** @type {boolean} */ (reader.readBool());
      msg.setIsLeaf(value);
      break;
    case 8:
      var value = new wrappers_pb.StringValue;
      reader.readMessage(value,wrappers_pb.StringValue.deserializeBinaryFromReader);
      msg.setSuppliedId(value);
      break;
    case 9:
      var value = /** @type {boolean} */ (reader.readBool());
      msg.setPartiallyVisible(value);
      break;
    case 10:
      var value = /** @type {string} */ (reader.readString());
      msg.addColumns(value);
      break;
    case 11:
      var value = /** @type {boolean} */ (reader.readBool());
      msg.setFilterHit(value);
      break;
    case 12:
      var value = /** @type {boolean} */ (reader.readBool());
      msg.setPhantom(value);
      break;
    case 13:
      var value = /** @type {boolean} */ (reader.readBool());
      msg.setEndItem(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node.prototype.serializeBinary = function() {
  var writer = new googleProtobuf.BinaryWriter();
  proto.vertexvis.protobuf.scenetree.v1alpha1.Node.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.Node} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getId();
  if (f != null) {
    writer.writeMessage(
      1,
      f,
      uuid_pb.Uuid.serializeBinaryToWriter
    );
  }
  f = message.getDepth();
  if (f !== 0) {
    writer.writeUint32(
      2,
      f
    );
  }
  f = message.getName();
  if (f.length > 0) {
    writer.writeString(
      3,
      f
    );
  }
  f = message.getVisible();
  if (f) {
    writer.writeBool(
      4,
      f
    );
  }
  f = message.getSelected();
  if (f) {
    writer.writeBool(
      5,
      f
    );
  }
  f = message.getExpanded();
  if (f) {
    writer.writeBool(
      6,
      f
    );
  }
  f = message.getIsLeaf();
  if (f) {
    writer.writeBool(
      7,
      f
    );
  }
  f = message.getSuppliedId();
  if (f != null) {
    writer.writeMessage(
      8,
      f,
      wrappers_pb.StringValue.serializeBinaryToWriter
    );
  }
  f = message.getPartiallyVisible();
  if (f) {
    writer.writeBool(
      9,
      f
    );
  }
  f = message.getColumnsList();
  if (f.length > 0) {
    writer.writeRepeatedString(
      10,
      f
    );
  }
  f = message.getFilterHit();
  if (f) {
    writer.writeBool(
      11,
      f
    );
  }
  f = message.getPhantom();
  if (f) {
    writer.writeBool(
      12,
      f
    );
  }
  f = message.getEndItem();
  if (f) {
    writer.writeBool(
      13,
      f
    );
  }
};


/**
 * optional vertexvis.protobuf.core.Uuid id = 1;
 * @return {?proto.vertexvis.protobuf.core.Uuid}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node.prototype.getId = function() {
  return /** @type{?proto.vertexvis.protobuf.core.Uuid} */ (
    googleProtobuf.Message.getWrapperField(this, uuid_pb.Uuid, 1));
};


/** @param {?proto.vertexvis.protobuf.core.Uuid|undefined} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node.prototype.setId = function(value) {
  googleProtobuf.Message.setWrapperField(this, 1, value);
};


proto.vertexvis.protobuf.scenetree.v1alpha1.Node.prototype.clearId = function() {
  this.setId(undefined);
};


/**
 * Returns whether this field is set.
 * @return {!boolean}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node.prototype.hasId = function() {
  return googleProtobuf.Message.getField(this, 1) != null;
};


/**
 * optional uint32 depth = 2;
 * @return {number}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node.prototype.getDepth = function() {
  return /** @type {number} */ (googleProtobuf.Message.getFieldWithDefault(this, 2, 0));
};


/** @param {number} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node.prototype.setDepth = function(value) {
  googleProtobuf.Message.setProto3IntField(this, 2, value);
};


/**
 * optional string name = 3;
 * @return {string}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node.prototype.getName = function() {
  return /** @type {string} */ (googleProtobuf.Message.getFieldWithDefault(this, 3, ""));
};


/** @param {string} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node.prototype.setName = function(value) {
  googleProtobuf.Message.setProto3StringField(this, 3, value);
};


/**
 * optional bool visible = 4;
 * Note that Boolean fields may be set to 0/1 when serialized from a Java server.
 * You should avoid comparisons like {@code val === true/false} in those cases.
 * @return {boolean}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node.prototype.getVisible = function() {
  return /** @type {boolean} */ (googleProtobuf.Message.getFieldWithDefault(this, 4, false));
};


/** @param {boolean} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node.prototype.setVisible = function(value) {
  googleProtobuf.Message.setProto3BooleanField(this, 4, value);
};


/**
 * optional bool selected = 5;
 * Note that Boolean fields may be set to 0/1 when serialized from a Java server.
 * You should avoid comparisons like {@code val === true/false} in those cases.
 * @return {boolean}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node.prototype.getSelected = function() {
  return /** @type {boolean} */ (googleProtobuf.Message.getFieldWithDefault(this, 5, false));
};


/** @param {boolean} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node.prototype.setSelected = function(value) {
  googleProtobuf.Message.setProto3BooleanField(this, 5, value);
};


/**
 * optional bool expanded = 6;
 * Note that Boolean fields may be set to 0/1 when serialized from a Java server.
 * You should avoid comparisons like {@code val === true/false} in those cases.
 * @return {boolean}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node.prototype.getExpanded = function() {
  return /** @type {boolean} */ (googleProtobuf.Message.getFieldWithDefault(this, 6, false));
};


/** @param {boolean} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node.prototype.setExpanded = function(value) {
  googleProtobuf.Message.setProto3BooleanField(this, 6, value);
};


/**
 * optional bool is_leaf = 7;
 * Note that Boolean fields may be set to 0/1 when serialized from a Java server.
 * You should avoid comparisons like {@code val === true/false} in those cases.
 * @return {boolean}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node.prototype.getIsLeaf = function() {
  return /** @type {boolean} */ (googleProtobuf.Message.getFieldWithDefault(this, 7, false));
};


/** @param {boolean} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node.prototype.setIsLeaf = function(value) {
  googleProtobuf.Message.setProto3BooleanField(this, 7, value);
};


/**
 * optional google.protobuf.StringValue supplied_id = 8;
 * @return {?proto.google.protobuf.StringValue}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node.prototype.getSuppliedId = function() {
  return /** @type{?proto.google.protobuf.StringValue} */ (
    googleProtobuf.Message.getWrapperField(this, wrappers_pb.StringValue, 8));
};


/** @param {?proto.google.protobuf.StringValue|undefined} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node.prototype.setSuppliedId = function(value) {
  googleProtobuf.Message.setWrapperField(this, 8, value);
};


proto.vertexvis.protobuf.scenetree.v1alpha1.Node.prototype.clearSuppliedId = function() {
  this.setSuppliedId(undefined);
};


/**
 * Returns whether this field is set.
 * @return {!boolean}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node.prototype.hasSuppliedId = function() {
  return googleProtobuf.Message.getField(this, 8) != null;
};


/**
 * optional bool partially_visible = 9;
 * Note that Boolean fields may be set to 0/1 when serialized from a Java server.
 * You should avoid comparisons like {@code val === true/false} in those cases.
 * @return {boolean}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node.prototype.getPartiallyVisible = function() {
  return /** @type {boolean} */ (googleProtobuf.Message.getFieldWithDefault(this, 9, false));
};


/** @param {boolean} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node.prototype.setPartiallyVisible = function(value) {
  googleProtobuf.Message.setProto3BooleanField(this, 9, value);
};


/**
 * repeated string columns = 10;
 * @return {!Array<string>}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node.prototype.getColumnsList = function() {
  return /** @type {!Array<string>} */ (googleProtobuf.Message.getRepeatedField(this, 10));
};


/** @param {!Array<string>} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node.prototype.setColumnsList = function(value) {
  googleProtobuf.Message.setField(this, 10, value || []);
};


/**
 * @param {!string} value
 * @param {number=} opt_index
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node.prototype.addColumns = function(value, opt_index) {
  googleProtobuf.Message.addToRepeatedField(this, 10, value, opt_index);
};


proto.vertexvis.protobuf.scenetree.v1alpha1.Node.prototype.clearColumnsList = function() {
  this.setColumnsList([]);
};


/**
 * optional bool filter_hit = 11;
 * Note that Boolean fields may be set to 0/1 when serialized from a Java server.
 * You should avoid comparisons like {@code val === true/false} in those cases.
 * @return {boolean}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node.prototype.getFilterHit = function() {
  return /** @type {boolean} */ (googleProtobuf.Message.getFieldWithDefault(this, 11, false));
};


/** @param {boolean} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node.prototype.setFilterHit = function(value) {
  googleProtobuf.Message.setProto3BooleanField(this, 11, value);
};


/**
 * optional bool phantom = 12;
 * Note that Boolean fields may be set to 0/1 when serialized from a Java server.
 * You should avoid comparisons like {@code val === true/false} in those cases.
 * @return {boolean}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node.prototype.getPhantom = function() {
  return /** @type {boolean} */ (googleProtobuf.Message.getFieldWithDefault(this, 12, false));
};


/** @param {boolean} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node.prototype.setPhantom = function(value) {
  googleProtobuf.Message.setProto3BooleanField(this, 12, value);
};


/**
 * optional bool end_item = 13;
 * Note that Boolean fields may be set to 0/1 when serialized from a Java server.
 * You should avoid comparisons like {@code val === true/false} in those cases.
 * @return {boolean}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node.prototype.getEndItem = function() {
  return /** @type {boolean} */ (googleProtobuf.Message.getFieldWithDefault(this, 13, false));
};


/** @param {boolean} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.Node.prototype.setEndItem = function(value) {
  googleProtobuf.Message.setProto3BooleanField(this, 13, value);
};



/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ListChange = function(opt_data) {
  googleProtobuf.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.vertexvis.protobuf.scenetree.v1alpha1.ListChange, googleProtobuf.Message);
if (goog.DEBUG && !COMPILED) {
  proto.vertexvis.protobuf.scenetree.v1alpha1.ListChange.displayName = 'proto.vertexvis.protobuf.scenetree.v1alpha1.ListChange';
}


if (googleProtobuf.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto suitable for use in Soy templates.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     com.google.apps.jspb.JsClassTemplate.JS_RESERVED_WORDS.
 * @param {boolean=} opt_includeInstance Whether to include the JSPB instance
 *     for transitional soy proto support: http://goto/soy-param-migration
 * @return {!Object}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ListChange.prototype.toObject = function(opt_includeInstance) {
  return proto.vertexvis.protobuf.scenetree.v1alpha1.ListChange.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Whether to include the JSPB
 *     instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.ListChange} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ListChange.toObject = function(includeInstance, msg) {
  var obj = {
    start: googleProtobuf.Message.getFieldWithDefault(msg, 1, 0)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.ListChange}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ListChange.deserializeBinary = function(bytes) {
  var reader = new googleProtobuf.BinaryReader(bytes);
  var msg = new proto.vertexvis.protobuf.scenetree.v1alpha1.ListChange;
  return proto.vertexvis.protobuf.scenetree.v1alpha1.ListChange.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.ListChange} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.ListChange}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ListChange.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = /** @type {number} */ (reader.readInt32());
      msg.setStart(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ListChange.prototype.serializeBinary = function() {
  var writer = new googleProtobuf.BinaryWriter();
  proto.vertexvis.protobuf.scenetree.v1alpha1.ListChange.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.ListChange} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ListChange.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getStart();
  if (f !== 0) {
    writer.writeInt32(
      1,
      f
    );
  }
};


/**
 * optional int32 start = 1;
 * @return {number}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ListChange.prototype.getStart = function() {
  return /** @type {number} */ (googleProtobuf.Message.getFieldWithDefault(this, 1, 0));
};


/** @param {number} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.ListChange.prototype.setStart = function(value) {
  googleProtobuf.Message.setProto3IntField(this, 1, value);
};



/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Range = function(opt_data) {
  googleProtobuf.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.vertexvis.protobuf.scenetree.v1alpha1.Range, googleProtobuf.Message);
if (goog.DEBUG && !COMPILED) {
  proto.vertexvis.protobuf.scenetree.v1alpha1.Range.displayName = 'proto.vertexvis.protobuf.scenetree.v1alpha1.Range';
}


if (googleProtobuf.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto suitable for use in Soy templates.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     com.google.apps.jspb.JsClassTemplate.JS_RESERVED_WORDS.
 * @param {boolean=} opt_includeInstance Whether to include the JSPB instance
 *     for transitional soy proto support: http://goto/soy-param-migration
 * @return {!Object}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Range.prototype.toObject = function(opt_includeInstance) {
  return proto.vertexvis.protobuf.scenetree.v1alpha1.Range.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Whether to include the JSPB
 *     instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.Range} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Range.toObject = function(includeInstance, msg) {
  var obj = {
    start: googleProtobuf.Message.getFieldWithDefault(msg, 1, 0),
    end: googleProtobuf.Message.getFieldWithDefault(msg, 2, 0)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.Range}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Range.deserializeBinary = function(bytes) {
  var reader = new googleProtobuf.BinaryReader(bytes);
  var msg = new proto.vertexvis.protobuf.scenetree.v1alpha1.Range;
  return proto.vertexvis.protobuf.scenetree.v1alpha1.Range.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.Range} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.Range}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Range.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = /** @type {number} */ (reader.readInt32());
      msg.setStart(value);
      break;
    case 2:
      var value = /** @type {number} */ (reader.readInt32());
      msg.setEnd(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Range.prototype.serializeBinary = function() {
  var writer = new googleProtobuf.BinaryWriter();
  proto.vertexvis.protobuf.scenetree.v1alpha1.Range.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.Range} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Range.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getStart();
  if (f !== 0) {
    writer.writeInt32(
      1,
      f
    );
  }
  f = message.getEnd();
  if (f !== 0) {
    writer.writeInt32(
      2,
      f
    );
  }
};


/**
 * optional int32 start = 1;
 * @return {number}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Range.prototype.getStart = function() {
  return /** @type {number} */ (googleProtobuf.Message.getFieldWithDefault(this, 1, 0));
};


/** @param {number} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.Range.prototype.setStart = function(value) {
  googleProtobuf.Message.setProto3IntField(this, 1, value);
};


/**
 * optional int32 end = 2;
 * @return {number}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Range.prototype.getEnd = function() {
  return /** @type {number} */ (googleProtobuf.Message.getFieldWithDefault(this, 2, 0));
};


/** @param {number} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.Range.prototype.setEnd = function(value) {
  googleProtobuf.Message.setProto3IntField(this, 2, value);
};



/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange = function(opt_data) {
  googleProtobuf.Message.initialize(this, opt_data, 0, -1, proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange.repeatedFields_, null);
};
goog.inherits(proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange, googleProtobuf.Message);
if (goog.DEBUG && !COMPILED) {
  proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange.displayName = 'proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange';
}
/**
 * List of repeated fields within this message type.
 * @private {!Array<number>}
 * @const
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange.repeatedFields_ = [1,2,3,4,5];



if (googleProtobuf.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto suitable for use in Soy templates.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     com.google.apps.jspb.JsClassTemplate.JS_RESERVED_WORDS.
 * @param {boolean=} opt_includeInstance Whether to include the JSPB instance
 *     for transitional soy proto support: http://goto/soy-param-migration
 * @return {!Object}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange.prototype.toObject = function(opt_includeInstance) {
  return proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Whether to include the JSPB
 *     instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange.toObject = function(includeInstance, msg) {
  var obj = {
    hiddenList: googleProtobuf.Message.toObjectList(msg.getHiddenList(),
    proto.vertexvis.protobuf.scenetree.v1alpha1.Range.toObject, includeInstance),
    shownList: googleProtobuf.Message.toObjectList(msg.getShownList(),
    proto.vertexvis.protobuf.scenetree.v1alpha1.Range.toObject, includeInstance),
    selectedList: googleProtobuf.Message.toObjectList(msg.getSelectedList(),
    proto.vertexvis.protobuf.scenetree.v1alpha1.Range.toObject, includeInstance),
    deselectedList: googleProtobuf.Message.toObjectList(msg.getDeselectedList(),
    proto.vertexvis.protobuf.scenetree.v1alpha1.Range.toObject, includeInstance),
    partiallyVisibleList: googleProtobuf.Message.toObjectList(msg.getPartiallyVisibleList(),
    proto.vertexvis.protobuf.scenetree.v1alpha1.Range.toObject, includeInstance)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange.deserializeBinary = function(bytes) {
  var reader = new googleProtobuf.BinaryReader(bytes);
  var msg = new proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange;
  return proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = new proto.vertexvis.protobuf.scenetree.v1alpha1.Range;
      reader.readMessage(value,proto.vertexvis.protobuf.scenetree.v1alpha1.Range.deserializeBinaryFromReader);
      msg.addHidden(value);
      break;
    case 2:
      var value = new proto.vertexvis.protobuf.scenetree.v1alpha1.Range;
      reader.readMessage(value,proto.vertexvis.protobuf.scenetree.v1alpha1.Range.deserializeBinaryFromReader);
      msg.addShown(value);
      break;
    case 3:
      var value = new proto.vertexvis.protobuf.scenetree.v1alpha1.Range;
      reader.readMessage(value,proto.vertexvis.protobuf.scenetree.v1alpha1.Range.deserializeBinaryFromReader);
      msg.addSelected(value);
      break;
    case 4:
      var value = new proto.vertexvis.protobuf.scenetree.v1alpha1.Range;
      reader.readMessage(value,proto.vertexvis.protobuf.scenetree.v1alpha1.Range.deserializeBinaryFromReader);
      msg.addDeselected(value);
      break;
    case 5:
      var value = new proto.vertexvis.protobuf.scenetree.v1alpha1.Range;
      reader.readMessage(value,proto.vertexvis.protobuf.scenetree.v1alpha1.Range.deserializeBinaryFromReader);
      msg.addPartiallyVisible(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange.prototype.serializeBinary = function() {
  var writer = new googleProtobuf.BinaryWriter();
  proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getHiddenList();
  if (f.length > 0) {
    writer.writeRepeatedMessage(
      1,
      f,
      proto.vertexvis.protobuf.scenetree.v1alpha1.Range.serializeBinaryToWriter
    );
  }
  f = message.getShownList();
  if (f.length > 0) {
    writer.writeRepeatedMessage(
      2,
      f,
      proto.vertexvis.protobuf.scenetree.v1alpha1.Range.serializeBinaryToWriter
    );
  }
  f = message.getSelectedList();
  if (f.length > 0) {
    writer.writeRepeatedMessage(
      3,
      f,
      proto.vertexvis.protobuf.scenetree.v1alpha1.Range.serializeBinaryToWriter
    );
  }
  f = message.getDeselectedList();
  if (f.length > 0) {
    writer.writeRepeatedMessage(
      4,
      f,
      proto.vertexvis.protobuf.scenetree.v1alpha1.Range.serializeBinaryToWriter
    );
  }
  f = message.getPartiallyVisibleList();
  if (f.length > 0) {
    writer.writeRepeatedMessage(
      5,
      f,
      proto.vertexvis.protobuf.scenetree.v1alpha1.Range.serializeBinaryToWriter
    );
  }
};


/**
 * repeated Range hidden = 1;
 * @return {!Array<!proto.vertexvis.protobuf.scenetree.v1alpha1.Range>}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange.prototype.getHiddenList = function() {
  return /** @type{!Array<!proto.vertexvis.protobuf.scenetree.v1alpha1.Range>} */ (
    googleProtobuf.Message.getRepeatedWrapperField(this, proto.vertexvis.protobuf.scenetree.v1alpha1.Range, 1));
};


/** @param {!Array<!proto.vertexvis.protobuf.scenetree.v1alpha1.Range>} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange.prototype.setHiddenList = function(value) {
  googleProtobuf.Message.setRepeatedWrapperField(this, 1, value);
};


/**
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.Range=} opt_value
 * @param {number=} opt_index
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.Range}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange.prototype.addHidden = function(opt_value, opt_index) {
  return googleProtobuf.Message.addToRepeatedWrapperField(this, 1, opt_value, proto.vertexvis.protobuf.scenetree.v1alpha1.Range, opt_index);
};


proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange.prototype.clearHiddenList = function() {
  this.setHiddenList([]);
};


/**
 * repeated Range shown = 2;
 * @return {!Array<!proto.vertexvis.protobuf.scenetree.v1alpha1.Range>}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange.prototype.getShownList = function() {
  return /** @type{!Array<!proto.vertexvis.protobuf.scenetree.v1alpha1.Range>} */ (
    googleProtobuf.Message.getRepeatedWrapperField(this, proto.vertexvis.protobuf.scenetree.v1alpha1.Range, 2));
};


/** @param {!Array<!proto.vertexvis.protobuf.scenetree.v1alpha1.Range>} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange.prototype.setShownList = function(value) {
  googleProtobuf.Message.setRepeatedWrapperField(this, 2, value);
};


/**
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.Range=} opt_value
 * @param {number=} opt_index
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.Range}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange.prototype.addShown = function(opt_value, opt_index) {
  return googleProtobuf.Message.addToRepeatedWrapperField(this, 2, opt_value, proto.vertexvis.protobuf.scenetree.v1alpha1.Range, opt_index);
};


proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange.prototype.clearShownList = function() {
  this.setShownList([]);
};


/**
 * repeated Range selected = 3;
 * @return {!Array<!proto.vertexvis.protobuf.scenetree.v1alpha1.Range>}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange.prototype.getSelectedList = function() {
  return /** @type{!Array<!proto.vertexvis.protobuf.scenetree.v1alpha1.Range>} */ (
    googleProtobuf.Message.getRepeatedWrapperField(this, proto.vertexvis.protobuf.scenetree.v1alpha1.Range, 3));
};


/** @param {!Array<!proto.vertexvis.protobuf.scenetree.v1alpha1.Range>} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange.prototype.setSelectedList = function(value) {
  googleProtobuf.Message.setRepeatedWrapperField(this, 3, value);
};


/**
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.Range=} opt_value
 * @param {number=} opt_index
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.Range}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange.prototype.addSelected = function(opt_value, opt_index) {
  return googleProtobuf.Message.addToRepeatedWrapperField(this, 3, opt_value, proto.vertexvis.protobuf.scenetree.v1alpha1.Range, opt_index);
};


proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange.prototype.clearSelectedList = function() {
  this.setSelectedList([]);
};


/**
 * repeated Range deselected = 4;
 * @return {!Array<!proto.vertexvis.protobuf.scenetree.v1alpha1.Range>}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange.prototype.getDeselectedList = function() {
  return /** @type{!Array<!proto.vertexvis.protobuf.scenetree.v1alpha1.Range>} */ (
    googleProtobuf.Message.getRepeatedWrapperField(this, proto.vertexvis.protobuf.scenetree.v1alpha1.Range, 4));
};


/** @param {!Array<!proto.vertexvis.protobuf.scenetree.v1alpha1.Range>} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange.prototype.setDeselectedList = function(value) {
  googleProtobuf.Message.setRepeatedWrapperField(this, 4, value);
};


/**
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.Range=} opt_value
 * @param {number=} opt_index
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.Range}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange.prototype.addDeselected = function(opt_value, opt_index) {
  return googleProtobuf.Message.addToRepeatedWrapperField(this, 4, opt_value, proto.vertexvis.protobuf.scenetree.v1alpha1.Range, opt_index);
};


proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange.prototype.clearDeselectedList = function() {
  this.setDeselectedList([]);
};


/**
 * repeated Range partially_visible = 5;
 * @return {!Array<!proto.vertexvis.protobuf.scenetree.v1alpha1.Range>}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange.prototype.getPartiallyVisibleList = function() {
  return /** @type{!Array<!proto.vertexvis.protobuf.scenetree.v1alpha1.Range>} */ (
    googleProtobuf.Message.getRepeatedWrapperField(this, proto.vertexvis.protobuf.scenetree.v1alpha1.Range, 5));
};


/** @param {!Array<!proto.vertexvis.protobuf.scenetree.v1alpha1.Range>} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange.prototype.setPartiallyVisibleList = function(value) {
  googleProtobuf.Message.setRepeatedWrapperField(this, 5, value);
};


/**
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.Range=} opt_value
 * @param {number=} opt_index
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.Range}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange.prototype.addPartiallyVisible = function(opt_value, opt_index) {
  return googleProtobuf.Message.addToRepeatedWrapperField(this, 5, opt_value, proto.vertexvis.protobuf.scenetree.v1alpha1.Range, opt_index);
};


proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange.prototype.clearPartiallyVisibleList = function() {
  this.setPartiallyVisibleList([]);
};



/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.KeepAlive = function(opt_data) {
  googleProtobuf.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.vertexvis.protobuf.scenetree.v1alpha1.KeepAlive, googleProtobuf.Message);
if (goog.DEBUG && !COMPILED) {
  proto.vertexvis.protobuf.scenetree.v1alpha1.KeepAlive.displayName = 'proto.vertexvis.protobuf.scenetree.v1alpha1.KeepAlive';
}


if (googleProtobuf.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto suitable for use in Soy templates.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     com.google.apps.jspb.JsClassTemplate.JS_RESERVED_WORDS.
 * @param {boolean=} opt_includeInstance Whether to include the JSPB instance
 *     for transitional soy proto support: http://goto/soy-param-migration
 * @return {!Object}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.KeepAlive.prototype.toObject = function(opt_includeInstance) {
  return proto.vertexvis.protobuf.scenetree.v1alpha1.KeepAlive.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Whether to include the JSPB
 *     instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.KeepAlive} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.KeepAlive.toObject = function(includeInstance, msg) {
  var obj = {

  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.KeepAlive}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.KeepAlive.deserializeBinary = function(bytes) {
  var reader = new googleProtobuf.BinaryReader(bytes);
  var msg = new proto.vertexvis.protobuf.scenetree.v1alpha1.KeepAlive;
  return proto.vertexvis.protobuf.scenetree.v1alpha1.KeepAlive.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.KeepAlive} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.KeepAlive}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.KeepAlive.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.KeepAlive.prototype.serializeBinary = function() {
  var writer = new googleProtobuf.BinaryWriter();
  proto.vertexvis.protobuf.scenetree.v1alpha1.KeepAlive.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.KeepAlive} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.KeepAlive.serializeBinaryToWriter = function(message, writer) {
};



/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterChange = function(opt_data) {
  googleProtobuf.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.vertexvis.protobuf.scenetree.v1alpha1.FilterChange, googleProtobuf.Message);
if (goog.DEBUG && !COMPILED) {
  proto.vertexvis.protobuf.scenetree.v1alpha1.FilterChange.displayName = 'proto.vertexvis.protobuf.scenetree.v1alpha1.FilterChange';
}


if (googleProtobuf.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto suitable for use in Soy templates.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     com.google.apps.jspb.JsClassTemplate.JS_RESERVED_WORDS.
 * @param {boolean=} opt_includeInstance Whether to include the JSPB instance
 *     for transitional soy proto support: http://goto/soy-param-migration
 * @return {!Object}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterChange.prototype.toObject = function(opt_includeInstance) {
  return proto.vertexvis.protobuf.scenetree.v1alpha1.FilterChange.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Whether to include the JSPB
 *     instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.FilterChange} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterChange.toObject = function(includeInstance, msg) {
  var obj = {
    numberOfResults: googleProtobuf.Message.getFieldWithDefault(msg, 1, 0)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.FilterChange}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterChange.deserializeBinary = function(bytes) {
  var reader = new googleProtobuf.BinaryReader(bytes);
  var msg = new proto.vertexvis.protobuf.scenetree.v1alpha1.FilterChange;
  return proto.vertexvis.protobuf.scenetree.v1alpha1.FilterChange.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.FilterChange} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.FilterChange}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterChange.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = /** @type {number} */ (reader.readInt32());
      msg.setNumberOfResults(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterChange.prototype.serializeBinary = function() {
  var writer = new googleProtobuf.BinaryWriter();
  proto.vertexvis.protobuf.scenetree.v1alpha1.FilterChange.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.FilterChange} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterChange.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getNumberOfResults();
  if (f !== 0) {
    writer.writeInt32(
      1,
      f
    );
  }
};


/**
 * optional int32 number_of_results = 1;
 * @return {number}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterChange.prototype.getNumberOfResults = function() {
  return /** @type {number} */ (googleProtobuf.Message.getFieldWithDefault(this, 1, 0));
};


/** @param {number} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterChange.prototype.setNumberOfResults = function(value) {
  googleProtobuf.Message.setProto3IntField(this, 1, value);
};



/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType = function(opt_data) {
  googleProtobuf.Message.initialize(this, opt_data, 0, -1, null, proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.oneofGroups_);
};
goog.inherits(proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType, googleProtobuf.Message);
if (goog.DEBUG && !COMPILED) {
  proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.displayName = 'proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType';
}
/**
 * Oneof group definitions for this message. Each group defines the field
 * numbers belonging to that group. When of these fields' value is set, all
 * other fields in the group are cleared. During deserialization, if multiple
 * fields are encountered for a group, only the last value seen will be kept.
 * @private {!Array<!Array<number>>}
 * @const
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.oneofGroups_ = [[1,2,3,4]];

/**
 * @enum {number}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.SealedValueCase = {
  SEALED_VALUE_NOT_SET: 0,
  LIST_CHANGE: 1,
  RANGES: 2,
  KEEP_ALIVE: 3,
  FILTER_CHANGE: 4
};

/**
 * @return {proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.SealedValueCase}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.prototype.getSealedValueCase = function() {
  return /** @type {proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.SealedValueCase} */(googleProtobuf.Message.computeOneofCase(this, proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.oneofGroups_[0]));
};



if (googleProtobuf.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto suitable for use in Soy templates.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     com.google.apps.jspb.JsClassTemplate.JS_RESERVED_WORDS.
 * @param {boolean=} opt_includeInstance Whether to include the JSPB instance
 *     for transitional soy proto support: http://goto/soy-param-migration
 * @return {!Object}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.prototype.toObject = function(opt_includeInstance) {
  return proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Whether to include the JSPB
 *     instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.toObject = function(includeInstance, msg) {
  var f, obj = {
    listChange: (f = msg.getListChange()) && proto.vertexvis.protobuf.scenetree.v1alpha1.ListChange.toObject(includeInstance, f),
    ranges: (f = msg.getRanges()) && proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange.toObject(includeInstance, f),
    keepAlive: (f = msg.getKeepAlive()) && proto.vertexvis.protobuf.scenetree.v1alpha1.KeepAlive.toObject(includeInstance, f),
    filterChange: (f = msg.getFilterChange()) && proto.vertexvis.protobuf.scenetree.v1alpha1.FilterChange.toObject(includeInstance, f)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.deserializeBinary = function(bytes) {
  var reader = new googleProtobuf.BinaryReader(bytes);
  var msg = new proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType;
  return proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = new proto.vertexvis.protobuf.scenetree.v1alpha1.ListChange;
      reader.readMessage(value,proto.vertexvis.protobuf.scenetree.v1alpha1.ListChange.deserializeBinaryFromReader);
      msg.setListChange(value);
      break;
    case 2:
      var value = new proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange;
      reader.readMessage(value,proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange.deserializeBinaryFromReader);
      msg.setRanges(value);
      break;
    case 3:
      var value = new proto.vertexvis.protobuf.scenetree.v1alpha1.KeepAlive;
      reader.readMessage(value,proto.vertexvis.protobuf.scenetree.v1alpha1.KeepAlive.deserializeBinaryFromReader);
      msg.setKeepAlive(value);
      break;
    case 4:
      var value = new proto.vertexvis.protobuf.scenetree.v1alpha1.FilterChange;
      reader.readMessage(value,proto.vertexvis.protobuf.scenetree.v1alpha1.FilterChange.deserializeBinaryFromReader);
      msg.setFilterChange(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.prototype.serializeBinary = function() {
  var writer = new googleProtobuf.BinaryWriter();
  proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getListChange();
  if (f != null) {
    writer.writeMessage(
      1,
      f,
      proto.vertexvis.protobuf.scenetree.v1alpha1.ListChange.serializeBinaryToWriter
    );
  }
  f = message.getRanges();
  if (f != null) {
    writer.writeMessage(
      2,
      f,
      proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange.serializeBinaryToWriter
    );
  }
  f = message.getKeepAlive();
  if (f != null) {
    writer.writeMessage(
      3,
      f,
      proto.vertexvis.protobuf.scenetree.v1alpha1.KeepAlive.serializeBinaryToWriter
    );
  }
  f = message.getFilterChange();
  if (f != null) {
    writer.writeMessage(
      4,
      f,
      proto.vertexvis.protobuf.scenetree.v1alpha1.FilterChange.serializeBinaryToWriter
    );
  }
};


/**
 * optional ListChange list_change = 1;
 * @return {?proto.vertexvis.protobuf.scenetree.v1alpha1.ListChange}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.prototype.getListChange = function() {
  return /** @type{?proto.vertexvis.protobuf.scenetree.v1alpha1.ListChange} */ (
    googleProtobuf.Message.getWrapperField(this, proto.vertexvis.protobuf.scenetree.v1alpha1.ListChange, 1));
};


/** @param {?proto.vertexvis.protobuf.scenetree.v1alpha1.ListChange|undefined} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.prototype.setListChange = function(value) {
  googleProtobuf.Message.setOneofWrapperField(this, 1, proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.oneofGroups_[0], value);
};


proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.prototype.clearListChange = function() {
  this.setListChange(undefined);
};


/**
 * Returns whether this field is set.
 * @return {!boolean}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.prototype.hasListChange = function() {
  return googleProtobuf.Message.getField(this, 1) != null;
};


/**
 * optional StateChange ranges = 2;
 * @return {?proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.prototype.getRanges = function() {
  return /** @type{?proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange} */ (
    googleProtobuf.Message.getWrapperField(this, proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange, 2));
};


/** @param {?proto.vertexvis.protobuf.scenetree.v1alpha1.StateChange|undefined} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.prototype.setRanges = function(value) {
  googleProtobuf.Message.setOneofWrapperField(this, 2, proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.oneofGroups_[0], value);
};


proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.prototype.clearRanges = function() {
  this.setRanges(undefined);
};


/**
 * Returns whether this field is set.
 * @return {!boolean}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.prototype.hasRanges = function() {
  return googleProtobuf.Message.getField(this, 2) != null;
};


/**
 * optional KeepAlive keep_alive = 3;
 * @return {?proto.vertexvis.protobuf.scenetree.v1alpha1.KeepAlive}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.prototype.getKeepAlive = function() {
  return /** @type{?proto.vertexvis.protobuf.scenetree.v1alpha1.KeepAlive} */ (
    googleProtobuf.Message.getWrapperField(this, proto.vertexvis.protobuf.scenetree.v1alpha1.KeepAlive, 3));
};


/** @param {?proto.vertexvis.protobuf.scenetree.v1alpha1.KeepAlive|undefined} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.prototype.setKeepAlive = function(value) {
  googleProtobuf.Message.setOneofWrapperField(this, 3, proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.oneofGroups_[0], value);
};


proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.prototype.clearKeepAlive = function() {
  this.setKeepAlive(undefined);
};


/**
 * Returns whether this field is set.
 * @return {!boolean}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.prototype.hasKeepAlive = function() {
  return googleProtobuf.Message.getField(this, 3) != null;
};


/**
 * optional FilterChange filter_change = 4;
 * @return {?proto.vertexvis.protobuf.scenetree.v1alpha1.FilterChange}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.prototype.getFilterChange = function() {
  return /** @type{?proto.vertexvis.protobuf.scenetree.v1alpha1.FilterChange} */ (
    googleProtobuf.Message.getWrapperField(this, proto.vertexvis.protobuf.scenetree.v1alpha1.FilterChange, 4));
};


/** @param {?proto.vertexvis.protobuf.scenetree.v1alpha1.FilterChange|undefined} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.prototype.setFilterChange = function(value) {
  googleProtobuf.Message.setOneofWrapperField(this, 4, proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.oneofGroups_[0], value);
};


proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.prototype.clearFilterChange = function() {
  this.setFilterChange(undefined);
};


/**
 * Returns whether this field is set.
 * @return {!boolean}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType.prototype.hasFilterChange = function() {
  return googleProtobuf.Message.getField(this, 4) != null;
};



/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ColumnKey = function(opt_data) {
  googleProtobuf.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.vertexvis.protobuf.scenetree.v1alpha1.ColumnKey, googleProtobuf.Message);
if (goog.DEBUG && !COMPILED) {
  proto.vertexvis.protobuf.scenetree.v1alpha1.ColumnKey.displayName = 'proto.vertexvis.protobuf.scenetree.v1alpha1.ColumnKey';
}


if (googleProtobuf.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto suitable for use in Soy templates.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     com.google.apps.jspb.JsClassTemplate.JS_RESERVED_WORDS.
 * @param {boolean=} opt_includeInstance Whether to include the JSPB instance
 *     for transitional soy proto support: http://goto/soy-param-migration
 * @return {!Object}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ColumnKey.prototype.toObject = function(opt_includeInstance) {
  return proto.vertexvis.protobuf.scenetree.v1alpha1.ColumnKey.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Whether to include the JSPB
 *     instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.ColumnKey} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ColumnKey.toObject = function(includeInstance, msg) {
  var obj = {
    value: googleProtobuf.Message.getFieldWithDefault(msg, 1, "")
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.ColumnKey}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ColumnKey.deserializeBinary = function(bytes) {
  var reader = new googleProtobuf.BinaryReader(bytes);
  var msg = new proto.vertexvis.protobuf.scenetree.v1alpha1.ColumnKey;
  return proto.vertexvis.protobuf.scenetree.v1alpha1.ColumnKey.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.ColumnKey} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.ColumnKey}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ColumnKey.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = /** @type {string} */ (reader.readString());
      msg.setValue(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ColumnKey.prototype.serializeBinary = function() {
  var writer = new googleProtobuf.BinaryWriter();
  proto.vertexvis.protobuf.scenetree.v1alpha1.ColumnKey.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.ColumnKey} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ColumnKey.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getValue();
  if (f.length > 0) {
    writer.writeString(
      1,
      f
    );
  }
};


/**
 * optional string value = 1;
 * @return {string}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ColumnKey.prototype.getValue = function() {
  return /** @type {string} */ (googleProtobuf.Message.getFieldWithDefault(this, 1, ""));
};


/** @param {string} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.ColumnKey.prototype.setValue = function(value) {
  googleProtobuf.Message.setProto3StringField(this, 1, value);
};


goog.object.extend(exports, proto.vertexvis.protobuf.scenetree.v1alpha1);
});

var scene_tree_api_pb = createCommonjsModule(function (module, exports) {
/**
 * @fileoverview
 * @enhanceable
 * @suppress {messageConventions} JS Compiler reports an error if a variable or
 *     field starts with 'MSG_' and isn't a translatable message.
 * @public
 */
// GENERATED CODE -- DO NOT EDIT!


var goog = googleProtobuf;
var global = Function('return this')();





goog.exportSymbol('proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllRequest', null, global);
goog.exportSymbol('proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllResponse', null, global);
goog.exportSymbol('proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeRequest', null, global);
goog.exportSymbol('proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeResponse', null, global);
goog.exportSymbol('proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllRequest', null, global);
goog.exportSymbol('proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllResponse', null, global);
goog.exportSymbol('proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeRequest', null, global);
goog.exportSymbol('proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeResponse', null, global);
goog.exportSymbol('proto.vertexvis.protobuf.scenetree.v1alpha1.FilterRequest', null, global);
goog.exportSymbol('proto.vertexvis.protobuf.scenetree.v1alpha1.FilterResponse', null, global);
goog.exportSymbol('proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsRequest', null, global);
goog.exportSymbol('proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsResponse', null, global);
goog.exportSymbol('proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsRequest', null, global);
goog.exportSymbol('proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsResponse', null, global);
goog.exportSymbol('proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeRequest', null, global);
goog.exportSymbol('proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeResponse', null, global);
goog.exportSymbol('proto.vertexvis.protobuf.scenetree.v1alpha1.Handshake', null, global);
goog.exportSymbol('proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemRequest', null, global);
goog.exportSymbol('proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemResponse', null, global);
goog.exportSymbol('proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeRequest', null, global);
goog.exportSymbol('proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeResponse', null, global);

/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeRequest = function(opt_data) {
  googleProtobuf.Message.initialize(this, opt_data, 0, -1, proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeRequest.repeatedFields_, null);
};
goog.inherits(proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeRequest, googleProtobuf.Message);
if (goog.DEBUG && !COMPILED) {
  proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeRequest.displayName = 'proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeRequest';
}
/**
 * List of repeated fields within this message type.
 * @private {!Array<number>}
 * @const
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeRequest.repeatedFields_ = [3];



if (googleProtobuf.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto suitable for use in Soy templates.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     com.google.apps.jspb.JsClassTemplate.JS_RESERVED_WORDS.
 * @param {boolean=} opt_includeInstance Whether to include the JSPB instance
 *     for transitional soy proto support: http://goto/soy-param-migration
 * @return {!Object}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeRequest.prototype.toObject = function(opt_includeInstance) {
  return proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeRequest.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Whether to include the JSPB
 *     instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeRequest} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeRequest.toObject = function(includeInstance, msg) {
  var f, obj = {
    viewId: (f = msg.getViewId()) && uuid_pb.Uuid.toObject(includeInstance, f),
    pager: (f = msg.getPager()) && paging_pb.OffsetPager.toObject(includeInstance, f),
    additionalColumnKeysList: googleProtobuf.Message.getRepeatedField(msg, 3)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeRequest}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeRequest.deserializeBinary = function(bytes) {
  var reader = new googleProtobuf.BinaryReader(bytes);
  var msg = new proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeRequest;
  return proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeRequest.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeRequest} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeRequest}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeRequest.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = new uuid_pb.Uuid;
      reader.readMessage(value,uuid_pb.Uuid.deserializeBinaryFromReader);
      msg.setViewId(value);
      break;
    case 2:
      var value = new paging_pb.OffsetPager;
      reader.readMessage(value,paging_pb.OffsetPager.deserializeBinaryFromReader);
      msg.setPager(value);
      break;
    case 3:
      var value = /** @type {string} */ (reader.readString());
      msg.addAdditionalColumnKeys(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeRequest.prototype.serializeBinary = function() {
  var writer = new googleProtobuf.BinaryWriter();
  proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeRequest.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeRequest} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeRequest.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getViewId();
  if (f != null) {
    writer.writeMessage(
      1,
      f,
      uuid_pb.Uuid.serializeBinaryToWriter
    );
  }
  f = message.getPager();
  if (f != null) {
    writer.writeMessage(
      2,
      f,
      paging_pb.OffsetPager.serializeBinaryToWriter
    );
  }
  f = message.getAdditionalColumnKeysList();
  if (f.length > 0) {
    writer.writeRepeatedString(
      3,
      f
    );
  }
};


/**
 * optional vertexvis.protobuf.core.Uuid view_id = 1;
 * @return {?proto.vertexvis.protobuf.core.Uuid}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeRequest.prototype.getViewId = function() {
  return /** @type{?proto.vertexvis.protobuf.core.Uuid} */ (
    googleProtobuf.Message.getWrapperField(this, uuid_pb.Uuid, 1));
};


/** @param {?proto.vertexvis.protobuf.core.Uuid|undefined} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeRequest.prototype.setViewId = function(value) {
  googleProtobuf.Message.setWrapperField(this, 1, value);
};


proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeRequest.prototype.clearViewId = function() {
  this.setViewId(undefined);
};


/**
 * Returns whether this field is set.
 * @return {!boolean}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeRequest.prototype.hasViewId = function() {
  return googleProtobuf.Message.getField(this, 1) != null;
};


/**
 * optional vertexvis.protobuf.core.OffsetPager pager = 2;
 * @return {?proto.vertexvis.protobuf.core.OffsetPager}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeRequest.prototype.getPager = function() {
  return /** @type{?proto.vertexvis.protobuf.core.OffsetPager} */ (
    googleProtobuf.Message.getWrapperField(this, paging_pb.OffsetPager, 2));
};


/** @param {?proto.vertexvis.protobuf.core.OffsetPager|undefined} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeRequest.prototype.setPager = function(value) {
  googleProtobuf.Message.setWrapperField(this, 2, value);
};


proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeRequest.prototype.clearPager = function() {
  this.setPager(undefined);
};


/**
 * Returns whether this field is set.
 * @return {!boolean}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeRequest.prototype.hasPager = function() {
  return googleProtobuf.Message.getField(this, 2) != null;
};


/**
 * repeated string additional_column_keys = 3;
 * @return {!Array<string>}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeRequest.prototype.getAdditionalColumnKeysList = function() {
  return /** @type {!Array<string>} */ (googleProtobuf.Message.getRepeatedField(this, 3));
};


/** @param {!Array<string>} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeRequest.prototype.setAdditionalColumnKeysList = function(value) {
  googleProtobuf.Message.setField(this, 3, value || []);
};


/**
 * @param {!string} value
 * @param {number=} opt_index
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeRequest.prototype.addAdditionalColumnKeys = function(value, opt_index) {
  googleProtobuf.Message.addToRepeatedField(this, 3, value, opt_index);
};


proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeRequest.prototype.clearAdditionalColumnKeysList = function() {
  this.setAdditionalColumnKeysList([]);
};



/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeResponse = function(opt_data) {
  googleProtobuf.Message.initialize(this, opt_data, 0, -1, proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeResponse.repeatedFields_, null);
};
goog.inherits(proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeResponse, googleProtobuf.Message);
if (goog.DEBUG && !COMPILED) {
  proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeResponse.displayName = 'proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeResponse';
}
/**
 * List of repeated fields within this message type.
 * @private {!Array<number>}
 * @const
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeResponse.repeatedFields_ = [1];



if (googleProtobuf.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto suitable for use in Soy templates.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     com.google.apps.jspb.JsClassTemplate.JS_RESERVED_WORDS.
 * @param {boolean=} opt_includeInstance Whether to include the JSPB instance
 *     for transitional soy proto support: http://goto/soy-param-migration
 * @return {!Object}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeResponse.prototype.toObject = function(opt_includeInstance) {
  return proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeResponse.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Whether to include the JSPB
 *     instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeResponse} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeResponse.toObject = function(includeInstance, msg) {
  var f, obj = {
    itemsList: googleProtobuf.Message.toObjectList(msg.getItemsList(),
    domain_pb.Node.toObject, includeInstance),
    totalVisible: googleProtobuf.Message.getFieldWithDefault(msg, 2, 0),
    cursor: (f = msg.getCursor()) && paging_pb.OffsetCursor.toObject(includeInstance, f)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeResponse}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeResponse.deserializeBinary = function(bytes) {
  var reader = new googleProtobuf.BinaryReader(bytes);
  var msg = new proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeResponse;
  return proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeResponse.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeResponse} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeResponse}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeResponse.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = new domain_pb.Node;
      reader.readMessage(value,domain_pb.Node.deserializeBinaryFromReader);
      msg.addItems(value);
      break;
    case 2:
      var value = /** @type {number} */ (reader.readUint32());
      msg.setTotalVisible(value);
      break;
    case 3:
      var value = new paging_pb.OffsetCursor;
      reader.readMessage(value,paging_pb.OffsetCursor.deserializeBinaryFromReader);
      msg.setCursor(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeResponse.prototype.serializeBinary = function() {
  var writer = new googleProtobuf.BinaryWriter();
  proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeResponse.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeResponse} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeResponse.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getItemsList();
  if (f.length > 0) {
    writer.writeRepeatedMessage(
      1,
      f,
      domain_pb.Node.serializeBinaryToWriter
    );
  }
  f = message.getTotalVisible();
  if (f !== 0) {
    writer.writeUint32(
      2,
      f
    );
  }
  f = message.getCursor();
  if (f != null) {
    writer.writeMessage(
      3,
      f,
      paging_pb.OffsetCursor.serializeBinaryToWriter
    );
  }
};


/**
 * repeated Node items = 1;
 * @return {!Array<!proto.vertexvis.protobuf.scenetree.v1alpha1.Node>}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeResponse.prototype.getItemsList = function() {
  return /** @type{!Array<!proto.vertexvis.protobuf.scenetree.v1alpha1.Node>} */ (
    googleProtobuf.Message.getRepeatedWrapperField(this, domain_pb.Node, 1));
};


/** @param {!Array<!proto.vertexvis.protobuf.scenetree.v1alpha1.Node>} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeResponse.prototype.setItemsList = function(value) {
  googleProtobuf.Message.setRepeatedWrapperField(this, 1, value);
};


/**
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.Node=} opt_value
 * @param {number=} opt_index
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.Node}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeResponse.prototype.addItems = function(opt_value, opt_index) {
  return googleProtobuf.Message.addToRepeatedWrapperField(this, 1, opt_value, proto.vertexvis.protobuf.scenetree.v1alpha1.Node, opt_index);
};


proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeResponse.prototype.clearItemsList = function() {
  this.setItemsList([]);
};


/**
 * optional uint32 total_visible = 2;
 * @return {number}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeResponse.prototype.getTotalVisible = function() {
  return /** @type {number} */ (googleProtobuf.Message.getFieldWithDefault(this, 2, 0));
};


/** @param {number} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeResponse.prototype.setTotalVisible = function(value) {
  googleProtobuf.Message.setProto3IntField(this, 2, value);
};


/**
 * optional vertexvis.protobuf.core.OffsetCursor cursor = 3;
 * @return {?proto.vertexvis.protobuf.core.OffsetCursor}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeResponse.prototype.getCursor = function() {
  return /** @type{?proto.vertexvis.protobuf.core.OffsetCursor} */ (
    googleProtobuf.Message.getWrapperField(this, paging_pb.OffsetCursor, 3));
};


/** @param {?proto.vertexvis.protobuf.core.OffsetCursor|undefined} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeResponse.prototype.setCursor = function(value) {
  googleProtobuf.Message.setWrapperField(this, 3, value);
};


proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeResponse.prototype.clearCursor = function() {
  this.setCursor(undefined);
};


/**
 * Returns whether this field is set.
 * @return {!boolean}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetTreeResponse.prototype.hasCursor = function() {
  return googleProtobuf.Message.getField(this, 3) != null;
};



/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeRequest = function(opt_data) {
  googleProtobuf.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeRequest, googleProtobuf.Message);
if (goog.DEBUG && !COMPILED) {
  proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeRequest.displayName = 'proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeRequest';
}


if (googleProtobuf.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto suitable for use in Soy templates.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     com.google.apps.jspb.JsClassTemplate.JS_RESERVED_WORDS.
 * @param {boolean=} opt_includeInstance Whether to include the JSPB instance
 *     for transitional soy proto support: http://goto/soy-param-migration
 * @return {!Object}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeRequest.prototype.toObject = function(opt_includeInstance) {
  return proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeRequest.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Whether to include the JSPB
 *     instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeRequest} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeRequest.toObject = function(includeInstance, msg) {
  var f, obj = {
    viewId: (f = msg.getViewId()) && uuid_pb.Uuid.toObject(includeInstance, f),
    nodeId: (f = msg.getNodeId()) && uuid_pb.Uuid.toObject(includeInstance, f)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeRequest}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeRequest.deserializeBinary = function(bytes) {
  var reader = new googleProtobuf.BinaryReader(bytes);
  var msg = new proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeRequest;
  return proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeRequest.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeRequest} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeRequest}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeRequest.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = new uuid_pb.Uuid;
      reader.readMessage(value,uuid_pb.Uuid.deserializeBinaryFromReader);
      msg.setViewId(value);
      break;
    case 2:
      var value = new uuid_pb.Uuid;
      reader.readMessage(value,uuid_pb.Uuid.deserializeBinaryFromReader);
      msg.setNodeId(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeRequest.prototype.serializeBinary = function() {
  var writer = new googleProtobuf.BinaryWriter();
  proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeRequest.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeRequest} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeRequest.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getViewId();
  if (f != null) {
    writer.writeMessage(
      1,
      f,
      uuid_pb.Uuid.serializeBinaryToWriter
    );
  }
  f = message.getNodeId();
  if (f != null) {
    writer.writeMessage(
      2,
      f,
      uuid_pb.Uuid.serializeBinaryToWriter
    );
  }
};


/**
 * optional vertexvis.protobuf.core.Uuid view_id = 1;
 * @return {?proto.vertexvis.protobuf.core.Uuid}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeRequest.prototype.getViewId = function() {
  return /** @type{?proto.vertexvis.protobuf.core.Uuid} */ (
    googleProtobuf.Message.getWrapperField(this, uuid_pb.Uuid, 1));
};


/** @param {?proto.vertexvis.protobuf.core.Uuid|undefined} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeRequest.prototype.setViewId = function(value) {
  googleProtobuf.Message.setWrapperField(this, 1, value);
};


proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeRequest.prototype.clearViewId = function() {
  this.setViewId(undefined);
};


/**
 * Returns whether this field is set.
 * @return {!boolean}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeRequest.prototype.hasViewId = function() {
  return googleProtobuf.Message.getField(this, 1) != null;
};


/**
 * optional vertexvis.protobuf.core.Uuid node_id = 2;
 * @return {?proto.vertexvis.protobuf.core.Uuid}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeRequest.prototype.getNodeId = function() {
  return /** @type{?proto.vertexvis.protobuf.core.Uuid} */ (
    googleProtobuf.Message.getWrapperField(this, uuid_pb.Uuid, 2));
};


/** @param {?proto.vertexvis.protobuf.core.Uuid|undefined} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeRequest.prototype.setNodeId = function(value) {
  googleProtobuf.Message.setWrapperField(this, 2, value);
};


proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeRequest.prototype.clearNodeId = function() {
  this.setNodeId(undefined);
};


/**
 * Returns whether this field is set.
 * @return {!boolean}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeRequest.prototype.hasNodeId = function() {
  return googleProtobuf.Message.getField(this, 2) != null;
};



/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeResponse = function(opt_data) {
  googleProtobuf.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeResponse, googleProtobuf.Message);
if (goog.DEBUG && !COMPILED) {
  proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeResponse.displayName = 'proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeResponse';
}


if (googleProtobuf.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto suitable for use in Soy templates.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     com.google.apps.jspb.JsClassTemplate.JS_RESERVED_WORDS.
 * @param {boolean=} opt_includeInstance Whether to include the JSPB instance
 *     for transitional soy proto support: http://goto/soy-param-migration
 * @return {!Object}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeResponse.prototype.toObject = function(opt_includeInstance) {
  return proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeResponse.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Whether to include the JSPB
 *     instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeResponse} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeResponse.toObject = function(includeInstance, msg) {
  var obj = {

  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeResponse}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeResponse.deserializeBinary = function(bytes) {
  var reader = new googleProtobuf.BinaryReader(bytes);
  var msg = new proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeResponse;
  return proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeResponse.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeResponse} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeResponse}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeResponse.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeResponse.prototype.serializeBinary = function() {
  var writer = new googleProtobuf.BinaryWriter();
  proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeResponse.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeResponse} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandNodeResponse.serializeBinaryToWriter = function(message, writer) {
};



/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeRequest = function(opt_data) {
  googleProtobuf.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeRequest, googleProtobuf.Message);
if (goog.DEBUG && !COMPILED) {
  proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeRequest.displayName = 'proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeRequest';
}


if (googleProtobuf.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto suitable for use in Soy templates.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     com.google.apps.jspb.JsClassTemplate.JS_RESERVED_WORDS.
 * @param {boolean=} opt_includeInstance Whether to include the JSPB instance
 *     for transitional soy proto support: http://goto/soy-param-migration
 * @return {!Object}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeRequest.prototype.toObject = function(opt_includeInstance) {
  return proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeRequest.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Whether to include the JSPB
 *     instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeRequest} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeRequest.toObject = function(includeInstance, msg) {
  var f, obj = {
    viewId: (f = msg.getViewId()) && uuid_pb.Uuid.toObject(includeInstance, f),
    nodeId: (f = msg.getNodeId()) && uuid_pb.Uuid.toObject(includeInstance, f)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeRequest}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeRequest.deserializeBinary = function(bytes) {
  var reader = new googleProtobuf.BinaryReader(bytes);
  var msg = new proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeRequest;
  return proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeRequest.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeRequest} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeRequest}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeRequest.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = new uuid_pb.Uuid;
      reader.readMessage(value,uuid_pb.Uuid.deserializeBinaryFromReader);
      msg.setViewId(value);
      break;
    case 2:
      var value = new uuid_pb.Uuid;
      reader.readMessage(value,uuid_pb.Uuid.deserializeBinaryFromReader);
      msg.setNodeId(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeRequest.prototype.serializeBinary = function() {
  var writer = new googleProtobuf.BinaryWriter();
  proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeRequest.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeRequest} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeRequest.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getViewId();
  if (f != null) {
    writer.writeMessage(
      1,
      f,
      uuid_pb.Uuid.serializeBinaryToWriter
    );
  }
  f = message.getNodeId();
  if (f != null) {
    writer.writeMessage(
      2,
      f,
      uuid_pb.Uuid.serializeBinaryToWriter
    );
  }
};


/**
 * optional vertexvis.protobuf.core.Uuid view_id = 1;
 * @return {?proto.vertexvis.protobuf.core.Uuid}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeRequest.prototype.getViewId = function() {
  return /** @type{?proto.vertexvis.protobuf.core.Uuid} */ (
    googleProtobuf.Message.getWrapperField(this, uuid_pb.Uuid, 1));
};


/** @param {?proto.vertexvis.protobuf.core.Uuid|undefined} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeRequest.prototype.setViewId = function(value) {
  googleProtobuf.Message.setWrapperField(this, 1, value);
};


proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeRequest.prototype.clearViewId = function() {
  this.setViewId(undefined);
};


/**
 * Returns whether this field is set.
 * @return {!boolean}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeRequest.prototype.hasViewId = function() {
  return googleProtobuf.Message.getField(this, 1) != null;
};


/**
 * optional vertexvis.protobuf.core.Uuid node_id = 2;
 * @return {?proto.vertexvis.protobuf.core.Uuid}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeRequest.prototype.getNodeId = function() {
  return /** @type{?proto.vertexvis.protobuf.core.Uuid} */ (
    googleProtobuf.Message.getWrapperField(this, uuid_pb.Uuid, 2));
};


/** @param {?proto.vertexvis.protobuf.core.Uuid|undefined} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeRequest.prototype.setNodeId = function(value) {
  googleProtobuf.Message.setWrapperField(this, 2, value);
};


proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeRequest.prototype.clearNodeId = function() {
  this.setNodeId(undefined);
};


/**
 * Returns whether this field is set.
 * @return {!boolean}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeRequest.prototype.hasNodeId = function() {
  return googleProtobuf.Message.getField(this, 2) != null;
};



/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeResponse = function(opt_data) {
  googleProtobuf.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeResponse, googleProtobuf.Message);
if (goog.DEBUG && !COMPILED) {
  proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeResponse.displayName = 'proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeResponse';
}


if (googleProtobuf.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto suitable for use in Soy templates.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     com.google.apps.jspb.JsClassTemplate.JS_RESERVED_WORDS.
 * @param {boolean=} opt_includeInstance Whether to include the JSPB instance
 *     for transitional soy proto support: http://goto/soy-param-migration
 * @return {!Object}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeResponse.prototype.toObject = function(opt_includeInstance) {
  return proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeResponse.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Whether to include the JSPB
 *     instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeResponse} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeResponse.toObject = function(includeInstance, msg) {
  var obj = {

  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeResponse}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeResponse.deserializeBinary = function(bytes) {
  var reader = new googleProtobuf.BinaryReader(bytes);
  var msg = new proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeResponse;
  return proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeResponse.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeResponse} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeResponse}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeResponse.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeResponse.prototype.serializeBinary = function() {
  var writer = new googleProtobuf.BinaryWriter();
  proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeResponse.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeResponse} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseNodeResponse.serializeBinaryToWriter = function(message, writer) {
};



/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeRequest = function(opt_data) {
  googleProtobuf.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeRequest, googleProtobuf.Message);
if (goog.DEBUG && !COMPILED) {
  proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeRequest.displayName = 'proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeRequest';
}


if (googleProtobuf.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto suitable for use in Soy templates.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     com.google.apps.jspb.JsClassTemplate.JS_RESERVED_WORDS.
 * @param {boolean=} opt_includeInstance Whether to include the JSPB instance
 *     for transitional soy proto support: http://goto/soy-param-migration
 * @return {!Object}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeRequest.prototype.toObject = function(opt_includeInstance) {
  return proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeRequest.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Whether to include the JSPB
 *     instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeRequest} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeRequest.toObject = function(includeInstance, msg) {
  var f, obj = {
    viewId: (f = msg.getViewId()) && uuid_pb.Uuid.toObject(includeInstance, f)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeRequest}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeRequest.deserializeBinary = function(bytes) {
  var reader = new googleProtobuf.BinaryReader(bytes);
  var msg = new proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeRequest;
  return proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeRequest.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeRequest} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeRequest}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeRequest.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = new uuid_pb.Uuid;
      reader.readMessage(value,uuid_pb.Uuid.deserializeBinaryFromReader);
      msg.setViewId(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeRequest.prototype.serializeBinary = function() {
  var writer = new googleProtobuf.BinaryWriter();
  proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeRequest.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeRequest} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeRequest.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getViewId();
  if (f != null) {
    writer.writeMessage(
      1,
      f,
      uuid_pb.Uuid.serializeBinaryToWriter
    );
  }
};


/**
 * optional vertexvis.protobuf.core.Uuid view_id = 1;
 * @return {?proto.vertexvis.protobuf.core.Uuid}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeRequest.prototype.getViewId = function() {
  return /** @type{?proto.vertexvis.protobuf.core.Uuid} */ (
    googleProtobuf.Message.getWrapperField(this, uuid_pb.Uuid, 1));
};


/** @param {?proto.vertexvis.protobuf.core.Uuid|undefined} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeRequest.prototype.setViewId = function(value) {
  googleProtobuf.Message.setWrapperField(this, 1, value);
};


proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeRequest.prototype.clearViewId = function() {
  this.setViewId(undefined);
};


/**
 * Returns whether this field is set.
 * @return {!boolean}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeRequest.prototype.hasViewId = function() {
  return googleProtobuf.Message.getField(this, 1) != null;
};



/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeResponse = function(opt_data) {
  googleProtobuf.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeResponse, googleProtobuf.Message);
if (goog.DEBUG && !COMPILED) {
  proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeResponse.displayName = 'proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeResponse';
}


if (googleProtobuf.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto suitable for use in Soy templates.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     com.google.apps.jspb.JsClassTemplate.JS_RESERVED_WORDS.
 * @param {boolean=} opt_includeInstance Whether to include the JSPB instance
 *     for transitional soy proto support: http://goto/soy-param-migration
 * @return {!Object}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeResponse.prototype.toObject = function(opt_includeInstance) {
  return proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeResponse.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Whether to include the JSPB
 *     instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeResponse} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeResponse.toObject = function(includeInstance, msg) {
  var f, obj = {
    change: (f = msg.getChange()) && domain_pb.TreeChangeType.toObject(includeInstance, f),
    handshake: (f = msg.getHandshake()) && proto.vertexvis.protobuf.scenetree.v1alpha1.Handshake.toObject(includeInstance, f)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeResponse}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeResponse.deserializeBinary = function(bytes) {
  var reader = new googleProtobuf.BinaryReader(bytes);
  var msg = new proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeResponse;
  return proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeResponse.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeResponse} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeResponse}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeResponse.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = new domain_pb.TreeChangeType;
      reader.readMessage(value,domain_pb.TreeChangeType.deserializeBinaryFromReader);
      msg.setChange(value);
      break;
    case 2:
      var value = new proto.vertexvis.protobuf.scenetree.v1alpha1.Handshake;
      reader.readMessage(value,proto.vertexvis.protobuf.scenetree.v1alpha1.Handshake.deserializeBinaryFromReader);
      msg.setHandshake(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeResponse.prototype.serializeBinary = function() {
  var writer = new googleProtobuf.BinaryWriter();
  proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeResponse.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeResponse} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeResponse.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getChange();
  if (f != null) {
    writer.writeMessage(
      1,
      f,
      domain_pb.TreeChangeType.serializeBinaryToWriter
    );
  }
  f = message.getHandshake();
  if (f != null) {
    writer.writeMessage(
      2,
      f,
      proto.vertexvis.protobuf.scenetree.v1alpha1.Handshake.serializeBinaryToWriter
    );
  }
};


/**
 * optional TreeChangeType change = 1;
 * @return {?proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeResponse.prototype.getChange = function() {
  return /** @type{?proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType} */ (
    googleProtobuf.Message.getWrapperField(this, domain_pb.TreeChangeType, 1));
};


/** @param {?proto.vertexvis.protobuf.scenetree.v1alpha1.TreeChangeType|undefined} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeResponse.prototype.setChange = function(value) {
  googleProtobuf.Message.setWrapperField(this, 1, value);
};


proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeResponse.prototype.clearChange = function() {
  this.setChange(undefined);
};


/**
 * Returns whether this field is set.
 * @return {!boolean}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeResponse.prototype.hasChange = function() {
  return googleProtobuf.Message.getField(this, 1) != null;
};


/**
 * optional Handshake handshake = 2;
 * @return {?proto.vertexvis.protobuf.scenetree.v1alpha1.Handshake}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeResponse.prototype.getHandshake = function() {
  return /** @type{?proto.vertexvis.protobuf.scenetree.v1alpha1.Handshake} */ (
    googleProtobuf.Message.getWrapperField(this, proto.vertexvis.protobuf.scenetree.v1alpha1.Handshake, 2));
};


/** @param {?proto.vertexvis.protobuf.scenetree.v1alpha1.Handshake|undefined} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeResponse.prototype.setHandshake = function(value) {
  googleProtobuf.Message.setWrapperField(this, 2, value);
};


proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeResponse.prototype.clearHandshake = function() {
  this.setHandshake(undefined);
};


/**
 * Returns whether this field is set.
 * @return {!boolean}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.SubscribeResponse.prototype.hasHandshake = function() {
  return googleProtobuf.Message.getField(this, 2) != null;
};



/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Handshake = function(opt_data) {
  googleProtobuf.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.vertexvis.protobuf.scenetree.v1alpha1.Handshake, googleProtobuf.Message);
if (goog.DEBUG && !COMPILED) {
  proto.vertexvis.protobuf.scenetree.v1alpha1.Handshake.displayName = 'proto.vertexvis.protobuf.scenetree.v1alpha1.Handshake';
}


if (googleProtobuf.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto suitable for use in Soy templates.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     com.google.apps.jspb.JsClassTemplate.JS_RESERVED_WORDS.
 * @param {boolean=} opt_includeInstance Whether to include the JSPB instance
 *     for transitional soy proto support: http://goto/soy-param-migration
 * @return {!Object}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Handshake.prototype.toObject = function(opt_includeInstance) {
  return proto.vertexvis.protobuf.scenetree.v1alpha1.Handshake.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Whether to include the JSPB
 *     instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.Handshake} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Handshake.toObject = function(includeInstance, msg) {
  var obj = {

  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.Handshake}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Handshake.deserializeBinary = function(bytes) {
  var reader = new googleProtobuf.BinaryReader(bytes);
  var msg = new proto.vertexvis.protobuf.scenetree.v1alpha1.Handshake;
  return proto.vertexvis.protobuf.scenetree.v1alpha1.Handshake.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.Handshake} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.Handshake}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Handshake.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Handshake.prototype.serializeBinary = function() {
  var writer = new googleProtobuf.BinaryWriter();
  proto.vertexvis.protobuf.scenetree.v1alpha1.Handshake.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.Handshake} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.Handshake.serializeBinaryToWriter = function(message, writer) {
};



/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterRequest = function(opt_data) {
  googleProtobuf.Message.initialize(this, opt_data, 0, -1, proto.vertexvis.protobuf.scenetree.v1alpha1.FilterRequest.repeatedFields_, null);
};
goog.inherits(proto.vertexvis.protobuf.scenetree.v1alpha1.FilterRequest, googleProtobuf.Message);
if (goog.DEBUG && !COMPILED) {
  proto.vertexvis.protobuf.scenetree.v1alpha1.FilterRequest.displayName = 'proto.vertexvis.protobuf.scenetree.v1alpha1.FilterRequest';
}
/**
 * List of repeated fields within this message type.
 * @private {!Array<number>}
 * @const
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterRequest.repeatedFields_ = [3];



if (googleProtobuf.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto suitable for use in Soy templates.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     com.google.apps.jspb.JsClassTemplate.JS_RESERVED_WORDS.
 * @param {boolean=} opt_includeInstance Whether to include the JSPB instance
 *     for transitional soy proto support: http://goto/soy-param-migration
 * @return {!Object}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterRequest.prototype.toObject = function(opt_includeInstance) {
  return proto.vertexvis.protobuf.scenetree.v1alpha1.FilterRequest.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Whether to include the JSPB
 *     instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.FilterRequest} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterRequest.toObject = function(includeInstance, msg) {
  var obj = {
    filter: googleProtobuf.Message.getFieldWithDefault(msg, 1, ""),
    fullTree: googleProtobuf.Message.getFieldWithDefault(msg, 2, false),
    columnsKeysList: googleProtobuf.Message.getRepeatedField(msg, 3),
    exactMatch: googleProtobuf.Message.getFieldWithDefault(msg, 4, false),
    removeHiddenItems: googleProtobuf.Message.getFieldWithDefault(msg, 5, false)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.FilterRequest}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterRequest.deserializeBinary = function(bytes) {
  var reader = new googleProtobuf.BinaryReader(bytes);
  var msg = new proto.vertexvis.protobuf.scenetree.v1alpha1.FilterRequest;
  return proto.vertexvis.protobuf.scenetree.v1alpha1.FilterRequest.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.FilterRequest} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.FilterRequest}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterRequest.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = /** @type {string} */ (reader.readString());
      msg.setFilter(value);
      break;
    case 2:
      var value = /** @type {boolean} */ (reader.readBool());
      msg.setFullTree(value);
      break;
    case 3:
      var value = /** @type {string} */ (reader.readString());
      msg.addColumnsKeys(value);
      break;
    case 4:
      var value = /** @type {boolean} */ (reader.readBool());
      msg.setExactMatch(value);
      break;
    case 5:
      var value = /** @type {boolean} */ (reader.readBool());
      msg.setRemoveHiddenItems(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterRequest.prototype.serializeBinary = function() {
  var writer = new googleProtobuf.BinaryWriter();
  proto.vertexvis.protobuf.scenetree.v1alpha1.FilterRequest.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.FilterRequest} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterRequest.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getFilter();
  if (f.length > 0) {
    writer.writeString(
      1,
      f
    );
  }
  f = message.getFullTree();
  if (f) {
    writer.writeBool(
      2,
      f
    );
  }
  f = message.getColumnsKeysList();
  if (f.length > 0) {
    writer.writeRepeatedString(
      3,
      f
    );
  }
  f = message.getExactMatch();
  if (f) {
    writer.writeBool(
      4,
      f
    );
  }
  f = message.getRemoveHiddenItems();
  if (f) {
    writer.writeBool(
      5,
      f
    );
  }
};


/**
 * optional string filter = 1;
 * @return {string}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterRequest.prototype.getFilter = function() {
  return /** @type {string} */ (googleProtobuf.Message.getFieldWithDefault(this, 1, ""));
};


/** @param {string} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterRequest.prototype.setFilter = function(value) {
  googleProtobuf.Message.setProto3StringField(this, 1, value);
};


/**
 * optional bool full_tree = 2;
 * Note that Boolean fields may be set to 0/1 when serialized from a Java server.
 * You should avoid comparisons like {@code val === true/false} in those cases.
 * @return {boolean}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterRequest.prototype.getFullTree = function() {
  return /** @type {boolean} */ (googleProtobuf.Message.getFieldWithDefault(this, 2, false));
};


/** @param {boolean} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterRequest.prototype.setFullTree = function(value) {
  googleProtobuf.Message.setProto3BooleanField(this, 2, value);
};


/**
 * repeated string columns_keys = 3;
 * @return {!Array<string>}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterRequest.prototype.getColumnsKeysList = function() {
  return /** @type {!Array<string>} */ (googleProtobuf.Message.getRepeatedField(this, 3));
};


/** @param {!Array<string>} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterRequest.prototype.setColumnsKeysList = function(value) {
  googleProtobuf.Message.setField(this, 3, value || []);
};


/**
 * @param {!string} value
 * @param {number=} opt_index
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterRequest.prototype.addColumnsKeys = function(value, opt_index) {
  googleProtobuf.Message.addToRepeatedField(this, 3, value, opt_index);
};


proto.vertexvis.protobuf.scenetree.v1alpha1.FilterRequest.prototype.clearColumnsKeysList = function() {
  this.setColumnsKeysList([]);
};


/**
 * optional bool exact_match = 4;
 * Note that Boolean fields may be set to 0/1 when serialized from a Java server.
 * You should avoid comparisons like {@code val === true/false} in those cases.
 * @return {boolean}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterRequest.prototype.getExactMatch = function() {
  return /** @type {boolean} */ (googleProtobuf.Message.getFieldWithDefault(this, 4, false));
};


/** @param {boolean} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterRequest.prototype.setExactMatch = function(value) {
  googleProtobuf.Message.setProto3BooleanField(this, 4, value);
};


/**
 * optional bool remove_hidden_items = 5;
 * Note that Boolean fields may be set to 0/1 when serialized from a Java server.
 * You should avoid comparisons like {@code val === true/false} in those cases.
 * @return {boolean}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterRequest.prototype.getRemoveHiddenItems = function() {
  return /** @type {boolean} */ (googleProtobuf.Message.getFieldWithDefault(this, 5, false));
};


/** @param {boolean} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterRequest.prototype.setRemoveHiddenItems = function(value) {
  googleProtobuf.Message.setProto3BooleanField(this, 5, value);
};



/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterResponse = function(opt_data) {
  googleProtobuf.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.vertexvis.protobuf.scenetree.v1alpha1.FilterResponse, googleProtobuf.Message);
if (goog.DEBUG && !COMPILED) {
  proto.vertexvis.protobuf.scenetree.v1alpha1.FilterResponse.displayName = 'proto.vertexvis.protobuf.scenetree.v1alpha1.FilterResponse';
}


if (googleProtobuf.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto suitable for use in Soy templates.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     com.google.apps.jspb.JsClassTemplate.JS_RESERVED_WORDS.
 * @param {boolean=} opt_includeInstance Whether to include the JSPB instance
 *     for transitional soy proto support: http://goto/soy-param-migration
 * @return {!Object}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterResponse.prototype.toObject = function(opt_includeInstance) {
  return proto.vertexvis.protobuf.scenetree.v1alpha1.FilterResponse.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Whether to include the JSPB
 *     instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.FilterResponse} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterResponse.toObject = function(includeInstance, msg) {
  var obj = {
    numberOfResults: googleProtobuf.Message.getFieldWithDefault(msg, 1, 0)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.FilterResponse}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterResponse.deserializeBinary = function(bytes) {
  var reader = new googleProtobuf.BinaryReader(bytes);
  var msg = new proto.vertexvis.protobuf.scenetree.v1alpha1.FilterResponse;
  return proto.vertexvis.protobuf.scenetree.v1alpha1.FilterResponse.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.FilterResponse} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.FilterResponse}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterResponse.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = /** @type {number} */ (reader.readUint32());
      msg.setNumberOfResults(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterResponse.prototype.serializeBinary = function() {
  var writer = new googleProtobuf.BinaryWriter();
  proto.vertexvis.protobuf.scenetree.v1alpha1.FilterResponse.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.FilterResponse} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterResponse.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getNumberOfResults();
  if (f !== 0) {
    writer.writeUint32(
      1,
      f
    );
  }
};


/**
 * optional uint32 number_of_results = 1;
 * @return {number}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterResponse.prototype.getNumberOfResults = function() {
  return /** @type {number} */ (googleProtobuf.Message.getFieldWithDefault(this, 1, 0));
};


/** @param {number} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.FilterResponse.prototype.setNumberOfResults = function(value) {
  googleProtobuf.Message.setProto3IntField(this, 1, value);
};



/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemRequest = function(opt_data) {
  googleProtobuf.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemRequest, googleProtobuf.Message);
if (goog.DEBUG && !COMPILED) {
  proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemRequest.displayName = 'proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemRequest';
}


if (googleProtobuf.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto suitable for use in Soy templates.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     com.google.apps.jspb.JsClassTemplate.JS_RESERVED_WORDS.
 * @param {boolean=} opt_includeInstance Whether to include the JSPB instance
 *     for transitional soy proto support: http://goto/soy-param-migration
 * @return {!Object}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemRequest.prototype.toObject = function(opt_includeInstance) {
  return proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemRequest.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Whether to include the JSPB
 *     instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemRequest} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemRequest.toObject = function(includeInstance, msg) {
  var f, obj = {
    nodeId: (f = msg.getNodeId()) && uuid_pb.Uuid.toObject(includeInstance, f)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemRequest}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemRequest.deserializeBinary = function(bytes) {
  var reader = new googleProtobuf.BinaryReader(bytes);
  var msg = new proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemRequest;
  return proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemRequest.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemRequest} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemRequest}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemRequest.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 2:
      var value = new uuid_pb.Uuid;
      reader.readMessage(value,uuid_pb.Uuid.deserializeBinaryFromReader);
      msg.setNodeId(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemRequest.prototype.serializeBinary = function() {
  var writer = new googleProtobuf.BinaryWriter();
  proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemRequest.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemRequest} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemRequest.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getNodeId();
  if (f != null) {
    writer.writeMessage(
      2,
      f,
      uuid_pb.Uuid.serializeBinaryToWriter
    );
  }
};


/**
 * optional vertexvis.protobuf.core.Uuid node_id = 2;
 * @return {?proto.vertexvis.protobuf.core.Uuid}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemRequest.prototype.getNodeId = function() {
  return /** @type{?proto.vertexvis.protobuf.core.Uuid} */ (
    googleProtobuf.Message.getWrapperField(this, uuid_pb.Uuid, 2));
};


/** @param {?proto.vertexvis.protobuf.core.Uuid|undefined} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemRequest.prototype.setNodeId = function(value) {
  googleProtobuf.Message.setWrapperField(this, 2, value);
};


proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemRequest.prototype.clearNodeId = function() {
  this.setNodeId(undefined);
};


/**
 * Returns whether this field is set.
 * @return {!boolean}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemRequest.prototype.hasNodeId = function() {
  return googleProtobuf.Message.getField(this, 2) != null;
};



/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemResponse = function(opt_data) {
  googleProtobuf.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemResponse, googleProtobuf.Message);
if (goog.DEBUG && !COMPILED) {
  proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemResponse.displayName = 'proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemResponse';
}


if (googleProtobuf.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto suitable for use in Soy templates.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     com.google.apps.jspb.JsClassTemplate.JS_RESERVED_WORDS.
 * @param {boolean=} opt_includeInstance Whether to include the JSPB instance
 *     for transitional soy proto support: http://goto/soy-param-migration
 * @return {!Object}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemResponse.prototype.toObject = function(opt_includeInstance) {
  return proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemResponse.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Whether to include the JSPB
 *     instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemResponse} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemResponse.toObject = function(includeInstance, msg) {
  var f, obj = {
    locatedIndex: (f = msg.getLocatedIndex()) && wrappers_pb.UInt64Value.toObject(includeInstance, f),
    requiresReload: googleProtobuf.Message.getFieldWithDefault(msg, 2, false)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemResponse}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemResponse.deserializeBinary = function(bytes) {
  var reader = new googleProtobuf.BinaryReader(bytes);
  var msg = new proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemResponse;
  return proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemResponse.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemResponse} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemResponse}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemResponse.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = new wrappers_pb.UInt64Value;
      reader.readMessage(value,wrappers_pb.UInt64Value.deserializeBinaryFromReader);
      msg.setLocatedIndex(value);
      break;
    case 2:
      var value = /** @type {boolean} */ (reader.readBool());
      msg.setRequiresReload(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemResponse.prototype.serializeBinary = function() {
  var writer = new googleProtobuf.BinaryWriter();
  proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemResponse.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemResponse} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemResponse.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getLocatedIndex();
  if (f != null) {
    writer.writeMessage(
      1,
      f,
      wrappers_pb.UInt64Value.serializeBinaryToWriter
    );
  }
  f = message.getRequiresReload();
  if (f) {
    writer.writeBool(
      2,
      f
    );
  }
};


/**
 * optional google.protobuf.UInt64Value located_index = 1;
 * @return {?proto.google.protobuf.UInt64Value}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemResponse.prototype.getLocatedIndex = function() {
  return /** @type{?proto.google.protobuf.UInt64Value} */ (
    googleProtobuf.Message.getWrapperField(this, wrappers_pb.UInt64Value, 1));
};


/** @param {?proto.google.protobuf.UInt64Value|undefined} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemResponse.prototype.setLocatedIndex = function(value) {
  googleProtobuf.Message.setWrapperField(this, 1, value);
};


proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemResponse.prototype.clearLocatedIndex = function() {
  this.setLocatedIndex(undefined);
};


/**
 * Returns whether this field is set.
 * @return {!boolean}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemResponse.prototype.hasLocatedIndex = function() {
  return googleProtobuf.Message.getField(this, 1) != null;
};


/**
 * optional bool requires_reload = 2;
 * Note that Boolean fields may be set to 0/1 when serialized from a Java server.
 * You should avoid comparisons like {@code val === true/false} in those cases.
 * @return {boolean}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemResponse.prototype.getRequiresReload = function() {
  return /** @type {boolean} */ (googleProtobuf.Message.getFieldWithDefault(this, 2, false));
};


/** @param {boolean} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.LocateItemResponse.prototype.setRequiresReload = function(value) {
  googleProtobuf.Message.setProto3BooleanField(this, 2, value);
};



/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllRequest = function(opt_data) {
  googleProtobuf.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllRequest, googleProtobuf.Message);
if (goog.DEBUG && !COMPILED) {
  proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllRequest.displayName = 'proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllRequest';
}


if (googleProtobuf.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto suitable for use in Soy templates.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     com.google.apps.jspb.JsClassTemplate.JS_RESERVED_WORDS.
 * @param {boolean=} opt_includeInstance Whether to include the JSPB instance
 *     for transitional soy proto support: http://goto/soy-param-migration
 * @return {!Object}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllRequest.prototype.toObject = function(opt_includeInstance) {
  return proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllRequest.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Whether to include the JSPB
 *     instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllRequest} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllRequest.toObject = function(includeInstance, msg) {
  var obj = {

  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllRequest}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllRequest.deserializeBinary = function(bytes) {
  var reader = new googleProtobuf.BinaryReader(bytes);
  var msg = new proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllRequest;
  return proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllRequest.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllRequest} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllRequest}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllRequest.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllRequest.prototype.serializeBinary = function() {
  var writer = new googleProtobuf.BinaryWriter();
  proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllRequest.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllRequest} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllRequest.serializeBinaryToWriter = function(message, writer) {
};



/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllResponse = function(opt_data) {
  googleProtobuf.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllResponse, googleProtobuf.Message);
if (goog.DEBUG && !COMPILED) {
  proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllResponse.displayName = 'proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllResponse';
}


if (googleProtobuf.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto suitable for use in Soy templates.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     com.google.apps.jspb.JsClassTemplate.JS_RESERVED_WORDS.
 * @param {boolean=} opt_includeInstance Whether to include the JSPB instance
 *     for transitional soy proto support: http://goto/soy-param-migration
 * @return {!Object}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllResponse.prototype.toObject = function(opt_includeInstance) {
  return proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllResponse.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Whether to include the JSPB
 *     instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllResponse} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllResponse.toObject = function(includeInstance, msg) {
  var obj = {

  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllResponse}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllResponse.deserializeBinary = function(bytes) {
  var reader = new googleProtobuf.BinaryReader(bytes);
  var msg = new proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllResponse;
  return proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllResponse.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllResponse} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllResponse}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllResponse.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllResponse.prototype.serializeBinary = function() {
  var writer = new googleProtobuf.BinaryWriter();
  proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllResponse.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllResponse} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.ExpandAllResponse.serializeBinaryToWriter = function(message, writer) {
};



/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllRequest = function(opt_data) {
  googleProtobuf.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllRequest, googleProtobuf.Message);
if (goog.DEBUG && !COMPILED) {
  proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllRequest.displayName = 'proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllRequest';
}


if (googleProtobuf.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto suitable for use in Soy templates.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     com.google.apps.jspb.JsClassTemplate.JS_RESERVED_WORDS.
 * @param {boolean=} opt_includeInstance Whether to include the JSPB instance
 *     for transitional soy proto support: http://goto/soy-param-migration
 * @return {!Object}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllRequest.prototype.toObject = function(opt_includeInstance) {
  return proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllRequest.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Whether to include the JSPB
 *     instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllRequest} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllRequest.toObject = function(includeInstance, msg) {
  var obj = {

  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllRequest}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllRequest.deserializeBinary = function(bytes) {
  var reader = new googleProtobuf.BinaryReader(bytes);
  var msg = new proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllRequest;
  return proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllRequest.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllRequest} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllRequest}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllRequest.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllRequest.prototype.serializeBinary = function() {
  var writer = new googleProtobuf.BinaryWriter();
  proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllRequest.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllRequest} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllRequest.serializeBinaryToWriter = function(message, writer) {
};



/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllResponse = function(opt_data) {
  googleProtobuf.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllResponse, googleProtobuf.Message);
if (goog.DEBUG && !COMPILED) {
  proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllResponse.displayName = 'proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllResponse';
}


if (googleProtobuf.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto suitable for use in Soy templates.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     com.google.apps.jspb.JsClassTemplate.JS_RESERVED_WORDS.
 * @param {boolean=} opt_includeInstance Whether to include the JSPB instance
 *     for transitional soy proto support: http://goto/soy-param-migration
 * @return {!Object}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllResponse.prototype.toObject = function(opt_includeInstance) {
  return proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllResponse.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Whether to include the JSPB
 *     instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllResponse} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllResponse.toObject = function(includeInstance, msg) {
  var obj = {

  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllResponse}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllResponse.deserializeBinary = function(bytes) {
  var reader = new googleProtobuf.BinaryReader(bytes);
  var msg = new proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllResponse;
  return proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllResponse.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllResponse} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllResponse}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllResponse.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllResponse.prototype.serializeBinary = function() {
  var writer = new googleProtobuf.BinaryWriter();
  proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllResponse.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllResponse} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.CollapseAllResponse.serializeBinaryToWriter = function(message, writer) {
};



/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsRequest = function(opt_data) {
  googleProtobuf.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsRequest, googleProtobuf.Message);
if (goog.DEBUG && !COMPILED) {
  proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsRequest.displayName = 'proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsRequest';
}


if (googleProtobuf.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto suitable for use in Soy templates.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     com.google.apps.jspb.JsClassTemplate.JS_RESERVED_WORDS.
 * @param {boolean=} opt_includeInstance Whether to include the JSPB instance
 *     for transitional soy proto support: http://goto/soy-param-migration
 * @return {!Object}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsRequest.prototype.toObject = function(opt_includeInstance) {
  return proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsRequest.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Whether to include the JSPB
 *     instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsRequest} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsRequest.toObject = function(includeInstance, msg) {
  var f, obj = {
    nodeId: (f = msg.getNodeId()) && uuid_pb.Uuid.toObject(includeInstance, f)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsRequest}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsRequest.deserializeBinary = function(bytes) {
  var reader = new googleProtobuf.BinaryReader(bytes);
  var msg = new proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsRequest;
  return proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsRequest.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsRequest} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsRequest}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsRequest.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = new uuid_pb.Uuid;
      reader.readMessage(value,uuid_pb.Uuid.deserializeBinaryFromReader);
      msg.setNodeId(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsRequest.prototype.serializeBinary = function() {
  var writer = new googleProtobuf.BinaryWriter();
  proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsRequest.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsRequest} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsRequest.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getNodeId();
  if (f != null) {
    writer.writeMessage(
      1,
      f,
      uuid_pb.Uuid.serializeBinaryToWriter
    );
  }
};


/**
 * optional vertexvis.protobuf.core.Uuid node_id = 1;
 * @return {?proto.vertexvis.protobuf.core.Uuid}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsRequest.prototype.getNodeId = function() {
  return /** @type{?proto.vertexvis.protobuf.core.Uuid} */ (
    googleProtobuf.Message.getWrapperField(this, uuid_pb.Uuid, 1));
};


/** @param {?proto.vertexvis.protobuf.core.Uuid|undefined} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsRequest.prototype.setNodeId = function(value) {
  googleProtobuf.Message.setWrapperField(this, 1, value);
};


proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsRequest.prototype.clearNodeId = function() {
  this.setNodeId(undefined);
};


/**
 * Returns whether this field is set.
 * @return {!boolean}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsRequest.prototype.hasNodeId = function() {
  return googleProtobuf.Message.getField(this, 1) != null;
};



/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsResponse = function(opt_data) {
  googleProtobuf.Message.initialize(this, opt_data, 0, -1, proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsResponse.repeatedFields_, null);
};
goog.inherits(proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsResponse, googleProtobuf.Message);
if (goog.DEBUG && !COMPILED) {
  proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsResponse.displayName = 'proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsResponse';
}
/**
 * List of repeated fields within this message type.
 * @private {!Array<number>}
 * @const
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsResponse.repeatedFields_ = [1];



if (googleProtobuf.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto suitable for use in Soy templates.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     com.google.apps.jspb.JsClassTemplate.JS_RESERVED_WORDS.
 * @param {boolean=} opt_includeInstance Whether to include the JSPB instance
 *     for transitional soy proto support: http://goto/soy-param-migration
 * @return {!Object}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsResponse.prototype.toObject = function(opt_includeInstance) {
  return proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsResponse.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Whether to include the JSPB
 *     instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsResponse} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsResponse.toObject = function(includeInstance, msg) {
  var obj = {
    itemsList: googleProtobuf.Message.toObjectList(msg.getItemsList(),
    domain_pb.Node.toObject, includeInstance)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsResponse}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsResponse.deserializeBinary = function(bytes) {
  var reader = new googleProtobuf.BinaryReader(bytes);
  var msg = new proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsResponse;
  return proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsResponse.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsResponse} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsResponse}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsResponse.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = new domain_pb.Node;
      reader.readMessage(value,domain_pb.Node.deserializeBinaryFromReader);
      msg.addItems(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsResponse.prototype.serializeBinary = function() {
  var writer = new googleProtobuf.BinaryWriter();
  proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsResponse.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsResponse} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsResponse.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getItemsList();
  if (f.length > 0) {
    writer.writeRepeatedMessage(
      1,
      f,
      domain_pb.Node.serializeBinaryToWriter
    );
  }
};


/**
 * repeated Node items = 1;
 * @return {!Array<!proto.vertexvis.protobuf.scenetree.v1alpha1.Node>}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsResponse.prototype.getItemsList = function() {
  return /** @type{!Array<!proto.vertexvis.protobuf.scenetree.v1alpha1.Node>} */ (
    googleProtobuf.Message.getRepeatedWrapperField(this, domain_pb.Node, 1));
};


/** @param {!Array<!proto.vertexvis.protobuf.scenetree.v1alpha1.Node>} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsResponse.prototype.setItemsList = function(value) {
  googleProtobuf.Message.setRepeatedWrapperField(this, 1, value);
};


/**
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.Node=} opt_value
 * @param {number=} opt_index
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.Node}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsResponse.prototype.addItems = function(opt_value, opt_index) {
  return googleProtobuf.Message.addToRepeatedWrapperField(this, 1, opt_value, proto.vertexvis.protobuf.scenetree.v1alpha1.Node, opt_index);
};


proto.vertexvis.protobuf.scenetree.v1alpha1.GetNodeAncestorsResponse.prototype.clearItemsList = function() {
  this.setItemsList([]);
};



/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsRequest = function(opt_data) {
  googleProtobuf.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsRequest, googleProtobuf.Message);
if (goog.DEBUG && !COMPILED) {
  proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsRequest.displayName = 'proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsRequest';
}


if (googleProtobuf.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto suitable for use in Soy templates.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     com.google.apps.jspb.JsClassTemplate.JS_RESERVED_WORDS.
 * @param {boolean=} opt_includeInstance Whether to include the JSPB instance
 *     for transitional soy proto support: http://goto/soy-param-migration
 * @return {!Object}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsRequest.prototype.toObject = function(opt_includeInstance) {
  return proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsRequest.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Whether to include the JSPB
 *     instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsRequest} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsRequest.toObject = function(includeInstance, msg) {
  var obj = {

  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsRequest}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsRequest.deserializeBinary = function(bytes) {
  var reader = new googleProtobuf.BinaryReader(bytes);
  var msg = new proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsRequest;
  return proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsRequest.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsRequest} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsRequest}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsRequest.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsRequest.prototype.serializeBinary = function() {
  var writer = new googleProtobuf.BinaryWriter();
  proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsRequest.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsRequest} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsRequest.serializeBinaryToWriter = function(message, writer) {
};



/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsResponse = function(opt_data) {
  googleProtobuf.Message.initialize(this, opt_data, 0, -1, proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsResponse.repeatedFields_, null);
};
goog.inherits(proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsResponse, googleProtobuf.Message);
if (goog.DEBUG && !COMPILED) {
  proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsResponse.displayName = 'proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsResponse';
}
/**
 * List of repeated fields within this message type.
 * @private {!Array<number>}
 * @const
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsResponse.repeatedFields_ = [1];



if (googleProtobuf.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto suitable for use in Soy templates.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     com.google.apps.jspb.JsClassTemplate.JS_RESERVED_WORDS.
 * @param {boolean=} opt_includeInstance Whether to include the JSPB instance
 *     for transitional soy proto support: http://goto/soy-param-migration
 * @return {!Object}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsResponse.prototype.toObject = function(opt_includeInstance) {
  return proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsResponse.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Whether to include the JSPB
 *     instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsResponse} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsResponse.toObject = function(includeInstance, msg) {
  var obj = {
    keysList: googleProtobuf.Message.toObjectList(msg.getKeysList(),
    domain_pb.ColumnKey.toObject, includeInstance)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsResponse}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsResponse.deserializeBinary = function(bytes) {
  var reader = new googleProtobuf.BinaryReader(bytes);
  var msg = new proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsResponse;
  return proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsResponse.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsResponse} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsResponse}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsResponse.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = new domain_pb.ColumnKey;
      reader.readMessage(value,domain_pb.ColumnKey.deserializeBinaryFromReader);
      msg.addKeys(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsResponse.prototype.serializeBinary = function() {
  var writer = new googleProtobuf.BinaryWriter();
  proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsResponse.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsResponse} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsResponse.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getKeysList();
  if (f.length > 0) {
    writer.writeRepeatedMessage(
      1,
      f,
      domain_pb.ColumnKey.serializeBinaryToWriter
    );
  }
};


/**
 * repeated ColumnKey keys = 1;
 * @return {!Array<!proto.vertexvis.protobuf.scenetree.v1alpha1.ColumnKey>}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsResponse.prototype.getKeysList = function() {
  return /** @type{!Array<!proto.vertexvis.protobuf.scenetree.v1alpha1.ColumnKey>} */ (
    googleProtobuf.Message.getRepeatedWrapperField(this, domain_pb.ColumnKey, 1));
};


/** @param {!Array<!proto.vertexvis.protobuf.scenetree.v1alpha1.ColumnKey>} value */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsResponse.prototype.setKeysList = function(value) {
  googleProtobuf.Message.setRepeatedWrapperField(this, 1, value);
};


/**
 * @param {!proto.vertexvis.protobuf.scenetree.v1alpha1.ColumnKey=} opt_value
 * @param {number=} opt_index
 * @return {!proto.vertexvis.protobuf.scenetree.v1alpha1.ColumnKey}
 */
proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsResponse.prototype.addKeys = function(opt_value, opt_index) {
  return googleProtobuf.Message.addToRepeatedWrapperField(this, 1, opt_value, proto.vertexvis.protobuf.scenetree.v1alpha1.ColumnKey, opt_index);
};


proto.vertexvis.protobuf.scenetree.v1alpha1.GetAvailableColumnsResponse.prototype.clearKeysList = function() {
  this.setKeysList([]);
};


goog.object.extend(exports, proto.vertexvis.protobuf.scenetree.v1alpha1);
});

var SceneTreeErrorCode;
(function (SceneTreeErrorCode) {
  SceneTreeErrorCode[SceneTreeErrorCode["UNKNOWN"] = 0] = "UNKNOWN";
  SceneTreeErrorCode[SceneTreeErrorCode["SCENE_TREE_DISABLED"] = 1] = "SCENE_TREE_DISABLED";
  SceneTreeErrorCode[SceneTreeErrorCode["MISSING_VIEWER"] = 2] = "MISSING_VIEWER";
  SceneTreeErrorCode[SceneTreeErrorCode["DISCONNECTED"] = 3] = "DISCONNECTED";
  SceneTreeErrorCode[SceneTreeErrorCode["SUBSCRIPTION_FAILURE"] = 4] = "SUBSCRIPTION_FAILURE";
  SceneTreeErrorCode[SceneTreeErrorCode["UNAUTHORIZED"] = 5] = "UNAUTHORIZED";
  SceneTreeErrorCode[SceneTreeErrorCode["ABORTED"] = 6] = "ABORTED";
})(SceneTreeErrorCode || (SceneTreeErrorCode = {}));
class SceneTreeErrorDetails {
  constructor(name, code, link) {
    this.name = name;
    this.code = code;
    this.link = link;
    this.message = getSceneTreeErrorMessage(code);
  }
}
function getSceneTreeErrorMessage(code) {
  switch (code) {
    case SceneTreeErrorCode.UNKNOWN:
      return 'An unknown error occurred.';
    case SceneTreeErrorCode.SCENE_TREE_DISABLED:
      return 'The tree for this scene is not enabled. Enable the tree for this scene to interact with the tree.';
    case SceneTreeErrorCode.MISSING_VIEWER:
      return 'Could not find reference to the viewer.';
    case SceneTreeErrorCode.DISCONNECTED:
      return 'Disconnected from server.';
    case SceneTreeErrorCode.SUBSCRIPTION_FAILURE:
      return 'The tree was not able to receive subscription events.';
    case SceneTreeErrorCode.UNAUTHORIZED:
      return 'The tree was unauthorized to connect to the server. The associated Viewer may not be connected.';
    case SceneTreeErrorCode.ABORTED:
      return 'Unable to load the tree for this scene.';
  }
}
class SceneTreeError extends CustomError {
  constructor(message, e) {
    super(message, e);
    // Allows for `instanceof` checks.
    Object.setPrototypeOf(this, SceneTreeError.prototype);
  }
}
class SceneTreeUnauthorizedError extends SceneTreeError {
  constructor(message, e) {
    super(message, e);
    // Allows for `instanceof` checks.
    Object.setPrototypeOf(this, SceneTreeUnauthorizedError.prototype);
  }
}
class SceneTreeConnectionCancelledError extends SceneTreeError {
  constructor(message, e) {
    super(message, e);
    // Allows for `instanceof` checks.
    Object.setPrototypeOf(this, SceneTreeConnectionCancelledError.prototype);
  }
}
class SceneTreeOperationFailedError extends SceneTreeError {
  constructor(message, e) {
    super(message, e);
    // Allows for `instanceof` checks.
    Object.setPrototypeOf(this, SceneTreeOperationFailedError.prototype);
  }
}

// package: vertexvis.protobuf.scenetree.v1alpha1
// file: scenetree/protos/scene_tree_api.proto


var grpc = grpcWebClient_umd.grpc;

var SceneTreeAPI = (function () {
  function SceneTreeAPI() {}
  SceneTreeAPI.serviceName = "vertexvis.protobuf.scenetree.v1alpha1.SceneTreeAPI";
  return SceneTreeAPI;
}());

SceneTreeAPI.GetTree = {
  methodName: "GetTree",
  service: SceneTreeAPI,
  requestStream: false,
  responseStream: false,
  requestType: scene_tree_api_pb.GetTreeRequest,
  responseType: scene_tree_api_pb.GetTreeResponse
};

SceneTreeAPI.ExpandNode = {
  methodName: "ExpandNode",
  service: SceneTreeAPI,
  requestStream: false,
  responseStream: false,
  requestType: scene_tree_api_pb.ExpandNodeRequest,
  responseType: scene_tree_api_pb.ExpandNodeResponse
};

SceneTreeAPI.CollapseNode = {
  methodName: "CollapseNode",
  service: SceneTreeAPI,
  requestStream: false,
  responseStream: false,
  requestType: scene_tree_api_pb.CollapseNodeRequest,
  responseType: scene_tree_api_pb.CollapseNodeResponse
};

SceneTreeAPI.Subscribe = {
  methodName: "Subscribe",
  service: SceneTreeAPI,
  requestStream: false,
  responseStream: true,
  requestType: scene_tree_api_pb.SubscribeRequest,
  responseType: scene_tree_api_pb.SubscribeResponse
};

SceneTreeAPI.Filter = {
  methodName: "Filter",
  service: SceneTreeAPI,
  requestStream: false,
  responseStream: false,
  requestType: scene_tree_api_pb.FilterRequest,
  responseType: scene_tree_api_pb.FilterResponse
};

SceneTreeAPI.LocateItem = {
  methodName: "LocateItem",
  service: SceneTreeAPI,
  requestStream: false,
  responseStream: false,
  requestType: scene_tree_api_pb.LocateItemRequest,
  responseType: scene_tree_api_pb.LocateItemResponse
};

SceneTreeAPI.ExpandAll = {
  methodName: "ExpandAll",
  service: SceneTreeAPI,
  requestStream: false,
  responseStream: false,
  requestType: scene_tree_api_pb.ExpandAllRequest,
  responseType: scene_tree_api_pb.ExpandAllResponse
};

SceneTreeAPI.CollapseAll = {
  methodName: "CollapseAll",
  service: SceneTreeAPI,
  requestStream: false,
  responseStream: false,
  requestType: scene_tree_api_pb.CollapseAllRequest,
  responseType: scene_tree_api_pb.CollapseAllResponse
};

SceneTreeAPI.GetNodeAncestors = {
  methodName: "GetNodeAncestors",
  service: SceneTreeAPI,
  requestStream: false,
  responseStream: false,
  requestType: scene_tree_api_pb.GetNodeAncestorsRequest,
  responseType: scene_tree_api_pb.GetNodeAncestorsResponse
};

SceneTreeAPI.GetAvailableColumns = {
  methodName: "GetAvailableColumns",
  service: SceneTreeAPI,
  requestStream: false,
  responseStream: false,
  requestType: scene_tree_api_pb.GetAvailableColumnsRequest,
  responseType: scene_tree_api_pb.GetAvailableColumnsResponse
};

var SceneTreeAPI_1 = SceneTreeAPI;

function SceneTreeAPIClient(serviceHost, options) {
  this.serviceHost = serviceHost;
  this.options = options || {};
}

SceneTreeAPIClient.prototype.getTree = function getTree(requestMessage, metadata, callback) {
  if (arguments.length === 2) {
    callback = arguments[1];
  }
  var client = grpc.unary(SceneTreeAPI.GetTree, {
    request: requestMessage,
    host: this.serviceHost,
    metadata: metadata,
    transport: this.options.transport,
    debug: this.options.debug,
    onEnd: function (response) {
      if (callback) {
        if (response.status !== grpc.Code.OK) {
          var err = new Error(response.statusMessage);
          err.code = response.status;
          err.metadata = response.trailers;
          callback(err, null);
        } else {
          callback(null, response.message);
        }
      }
    }
  });
  return {
    cancel: function () {
      callback = null;
      client.close();
    }
  };
};

SceneTreeAPIClient.prototype.expandNode = function expandNode(requestMessage, metadata, callback) {
  if (arguments.length === 2) {
    callback = arguments[1];
  }
  var client = grpc.unary(SceneTreeAPI.ExpandNode, {
    request: requestMessage,
    host: this.serviceHost,
    metadata: metadata,
    transport: this.options.transport,
    debug: this.options.debug,
    onEnd: function (response) {
      if (callback) {
        if (response.status !== grpc.Code.OK) {
          var err = new Error(response.statusMessage);
          err.code = response.status;
          err.metadata = response.trailers;
          callback(err, null);
        } else {
          callback(null, response.message);
        }
      }
    }
  });
  return {
    cancel: function () {
      callback = null;
      client.close();
    }
  };
};

SceneTreeAPIClient.prototype.collapseNode = function collapseNode(requestMessage, metadata, callback) {
  if (arguments.length === 2) {
    callback = arguments[1];
  }
  var client = grpc.unary(SceneTreeAPI.CollapseNode, {
    request: requestMessage,
    host: this.serviceHost,
    metadata: metadata,
    transport: this.options.transport,
    debug: this.options.debug,
    onEnd: function (response) {
      if (callback) {
        if (response.status !== grpc.Code.OK) {
          var err = new Error(response.statusMessage);
          err.code = response.status;
          err.metadata = response.trailers;
          callback(err, null);
        } else {
          callback(null, response.message);
        }
      }
    }
  });
  return {
    cancel: function () {
      callback = null;
      client.close();
    }
  };
};

SceneTreeAPIClient.prototype.subscribe = function subscribe(requestMessage, metadata) {
  var listeners = {
    data: [],
    end: [],
    status: []
  };
  var client = grpc.invoke(SceneTreeAPI.Subscribe, {
    request: requestMessage,
    host: this.serviceHost,
    metadata: metadata,
    transport: this.options.transport,
    debug: this.options.debug,
    onMessage: function (responseMessage) {
      listeners.data.forEach(function (handler) {
        handler(responseMessage);
      });
    },
    onEnd: function (status, statusMessage, trailers) {
      listeners.status.forEach(function (handler) {
        handler({ code: status, details: statusMessage, metadata: trailers });
      });
      listeners.end.forEach(function (handler) {
        handler({ code: status, details: statusMessage, metadata: trailers });
      });
      listeners = null;
    }
  });
  return {
    on: function (type, handler) {
      listeners[type].push(handler);
      return this;
    },
    cancel: function () {
      listeners = null;
      client.close();
    }
  };
};

SceneTreeAPIClient.prototype.filter = function filter(requestMessage, metadata, callback) {
  if (arguments.length === 2) {
    callback = arguments[1];
  }
  var client = grpc.unary(SceneTreeAPI.Filter, {
    request: requestMessage,
    host: this.serviceHost,
    metadata: metadata,
    transport: this.options.transport,
    debug: this.options.debug,
    onEnd: function (response) {
      if (callback) {
        if (response.status !== grpc.Code.OK) {
          var err = new Error(response.statusMessage);
          err.code = response.status;
          err.metadata = response.trailers;
          callback(err, null);
        } else {
          callback(null, response.message);
        }
      }
    }
  });
  return {
    cancel: function () {
      callback = null;
      client.close();
    }
  };
};

SceneTreeAPIClient.prototype.locateItem = function locateItem(requestMessage, metadata, callback) {
  if (arguments.length === 2) {
    callback = arguments[1];
  }
  var client = grpc.unary(SceneTreeAPI.LocateItem, {
    request: requestMessage,
    host: this.serviceHost,
    metadata: metadata,
    transport: this.options.transport,
    debug: this.options.debug,
    onEnd: function (response) {
      if (callback) {
        if (response.status !== grpc.Code.OK) {
          var err = new Error(response.statusMessage);
          err.code = response.status;
          err.metadata = response.trailers;
          callback(err, null);
        } else {
          callback(null, response.message);
        }
      }
    }
  });
  return {
    cancel: function () {
      callback = null;
      client.close();
    }
  };
};

SceneTreeAPIClient.prototype.expandAll = function expandAll(requestMessage, metadata, callback) {
  if (arguments.length === 2) {
    callback = arguments[1];
  }
  var client = grpc.unary(SceneTreeAPI.ExpandAll, {
    request: requestMessage,
    host: this.serviceHost,
    metadata: metadata,
    transport: this.options.transport,
    debug: this.options.debug,
    onEnd: function (response) {
      if (callback) {
        if (response.status !== grpc.Code.OK) {
          var err = new Error(response.statusMessage);
          err.code = response.status;
          err.metadata = response.trailers;
          callback(err, null);
        } else {
          callback(null, response.message);
        }
      }
    }
  });
  return {
    cancel: function () {
      callback = null;
      client.close();
    }
  };
};

SceneTreeAPIClient.prototype.collapseAll = function collapseAll(requestMessage, metadata, callback) {
  if (arguments.length === 2) {
    callback = arguments[1];
  }
  var client = grpc.unary(SceneTreeAPI.CollapseAll, {
    request: requestMessage,
    host: this.serviceHost,
    metadata: metadata,
    transport: this.options.transport,
    debug: this.options.debug,
    onEnd: function (response) {
      if (callback) {
        if (response.status !== grpc.Code.OK) {
          var err = new Error(response.statusMessage);
          err.code = response.status;
          err.metadata = response.trailers;
          callback(err, null);
        } else {
          callback(null, response.message);
        }
      }
    }
  });
  return {
    cancel: function () {
      callback = null;
      client.close();
    }
  };
};

SceneTreeAPIClient.prototype.getNodeAncestors = function getNodeAncestors(requestMessage, metadata, callback) {
  if (arguments.length === 2) {
    callback = arguments[1];
  }
  var client = grpc.unary(SceneTreeAPI.GetNodeAncestors, {
    request: requestMessage,
    host: this.serviceHost,
    metadata: metadata,
    transport: this.options.transport,
    debug: this.options.debug,
    onEnd: function (response) {
      if (callback) {
        if (response.status !== grpc.Code.OK) {
          var err = new Error(response.statusMessage);
          err.code = response.status;
          err.metadata = response.trailers;
          callback(err, null);
        } else {
          callback(null, response.message);
        }
      }
    }
  });
  return {
    cancel: function () {
      callback = null;
      client.close();
    }
  };
};

SceneTreeAPIClient.prototype.getAvailableColumns = function getAvailableColumns(requestMessage, metadata, callback) {
  if (arguments.length === 2) {
    callback = arguments[1];
  }
  var client = grpc.unary(SceneTreeAPI.GetAvailableColumns, {
    request: requestMessage,
    host: this.serviceHost,
    metadata: metadata,
    transport: this.options.transport,
    debug: this.options.debug,
    onEnd: function (response) {
      if (callback) {
        if (response.status !== grpc.Code.OK) {
          var err = new Error(response.statusMessage);
          err.code = response.status;
          err.metadata = response.trailers;
          callback(err, null);
        } else {
          callback(null, response.message);
        }
      }
    }
  });
  return {
    cancel: function () {
      callback = null;
      client.close();
    }
  };
};

var SceneTreeAPIClient_1 = SceneTreeAPIClient;

function isGrpcServiceError(err) {
  return typeof err.code === 'number' && err.hasOwnProperty('metadata');
}
function webSocketSubscriptionTransportFactory(options) {
  if (options.methodDefinition.methodName === SceneTreeAPI_1.Subscribe.methodName) {
    return grpcWebClient_umd.grpc.WebsocketTransport()(options);
  }
  else {
    return grpcWebClient_umd.grpc.CrossBrowserHttpTransport({ withCredentials: false })(options);
  }
}

function e(e){this.message=e;}e.prototype=new Error,e.prototype.name="InvalidCharacterError";var r="undefined"!=typeof window&&window.atob&&window.atob.bind(window)||function(r){var t=String(r).replace(/=+$/,"");if(t.length%4==1)throw new e("'atob' failed: The string to be decoded is not correctly encoded.");for(var n,o,a=0,i=0,c="";o=t.charAt(i++);~o&&(n=a%4?64*n+o:o,a++%4)?c+=String.fromCharCode(255&n>>(-2*a&6)):0)o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=".indexOf(o);return c};function t(e){var t=e.replace(/-/g,"+").replace(/_/g,"/");switch(t.length%4){case 0:break;case 2:t+="==";break;case 3:t+="=";break;default:throw "Illegal base64url string!"}try{return function(e){return decodeURIComponent(r(e).replace(/(.)/g,(function(e,r){var t=r.charCodeAt(0).toString(16).toUpperCase();return t.length<2&&(t="0"+t),"%"+t})))}(t)}catch(e){return r(t)}}function n(e){this.message=e;}function o(e,r){if("string"!=typeof e)throw new n("Invalid token specified");var o=!0===(r=r||{}).header?0:1;try{return JSON.parse(t(e.split(".")[o]))}catch(e){throw new n("Invalid token specified: "+e.message)}}n.prototype=new Error,n.prototype.name="InvalidTokenError";

function decodeSceneTreeJwt(jwt) {
  return o(jwt);
}

/**
 * The `SceneTreeController` is responsible for coordinating interactions of the
 * view, fetching and mutating tree data on the server, maintaining state and
 * notifying the view about state changes.
 */
class SceneTreeController {
  constructor(client, rowLimit, connectOptions = {
    spinnerDelay: 2000,
    subscriptionHandshakeGracePeriodInMs: 5000,
  }) {
    this.client = client;
    this.rowLimit = rowLimit;
    this.connectOptions = connectOptions;
    this.nextPageId = 0;
    this.pages = new Map();
    this.activeRowRange = [0, 0];
    this.metadataKeys = [];
    this.debugLogs = false;
    /**
     * A dispatcher that emits an event whenever the internal state has changed.
     */
    this.onStateChange = new EventDispatcher();
    this.state = {
      totalRows: 0,
      isSearching: false,
      rows: [],
      connection: { type: 'disconnected' },
    };
  }
  /**
   * The number of pages that have been fetched.
   */
  get fetchedPageCount() {
    return this.pages.size;
  }
  /**
   * Indicates if the controller is connected to the tree backend, and can make
   * requests.
   */
  get isConnected() {
    return this.state.connection.type === 'connected';
  }
  /**
   * Registers an event listener that will be invoked when the state changes
   *
   * @param listener The listener to add.
   * @returns A disposable that can be used to remove the listener.
   */
  stateChanged(listener) {
    return this.onStateChange.on(listener);
  }
  setDebugLogs(debugLogs) {
    this.debugLogs = debugLogs;
  }
  async handleSubscriptionHandshakeTimeout(jwtProvider, sceneViewId) {
    var _a;
    const connection = this.getState().connection;
    if (this.isConnectedState(connection) &&
      ((_a = connection.subscriptionStatusState) === null || _a === void 0 ? void 0 : _a.attempt) != null &&
      connection.subscriptionStatusState.attempt <
        SceneTreeController.MAX_SUBSCRIPTION_RETRY_COUNT) {
      const newAttempt = connection.subscriptionStatusState.attempt + 1;
      console.warn(`Failed to subscribe within the allotted timeout. Retry attempt={${newAttempt}}`);
      connection.subscriptionStatusState.stream.cancel();
      this.clearHandshakeTimer();
      const stream = await this.subscribe();
      this.invalidateAfterOffset(0);
      this.fetchUnloadedPagesInActiveRows();
      this.updateState(Object.assign(Object.assign({}, this.state), { connection: Object.assign(Object.assign({}, connection), { type: 'connected', subscription: {
            dispose: () => stream.cancel(),
          }, subscriptionStatusState: {
            attempt: newAttempt,
            stream,
          } }) }));
      this.subscriptionHandshakeTimer = window.setTimeout(() => {
        this.handleSubscriptionHandshakeTimeout(jwtProvider, sceneViewId);
      }, this.connectOptions.subscriptionHandshakeGracePeriodInMs);
    }
    else {
      this.updateState(Object.assign(Object.assign({}, this.state), { connection: {
          type: 'failure',
          jwtProvider,
          sceneViewId,
          details: new SceneTreeErrorDetails('SUBSCRIPTION_FAILURE', SceneTreeErrorCode.SUBSCRIPTION_FAILURE),
        } }));
    }
  }
  async connect(jwtProvider) {
    const { connection } = this.state;
    const jwt = jwtProvider();
    if (jwt == null) {
      throw new SceneTreeUnauthorizedError('Cannot connect scene tree. JWT is undefined');
    }
    const { view: sceneViewId } = decodeSceneTreeJwt(jwt);
    if (connection.sceneViewId !== sceneViewId) {
      this.disconnect(true);
    }
    else {
      this.disconnect(false);
    }
    const connecting = {
      type: 'connecting',
      jwtProvider,
      sceneViewId,
    };
    this.updateState(Object.assign(Object.assign({}, this.state), { connection: connecting }));
    try {
      this.log('Scene tree controller connecting.');
      this.restartLoadingTimer();
      // Ensure we have a subscription prior to attempting to get the first page
      // to make sure we receive any ListChange that comes through
      const stream = await this.subscribe();
      await this.fetchPage(0);
      if (this.state.connection.type !== 'cancelled') {
        this.updateState(Object.assign(Object.assign({}, this.state), { connection: {
            jwtProvider,
            sceneViewId,
            type: 'connected',
            subscription: { dispose: () => stream.cancel() },
            subscriptionStatusState: {
              attempt: 0,
              stream,
            },
          } }));
        this.restartHandshakeTimer(jwtProvider, sceneViewId);
      }
    }
    catch (e) {
      this.ifErrorIsFatal(e, () => {
        this.updateState(Object.assign(Object.assign({}, this.state), { connection: {
            type: 'failure',
            jwtProvider,
            sceneViewId,
            details: this.getConnectionError(e),
          } }));
        this.clearHandshakeTimer();
        throw e;
      });
    }
    this.startIdleReconnectTimer();
  }
  clearReconnectTimer() {
    if (this.reconnectTimer != null) {
      window.clearTimeout(this.reconnectTimer);
    }
  }
  restartHandshakeTimer(jwtProvider, sceneViewId) {
    this.clearHandshakeTimer();
    if (!this.state.handshakeReceived) {
      this.subscriptionHandshakeTimer = window.setTimeout(() => {
        this.handleSubscriptionHandshakeTimeout(jwtProvider, sceneViewId);
        this.subscriptionHandshakeTimer = undefined;
      }, this.connectOptions.subscriptionHandshakeGracePeriodInMs);
    }
  }
  clearHandshakeTimer() {
    if (this.subscriptionHandshakeTimer != null) {
      window.clearTimeout(this.subscriptionHandshakeTimer);
      this.subscriptionHandshakeTimer = undefined;
    }
  }
  startIdleReconnectTimer() {
    this.startReconnectTimer(this.connectOptions.idleReconnectInSeconds ||
      SceneTreeController.IDLE_RECONNECT_IN_SECONDS);
  }
  startConnectionLostReconnectTimer() {
    this.startReconnectTimer(this.connectOptions.lostConnectionReconnectInSeconds ||
      SceneTreeController.LOST_CONNECTION_RECONNECT_IN_SECONDS);
  }
  startReconnectTimer(delayInSeconds) {
    this.clearReconnectTimer();
    this.reconnectTimer = window.setTimeout(() => {
      if (this.state.connection.type === 'connected') {
        this.connect(this.state.connection.jwtProvider);
      }
    }, delayInSeconds * 1000);
  }
  connectToViewer(viewer) {
    const connectWithViewerJwt = async () => {
      if (viewer.token != null) {
        this.log('Scene tree controller found viewer JWT. Attempting connection.');
        try {
          await this.connect(() => viewer.token);
        }
        catch (e) {
          this.ifErrorIsFatal(e, () => {
            console.error('Scene tree controller errored connecting.', e);
          });
        }
      }
      else {
        this.log('Scene tree controller was unable to find JWT.');
      }
    };
    const handleSceneReady = () => {
      this.log('Scene tree controller received scene ready');
      connectWithViewerJwt();
    };
    connectWithViewerJwt();
    viewer.addEventListener('sceneReady', handleSceneReady);
    return {
      dispose: () => {
        viewer.removeEventListener('sceneReady', handleSceneReady);
        this.disconnect();
      },
    };
  }
  disconnect(reset = false) {
    this.log(`Scene tree controller disconnecting [reset=${reset}]`);
    this.clearHandshakeTimer();
    this.clearReconnectTimer();
    if (reset) {
      this.pages.clear();
      this.activeRowRange = [];
    }
    const { connection } = this.state;
    if (connection.type === 'connected') {
      connection.subscription.dispose();
    }
    this.updateState({
      connection: {
        type: 'disconnected',
        jwtProvider: connection.jwtProvider,
        sceneViewId: connection.sceneViewId,
      },
      isSearching: false,
      totalRows: reset ? 0 : this.state.totalRows,
      rows: reset ? [] : this.state.rows,
      filterTerm: reset ? undefined : this.state.filterTerm,
      totalFilteredRows: reset ? undefined : this.state.totalFilteredRows,
      shouldShowEmptyResults: reset
        ? undefined
        : this.state.shouldShowEmptyResults,
      handshakeReceived: reset ? undefined : this.state.handshakeReceived,
      firstFetchComplete: reset ? undefined : this.state.firstFetchComplete,
    });
  }
  cancel() {
    this.log(`Scene tree controller cancelled`);
    this.clearHandshakeTimer();
    this.clearReconnectTimer();
    this.pages.clear();
    this.activeRowRange = [];
    const { connection } = this.state;
    if (connection.type === 'connected') {
      connection.subscription.dispose();
    }
    this.updateState({
      connection: {
        type: 'cancelled',
        jwtProvider: connection.jwtProvider,
        sceneViewId: connection.sceneViewId,
      },
      isSearching: false,
      totalRows: 0,
      rows: [],
    });
  }
  /**
   * Collapses a node with the given node ID.
   *
   * @param id A node ID to collapse.
   */
  async collapseNode(id) {
    return this.ifConnectionHasJwt(async (jwt) => {
      const nodeId = new uuid_pb.Uuid();
      nodeId.setHex(id);
      const req = new scene_tree_api_pb.CollapseNodeRequest();
      req.setNodeId(nodeId);
      await this.requestUnary(jwt, (metadata, handler) => this.client.collapseNode(req, metadata, handler));
    });
  }
  /**
   * Expands a node with the given node ID.
   *
   * @param id A node ID to expand.
   */
  async expandNode(id) {
    return this.ifConnectionHasJwt(async (jwt) => {
      const nodeId = new uuid_pb.Uuid();
      nodeId.setHex(id);
      const req = new scene_tree_api_pb.ExpandNodeRequest();
      req.setNodeId(nodeId);
      await this.requestUnary(jwt, (metadata, handler) => this.client.expandNode(req, metadata, handler));
    });
  }
  /**
   * Collapses all nodes in the tree.
   */
  async collapseAll() {
    return this.ifConnectionHasJwt(async (jwt) => {
      await this.requestUnary(jwt, (metadata, handler) => this.client.collapseAll(new scene_tree_api_pb.CollapseAllRequest(), metadata, handler));
    });
  }
  /**
   * Expands all nodes in the tree.
   */
  async expandAll() {
    return this.ifConnectionHasJwt(async (jwt) => {
      await this.requestUnary(jwt, (metadata, handler) => this.client.expandAll(new scene_tree_api_pb.ExpandAllRequest(), metadata, handler));
    });
  }
  /**
   * Invokes a network request that will expand all the parent nodes for the
   * node mapped to the given ID.
   *
   * @param id An ID of an item.
   * @returns A promise that resolves with the index of the node after
   *  expansion.
   */
  async expandParentNodes(id) {
    return this.ifConnectionHasJwt(async (jwt) => {
      const nodeId = new uuid_pb.Uuid();
      nodeId.setHex(id);
      const req = new scene_tree_api_pb.LocateItemRequest();
      req.setNodeId(nodeId);
      const res = await this.requestUnary(jwt, (metadata, handler) => this.client.locateItem(req, metadata, handler));
      const { requiresReload, locatedIndex } = res.toObject();
      if (requiresReload) {
        this.invalidateAfterOffset(0);
        await this.fetchUnloadedPagesInActiveRows();
      }
      if (locatedIndex == null) {
        throw new SceneTreeOperationFailedError('Cannot locate node. Location index is undefined.');
      }
      return locatedIndex.value;
    });
  }
  async fetchNodeAncestors(nodeId) {
    return this.ifConnectionHasJwt(async (jwt) => {
      const nodeUuid = new uuid_pb.Uuid();
      nodeUuid.setHex(nodeId);
      const req = new scene_tree_api_pb.GetNodeAncestorsRequest();
      req.setNodeId(nodeUuid);
      const res = await this.requestUnary(jwt, (metadata, handler) => this.client.getNodeAncestors(req, metadata, handler));
      return res.toObject().itemsList;
    });
  }
  /**
   * Fetches a page at the given index. Once the data has been fetched, the
   * controller will emit an `onStateChange` event that contains rows with the
   * fetched page. If a page is invalidated before the request completes, the
   * response is ignored.
   *
   * If the index is out of range, returns without fetching any data.
   *
   * @param index A 0 based index to fetch.
   */
  async fetchPage(index) {
    return this.ifConnectionHasJwt(async (jwt) => {
      var _a;
      if (index < 0 || index > this.maxPages - 1) {
        return;
      }
      if (!this.pages.has(index)) {
        const offset = index * this.rowLimit;
        this.log('Scene tree fetching page', index, offset);
        const res = this.fetchTree(offset, this.rowLimit, jwt);
        const id = this.nextPageId++;
        const page = { id, res, index, metadataKeys: this.metadataKeys };
        this.pages.set(index, page);
        this.handlePageResult(page);
      }
      await ((_a = this.pages.get(index)) === null || _a === void 0 ? void 0 : _a.res);
    });
  }
  /**
   * Fetches a page that contains the given row offset.
   *
   * @param offset The row offset of the page to fetch.
   */
  fetchPageAtOffset(offset) {
    const page = Math.floor(offset / this.rowLimit);
    return this.fetchPage(page);
  }
  /**
   * Fetches pages that contain the given row ranges.
   *
   * @param startOffset A start offset, inclusive.
   * @param endOffset The end offset, inclusive.
   */
  async fetchRange(startOffset, endOffset) {
    const startPage = Math.floor(startOffset / this.rowLimit);
    const endPage = Math.floor(endOffset / this.rowLimit);
    const [boundedStart, boundedEnd] = this.constrainPageRange(startPage, endPage);
    const pageCount = boundedEnd - boundedStart + 1;
    await Promise.all(Array.from({ length: pageCount }).map((_, page) => this.fetchPage(page)));
  }
  /**
   * Fetches the metadata keys for the current scene view.
   */
  async fetchMetadataKeys() {
    return this.ifConnectionHasJwt(async (jwt) => {
      const res = await this.requestUnary(jwt, (meta, handler) => {
        const req = new scene_tree_api_pb.GetAvailableColumnsRequest();
        this.client.getAvailableColumns(req, meta, handler);
      });
      return res.getKeysList().map((value) => value.getValue());
    });
  }
  /**
   * Performs a network request that will filter the nodes in the tree that
   * match the given term and options.
   *
   * @param term The filter term.
   * @param options The options to apply to the filter.
   */
  async filter(term, options = {}) {
    return this.ifConnectionHasJwt(async (jwt) => {
      var _a;
      this.updateState(Object.assign(Object.assign({}, this.state), { isSearching: true, filterTerm: term !== '' ? term : undefined }));
      // Cancel any in-flight filter requests, and wait for the request
      // to complete prior to making another filter request. This prevents
      // a race condition between requests from different keystrokes.
      (_a = this.pendingFilterGrpcRes) === null || _a === void 0 ? void 0 : _a.cancel();
      this.pendingFilterGrpcRes = undefined;
      if (this.state.filterTerm === term || term === '') {
        try {
          const res = await this.requestUnary(jwt, (metadata, handler) => {
            var _a;
            const req = new scene_tree_api_pb.FilterRequest();
            req.setFilter(term);
            req.setFullTree((_a = options.includeCollapsed) !== null && _a !== void 0 ? _a : true);
            req.setExactMatch(!!options.exactMatch);
            req.setRemoveHiddenItems(!!options.removeHiddenItems);
            if (options.columns)
              req.setColumnsKeysList(options.columns);
            this.pendingFilterGrpcRes = this.client.filter(req, metadata, handler);
          });
          const { numberOfResults } = res.toObject();
          this.updateState(Object.assign(Object.assign({}, this.state), { totalFilteredRows: numberOfResults, isSearching: false }));
        }
        catch (e) {
          console.error('Failed to filter search ', e);
          this.updateState(Object.assign(Object.assign({}, this.state), { isSearching: false }));
        }
      }
    });
  }
  /**
   * Checks if the page at the given index is loaded.
   *
   * @param index A page index.
   * @returns `true` if the page is loaded. `false` otherwise.
   */
  isPageLoaded(index) {
    return this.pages.has(index);
  }
  /**
   * Returns a list of page indices within a range that have not been loaded.
   *
   * @param start The start page index, inclusive.
   * @param end The end page index, inclusive.
   * @returns A list of pages indices that have not been loaded.
   */
  getNonLoadedPageIndexes(start, end) {
    const [boundedStart, boundedEnd] = this.constrainPageRange(start, end);
    const pageCount = boundedEnd - boundedStart + 1;
    return Array.from({ length: pageCount })
      .map((_, i) => boundedStart + i)
      .filter((page) => !this.isPageLoaded(page));
  }
  /**
   * Returns the page at the given index, or `undefined` if one doesn't exist.
   *
   * @param index The index to return.
   * @returns A `Page` if found, otherwise `undefined`.
   */
  getPage(index) {
    return this.pages.get(index);
  }
  /**
   * Clears page data that is outside a given range. Uses a distance algorithm
   * to removes pages that are furthest from either end of the range. This
   * method is useful for clearing out data that is not needed anymore to keep
   * memory pressure in the client low.
   *
   * @param startPage The index of the starting page in the range.
   * @param endPage The index of the ending page in the range.
   * @param threshold A minimum number of pages to keep. No cleanup is performed
   *  if the number of fetched pages doesn't meet this threshold.
   */
  invalidatePagesOutsideRange(startPage, endPage, threshold = 0) {
    const [boundedStart, boundedEnd] = this.constrainPageRange(startPage, endPage);
    const boundedThreshold = Math.max(boundedEnd - boundedStart, threshold);
    if (this.fetchedPageCount > boundedThreshold) {
      const pages = Array.from(this.pages.keys()).map((index) => {
        const distance = index < boundedStart ? boundedStart - index : index - boundedEnd;
        return { index, distance };
      });
      const sortedDesc = pages.sort((a, b) => b.distance - a.distance);
      sortedDesc
        .slice(0, pages.length - threshold)
        .forEach(({ index }) => this.invalidatePage(index));
      this.log(`Scene tree dropped ${pages.length - this.fetchedPageCount} pages`, this.pages);
    }
  }
  setMetadataKeys(keys) {
    this.metadataKeys = keys;
    if (this.state.connection.type === 'connected') {
      const [start, end] = this.activeRowRange;
      this.invalidateAfterOffset(0);
      return this.updateActiveRowRange(start, end);
    }
    else {
      return Promise.resolve();
    }
  }
  /**
   * Sets the active rows. Active rows dictate which pages will be refetched
   * when the tree changes.
   *
   * @param start The starting row index.
   * @param end The ending row index.
   * @returns A promise that resolves when the first page of data has been
   *  loaded.
   */
  async updateActiveRowRange(start, end) {
    this.activeRowRange = this.constrainRowOffsets(start, end);
    this.tryClearLoadingState();
    await this.fetchUnloadedPagesInActiveRows();
  }
  /**
   * Performs a network request that will listen to server-side changes of the
   * scene tree's data.
   */
  subscribe() {
    return this.ifConnectionHasJwt((jwt) => {
      const stream = this.requestServerStream(jwt, (metadata) => {
        const sub = this.client.subscribe(new scene_tree_api_pb.SubscribeRequest(), metadata);
        return sub;
      });
      stream.on('data', (msg) => {
        if (msg.hasHandshake()) {
          this.clearHandshakeTimer();
          this.updateState(Object.assign(Object.assign({}, this.state), { handshakeReceived: true }));
          // Verify that we've loaded the first page of the tree when we receive
          // a handshake in the case that the listener was not fully registered
          // when a `ListChange` was sent.
          if (this.state.firstFetchComplete) {
            this.log('Scene tree first fetch completed before handshake received, invalidating current pages');
            this.invalidateAfterOffset(0);
            this.fetchUnloadedPagesInActiveRows();
          }
        }
        this.startIdleReconnectTimer();
        const { change } = msg.toObject();
        // Update the number of filtered results if changed
        if ((change === null || change === void 0 ? void 0 : change.filterChange) != null) {
          this.updateState(Object.assign(Object.assign({}, this.state), { totalFilteredRows: change.filterChange.numberOfResults }));
        }
        if ((change === null || change === void 0 ? void 0 : change.listChange) != null) {
          this.log('Received list change', change.listChange.start);
          this.invalidateAfterOffset(change.listChange.start);
          this.fetchUnloadedPagesInActiveRows();
        }
        const { hiddenList = [], shownList = [], partiallyVisibleList = [], deselectedList = [], selectedList = [], } = (change === null || change === void 0 ? void 0 : change.ranges) || {};
        if (partiallyVisibleList.length > 0) {
          this.log('Received partial visibility list change', partiallyVisibleList);
          partiallyVisibleList.forEach(({ start, end }) => this.patchNodesInRange(start, end, () => ({
            partiallyVisible: true,
          })));
        }
        if (hiddenList.length > 0) {
          this.log('Received hidden list change', hiddenList);
          hiddenList.forEach(({ start, end }) => this.patchNodesInRange(start, end, () => ({
            visible: false,
            partiallyVisible: false,
          })));
        }
        if (shownList.length > 0) {
          this.log('Received shown list change', shownList);
          shownList.forEach(({ start, end }) => this.patchNodesInRange(start, end, () => ({
            visible: true,
            partiallyVisible: false,
          })));
        }
        if (deselectedList.length > 0) {
          this.log('Received deselected list change', deselectedList);
          deselectedList.forEach(({ start, end }) => this.patchNodesInRange(start, end, () => ({ selected: false })));
        }
        if (selectedList.length > 0) {
          this.log('Received selected list change', selectedList);
          selectedList.forEach(({ start, end }) => this.patchNodesInRange(start, end, () => ({ selected: true })));
        }
      });
      stream.on('status', (s) => {
        if (s.code !== 0) {
          console.error(`Failed to subscribe to scene tree with code=${s.code}, details=${s.details}`);
          this.invalidateAfterOffset(0);
        }
      });
      stream.on('end', () => {
        this.invalidateAfterOffset(0);
        if (this.state.connection.type === 'connected') {
          this.startConnectionLostReconnectTimer();
        }
      });
      return stream;
    });
  }
  async fetchUnloadedPagesInActiveRows() {
    var _a, _b;
    const [startPage, endPage] = this.getPageIndexesForRange(
    // Verify the first page is loaded properly even if the `activeRowRange`
    // has not been specified by the underlying table layout after a reconnect.
    (_a = this.activeRowRange[0]) !== null && _a !== void 0 ? _a : 0, (_b = this.activeRowRange[1]) !== null && _b !== void 0 ? _b : 0);
    const pages = this.getNonLoadedPageIndexes(startPage - 1, endPage + 1);
    await Promise.all(pages.map((page) => this.fetchPage(page)));
  }
  patchNodesInRange(start, end, transform) {
    const updatedRows = this.state.rows
      .slice(start, end + 1)
      .map((row) => isLoadedRow(row)
      ? Object.assign(Object.assign({}, row), { node: Object.assign(Object.assign({}, row.node), transform(row.node)) }) : row);
    const startRows = this.state.rows.slice(0, start);
    const endRows = this.state.rows.slice(end + 1);
    const rows = [...startRows, ...updatedRows, ...endRows];
    this.updateState(Object.assign(Object.assign({}, this.state), { rows }));
  }
  async handlePageResult(page) {
    var _a;
    try {
      const res = await page.res;
      const currentPage = this.getPage(page.index);
      // Only handle the result if the page has not been invalidated.
      if ((currentPage === null || currentPage === void 0 ? void 0 : currentPage.id) === page.id) {
        const cursor = res.getCursor();
        const itemsList = res.getItemsList();
        const totalRows = (_a = cursor === null || cursor === void 0 ? void 0 : cursor.getTotal()) !== null && _a !== void 0 ? _a : 0;
        const offset = page.index * this.rowLimit;
        const fetchedRows = fromNodeProto(offset, itemsList, currentPage.metadataKeys);
        const start = this.state.rows.slice(0, offset);
        const end = this.state.rows.slice(start.length + fetchedRows.length, totalRows);
        const fill = new Array(Math.max(0, totalRows - start.length - fetchedRows.length - end.length));
        const rows = [...start, ...fetchedRows, ...end, ...fill];
        if (this.isViewLoading(rows) && this.loadingTimer == null) {
          this.restartLoadingTimer();
          this.updateState(Object.assign(Object.assign({}, this.state), { totalRows: totalRows, rows: rows, shouldShowEmptyResults: this.state.filterTerm != null &&
              (rows.length === 0 || this.state.totalFilteredRows === 0) }));
        }
        else {
          this.updateState(Object.assign(Object.assign({}, this.state), { totalRows: totalRows, rows: rows, shouldShowLoading: rows.length === 0 && this.state.shouldShowLoading, shouldShowEmptyResults: this.state.filterTerm != null &&
              (rows.length === 0 || this.state.totalFilteredRows === 0), firstFetchComplete: true }));
        }
      }
    }
    catch (e) {
      const errorMessage = e instanceof Error ? e.toString() : 'Unknown';
      console.error(`Request error fetching page at index ${page.index} (${errorMessage})`);
      const currentPage = this.getPage(page.index);
      if ((currentPage === null || currentPage === void 0 ? void 0 : currentPage.id) === page.id) {
        this.invalidatePage(page.index);
      }
    }
  }
  invalidatePage(index) {
    if (this.isPageLoaded(index)) {
      this.pages.delete(index);
    }
  }
  invalidateAfterOffset(offset) {
    const pageIndex = Math.floor(offset / this.rowLimit);
    for (const index of this.pages.keys()) {
      if (index >= pageIndex) {
        this.invalidatePage(index);
      }
    }
  }
  getState() {
    return this.state;
  }
  isViewLoading(rows) {
    return (this.state.filterTerm == null &&
      rows[this.activeRowRange[0]] == null &&
      rows[this.activeRowRange[1]] == null);
  }
  restartLoadingTimer() {
    if (this.loadingTimer != null) {
      this.clearLoadingTimer();
    }
    this.loadingTimer = window.setTimeout(() => {
      this.loadingTimer = undefined;
      this.updateState(Object.assign(Object.assign({}, this.getState()), { shouldShowLoading: true }));
    }, this.connectOptions.spinnerDelay);
  }
  clearLoadingTimer() {
    if (this.loadingTimer != null) {
      clearTimeout(this.loadingTimer);
      this.loadingTimer = undefined;
    }
  }
  tryClearLoadingState() {
    const didClearLoadingTimer = this.tryClearLoadingTimer(this.state);
    if (didClearLoadingTimer) {
      this.updateState(Object.assign(Object.assign({}, this.state), { shouldShowLoading: false }));
    }
  }
  tryClearLoadingTimer(state) {
    const loadingShowingOrTimerStarted = this.state.shouldShowLoading || this.loadingTimer != null;
    const updateLoadingTimer = loadingShowingOrTimerStarted && !this.isViewLoading(state.rows);
    if (updateLoadingTimer) {
      this.clearLoadingTimer();
      return true;
    }
    return false;
  }
  updateState(newState) {
    const didClearLoadingTimer = this.tryClearLoadingTimer(newState);
    this.state = Object.assign(Object.assign({}, newState), { shouldShowLoading: didClearLoadingTimer
        ? false
        : newState.shouldShowLoading });
    this.onStateChange.emit(this.state);
  }
  getPageForOffset(offset) {
    const index = Math.floor(offset / this.rowLimit);
    return this.constrainPageIndex(index);
  }
  getPageIndexesForRange(start, end) {
    const pageStart = this.getPageForOffset(start);
    const pageEnd = this.getPageForOffset(end);
    return [pageStart, pageEnd];
  }
  async fetchTree(offset, limit, jwt) {
    return this.requestUnary(jwt, (metadata, handler) => {
      const pager = new paging_pb.OffsetPager();
      pager.setOffset(offset);
      pager.setLimit(limit);
      const req = new scene_tree_api_pb.GetTreeRequest();
      req.setPager(pager);
      req.setAdditionalColumnKeysList(this.metadataKeys);
      this.client.getTree(req, metadata, handler);
    });
  }
  // TODO(dan): used shared grpc lib
  requestUnary(jwt, req) {
    return new Promise((resolve, reject) => {
      const metadata = this.createJwtMetadata(jwt);
      req(metadata, (err, res) => {
        if (err != null) {
          reject(err);
        }
        else if (res != null) {
          resolve(res);
        }
        else {
          reject(new SceneTreeError('Invalid response. Both error and result are null'));
        }
      });
    });
  }
  // TODO(dan): move to shared grpc lib
  requestServerStream(jwt, req) {
    const metadata = this.createJwtMetadata(jwt);
    return req(metadata);
  }
  createJwtMetadata(jwt) {
    return new grpcWebClient_umd.grpc.Metadata({
      'jwt-context': JSON.stringify({ jwt }),
    });
  }
  async ifConnectionHasJwt(then) {
    const { connection } = this.state;
    if (connection.type === 'connecting' || connection.type === 'connected') {
      const jwt = await connection.jwtProvider();
      if (jwt != null) {
        return then(jwt);
      }
      else {
        throw new SceneTreeUnauthorizedError('SceneTreeController cannot perform request. Viewer JWT is undefined.');
      }
    }
    else if (connection.type === 'cancelled') {
      throw new SceneTreeConnectionCancelledError(`Request attempted, but controller was cancelled`);
    }
    else {
      throw new SceneTreeError('SceneTreeController is not in connected state');
    }
  }
  ifErrorIsFatal(error, then) {
    if (!(error instanceof SceneTreeConnectionCancelledError)) {
      then();
    }
  }
  getConnectionError(e) {
    if (isGrpcServiceError(e)) {
      if (e.code === grpcWebClient_umd.grpc.Code.FailedPrecondition) {
        return new SceneTreeErrorDetails('SCENE_TREE_DISABLED', SceneTreeErrorCode.SCENE_TREE_DISABLED);
      }
      else if (e.code === grpcWebClient_umd.grpc.Code.Unauthenticated) {
        return new SceneTreeErrorDetails('UNAUTHORIZED', SceneTreeErrorCode.UNAUTHORIZED);
      }
      else if (e.code === grpcWebClient_umd.grpc.Code.Aborted) {
        return new SceneTreeErrorDetails('ABORTED', SceneTreeErrorCode.ABORTED);
      }
      else {
        return new SceneTreeErrorDetails('UNKNOWN', SceneTreeErrorCode.UNKNOWN);
      }
    }
    else if (e instanceof SceneTreeUnauthorizedError) {
      return new SceneTreeErrorDetails('UNAUTHORIZED', SceneTreeErrorCode.UNAUTHORIZED);
    }
    else {
      return new SceneTreeErrorDetails('UNKNOWN', SceneTreeErrorCode.UNKNOWN);
    }
  }
  constrainPageRange(start, end) {
    return [Math.max(0, start), Math.min(this.maxPages - 1, end)];
  }
  constrainPageIndex(index) {
    return Math.max(0, Math.min(index, this.maxPages - 1));
  }
  constrainRowOffsets(start, end) {
    return [Math.max(0, start), Math.min(this.state.totalRows - 1, end)];
  }
  get maxPages() {
    return Math.max(1, Math.ceil(this.state.totalRows / this.rowLimit));
  }
  log(message, ...optionalParams) {
    if (this.debugLogs) {
      console.debug(message, optionalParams);
    }
  }
  isConnectedState(connection) {
    return connection.type === 'connected';
  }
}
SceneTreeController.IDLE_RECONNECT_IN_SECONDS = 4 * 60;
SceneTreeController.LOST_CONNECTION_RECONNECT_IN_SECONDS = 2;
SceneTreeController.MAX_SUBSCRIPTION_RETRY_COUNT = 2;

export { SceneTreeController as S, SceneTreeAPIClient_1 as a, SceneTreeErrorDetails as b, SceneTreeErrorCode as c, webSocketSubscriptionTransportFactory as w };

//# sourceMappingURL=controller.js.map